PROGRAM compact_ellipticals
! declaration of variables
IMPLICIT NONE
! basic constants
double precision :: PI,light,H0,q0,veryhugenumber,divisor,binhelp,dummy_var,G
! loop and counting integers as well as some init parameters
integer :: io_err,n,i,ii,iii,galactive,hcount,n_g,n_r,n_i,n_z,special_index,n_sersic,n_dr7,n_mendel,n_act
integer :: usenewdata,uuu,ee,maxloop,n_taylor,n_threesigma,u_taylor,u_internal,u_sersic,u_trujillo
integer :: n_trujillo,d,n_allearly,n_3sigma,i_d,i_tr,i_ta
! arrays for SDSS raw data
double precision, allocatable :: objid(:)
double precision, allocatable :: gb(:),gl(:),RA(:),dec(:)
double precision, allocatable :: z(:),veldisp(:),z_cluster(:)
double precision, allocatable :: ba_g(:),ba_r(:),ba_i(:),ba_z(:)
double precision, allocatable :: deVRad_g(:),deVRad_r(:),deVRad_i(:),deVRad_z(:)
double precision, allocatable :: deVMag_g(:),deVMag_r(:),deVMag_i(:),deVMag_z(:)
double precision, allocatable :: extinction_g(:),extinction_r(:),extinction_i(:),extinction_z(:)
double precision, allocatable :: objid_mendel(:),logmstars_mendel(:),logmstarc_mendel(:)
double precision, allocatable :: logmstars_sersic(:),logmstarc_sersic(:)
! arrays for derived parameters
double precision, allocatable :: Mag_g(:),Mag_r(:),Mag_i(:),Mag_z(:)
double precision, allocatable :: distance(:),z_cor(:),logdistlum(:),d_com(:)
double precision, allocatable :: K_g(:),K_r(:),K_i(:),K_z(:)
double precision, allocatable :: r_cor_g(:),r_cor_r(:),r_cor_i(:),r_cor_z(:)
double precision, allocatable :: sigma_cor_g(:),sigma_cor_r(:),sigma_cor_i(:),sigma_cor_z(:)
double precision, allocatable :: logI0_g(:),logI0_r(:),logI0_i(:),logI0_z(:)
double precision, allocatable :: I0_g(:),I0_r(:),I0_i(:),I0_z(:)
double precision, allocatable :: alpha_g(:),alpha_r(:),alpha_i(:),alpha_z(:)
double precision, allocatable :: R0_g(:),R0_r(:),R0_i(:),R0_z(:)
double precision, allocatable :: logR0_g(:),logR0_r(:),logR0_i(:),logR0_z(:)
double precision, allocatable :: logsigma_g(:),logsigma_r(:),logsigma_i(:),logsigma_z(:)
double precision, allocatable :: err_u(:),err_g(:),err_r(:),err_i(:),err_z(:)
double precision, allocatable :: Mag_app_g(:),Mag_app_r(:),Mag_app_i(:),Mag_app_z(:)
double precision, allocatable :: magabs_g(:),magabs_r(:),magabs_i(:),magabs_z(:)
double precision, allocatable :: d_g(:),d_r(:),d_i(:),d_z(:)
double precision, allocatable :: ratioL_g(:),ratioL_r(:),ratioL_i(:),ratioL_z(:)
double precision, allocatable :: dist_fp_g(:),dist_fp_r(:),dist_fp_i(:),dist_fp_z(:)
double precision, allocatable :: otherside_g(:),otherside_r(:),otherside_i(:),otherside_z(:)
double precision, allocatable :: SDSS_DR7_id(:),z_sersic(:),spec_index(:),scale_sersic(:),mag_g_sersic(:),mag_r_sersic(:)
double precision, allocatable :: mag_g_err_sersic(:),mag_r_err_sersic(:),sersic_err_index(:)
double precision, allocatable :: new_mag_g_err_sersic(:),new_mag_r_err_sersic(:),new_sersic_err_index(:)
double precision, allocatable :: r_g_sersic(:),r_r_sersic(:),ellipticity_sersic(:),sersic_index(:)
double precision, allocatable :: SDSS_ID_junk(:),RA_DR7(:),dec_DR7(:),z_DR7(:)
double precision, allocatable :: RA_sersic(:),dec_sersic(:)
double precision, allocatable :: new_scale_sersic(:),new_mag_g_sersic(:),new_mag_r_sersic(:)
double precision, allocatable :: new_r_g_sersic(:),new_r_r_sersic(:),new_ellipticity_sersic(:),new_sersic_index(:)
double precision, allocatable :: new_logmstars(:),new_logmstarc(:)
double precision, allocatable :: err_sigma_cor_g(:),err_sigma_cor_r(:),err_sigma_cor_i(:),err_sigma_cor_z(:)
double precision, allocatable :: err_sigma_g_sersic(:),err_sigma_r_sersic(:)
double precision, allocatable :: magapp_g_err(:),sbm_err_g(:),magapp_r_err(:),sbm_err_r(:),magapp_i_err(:),sbm_err_i(:)
double precision, allocatable :: magapp_z_err(:),sbm_err_z(:),magapp_sersic_g_err(:),sb_err_g_sersic(:)
double precision, allocatable :: magapp_sersic_r_err(:),sb_err_r_sersic(:),disterr(:)
double precision, allocatable :: R_Err_g(:),R_Err_r(:),R_Err_i(:),R_Err_z(:),R_Err_g_sersic(:),R_Err_r_sersic(:)
double precision, allocatable :: M_dyn_g_err(:),M_dyn_r_err(:),M_dyn_i_err(:),M_dyn_z_err(:)
double precision, allocatable :: M_dyn_g_sersic_err(:),M_dyn_r_sersic_err(:)
double precision, allocatable :: magabs_g_err(:),magabs_r_err(:),magabs_i_err(:),magabs_z_err(:)
double precision, allocatable :: magabs_sersic_g_err(:),magabs_sersic_r_err(:)
double precision, allocatable ::  deVRadErr_g(:),deVRadErr_r(:),deVRadErr_i(:),deVRadErr_z(:)
double precision, allocatable ::  deVMagErr_g(:),deVMagErr_r(:),deVMagErr_i(:),deVMagErr_z(:)
double precision, allocatable ::  zErr(:),veldisperr(:)
double precision, allocatable ::  rad_r_allearly(:)
logical, allocatable :: sersic_active(:),unmatched(:),unmatched2(:)
! booleans for selection
logical, allocatable :: active(:),act(:),act_dV(:),act_S(:),act_fp(:),act_vdbosch15(:),act_vdbosch15_basic(:)
logical, allocatable :: act_taylor(:),act_crossmatchtaylor(:),act_trujillo(:),act_crossmatchtrujillo(:),act_old(:)
integer, allocatable :: taylor_id_sample(:),trujillo_id_sample(:),trujillo_id(:)
! other stuff and variables for the error analysis
double precision :: r_fiber,z_gal_x,z_gal_y,z_gal_z
double precision :: v_cmb,l_cmb,b_cmb,z_cmb,gal_b,gal_l
double precision :: z_cmb_x,z_cmb_y,z_cmb_z
double precision :: maxmag_g,minmag_g,maxmag_r,minmag_r,maxmag_i,minmag_i,maxmag_z,minmag_z
double precision :: mag_evolution_g,mag_evolution_r,mag_evolution_i,mag_evolution_z
double precision :: omega_m,omega_lambda
double precision :: helpflip,comp_d_g,comp_d_r,comp_d_i,comp_d_z
double precision :: R0_bar_g,R0_bar_r,R0_bar_i,R0_bar_z,R_lasker,Mdyn_lasker,sigma_lasker,nser_lasker
double precision :: R0_sigma_g,R0_sigma_r,R0_sigma_i,R0_sigma_z
double precision :: sigma_bar_g,sigma_bar_r,sigma_bar_i,sigma_bar_z
double precision :: sigma_sigma_g,sigma_sigma_r,sigma_sigma_i,sigma_sigma_z
integer :: n1percent,hcount_g,hcount_r,hcount_i,hcount_z
integer :: hhcount_g,hhcount_r,hhcount_i,hhcount_z
double precision :: a_g,b_g,c_g,a_r,b_r,c_r,a_i,b_i,c_i,a_z,b_z,c_z
double precision :: rms_g,rms_r,rms_i,rms_z,dist_fp
double precision :: av_dist_fp_g,av_dist_fp_r,av_dist_fp_i,av_dist_fp_z
double precision :: cc1,cc2,cc3,cmd_rms,av_cirularisation
double precision :: help_sum2_g,help_sum2_r,help_sum2_i,help_sum2_z
double precision :: logR_2_g,logR_2_r,logR_2_i,logR_2_z
double precision :: devfitk_g,devfitk_r,devfitk_i,devfitk_z
double precision :: devfitd_g,devfitd_r,devfitd_i,devfitd_z,log_delta_R0_rz,log_delta_R0_ri
double precision :: devrms_g,devrms_r,devrms_i,devrms_z,delta_R0_rz,delta_R0_ri,av_RO_r,av_logR0_r
double precision, dimension(0:500,0:500) :: mapmap
double precision :: help_x2,help_y2
integer :: help_x,help_y
double precision :: min_sigma_dev,min_R0_dev,min_corr_dev,arcsec,angular_sep
  character(100) :: read_string,useless_string
  character(19) :: SDSS_id_string,SDSS_id_string1,SDSS_id_string2,SDSS_id_string3
  character(12) :: hs1,hs2,hs3,hs4,hs5,hs6,hs7,hs8,hs9,hs10,hs11,hs12,hs13,hs15,hs16,hs17,hs18,hs19,hs20
  character(12) :: hs21,hs22,hs23,hs24,hs25,hs14,hs26,hs27,hs28,hs29,hs30
INTEGER(KIND=8), allocatable :: SDSS_DR7_id_s_int(:),SDSS_DR7_id_c_int(:),SDSS_DR7_id_m_int(:)
double precision, allocatable :: m_g_sersic(:),m_r_sersic(:),K_g_sersic(:),K_r_sersic(:)
double precision, allocatable :: rac_g_sersic(:),rac_r_sersic(:),sigma_g_sersic(:),sigma_r_sersic(:)
double precision, allocatable :: Mag_app_g_sersic(:),logI0_g_sersic(:),I0_g_sersic(:)
double precision, allocatable :: Mag_app_r_sersic(:),logI0_r_sersic(:),I0_r_sersic(:)
double precision, allocatable :: vweight_g(:),vweight_r(:),vweight_i(:),vweight_z(:)
double precision, allocatable :: vweight_g_sersic(:),vweight_r_sersic(:)
double precision, allocatable :: lum_g(:),lum_r(:)
double precision, allocatable :: lum_g_sersic(:),lum_r_sersic(:)
double precision, allocatable :: ml_ratio_g(:),ml_ratio_r(:)
double precision, allocatable :: ml_ratio_g_sersic(:),ml_ratio_r_sersic(:)
double precision, allocatable :: alpha_g_sersic(:),alpha_r_sersic(:),R0_g_sersic(:),R0_r_sersic(:)
double precision, allocatable :: logR0_g_sersic(:),logR0_r_sersic(:),logsigma_g_sersic(:),logsigma_r_sersic(:)
double precision, allocatable :: magabs_g_sersic(:),magabs_r_sersic(:)
double precision, allocatable :: M_dyn_g(:),M_dyn_r(:),M_dyn_i(:),M_dyn_z(:),M_dyn_g_sersic(:),M_dyn_r_sersic(:)
double precision, allocatable :: log_M_dyn_g(:),log_M_dyn_r(:),log_M_dyn_i(:),log_M_dyn_z(:)
double precision, allocatable :: log_M_dyn_g_sersic(:),log_M_dyn_r_sersic(:)
double precision, allocatable :: log_lum_g(:),log_lum_r(:)
double precision, allocatable :: log_lum_g_sersic(:),log_lum_r_sersic(:)
double precision, allocatable :: M_star(:),log_M_star(:),ml_ratio_star(:)
double precision, allocatable :: M_star_sersic(:),log_M_star_sersic(:),ml_ratio_star_sersic(:)
double precision, allocatable :: lnLDeV_g(:),lnLDeV_r(:),lnLDeV_i(:),lnLDeV_z(:)
double precision, allocatable :: lnLExp_g(:),lnLExp_r(:),lnLExp_i(:),lnLExp_z(:)
double precision, allocatable :: Zoo_el(:)
INTEGER(KIND=8), allocatable :: Zoo_nvote(:)

double precision, allocatable :: lum_g_err(:),lum_r_err(:)
double precision, allocatable :: lum_g_sersic_err(:),lum_r_sersic_err(:)
double precision, allocatable :: ml_ratio_g_err(:),ml_ratio_r_err(:)
double precision, allocatable :: ml_ratio_g_sersic_err(:),ml_ratio_r_sersic_err(:)
double precision, allocatable :: log_M_dyn_g_errp(:),log_M_dyn_r_errp(:),log_M_dyn_i_errp(:),log_M_dyn_z_errp(:)
double precision, allocatable :: log_M_dyn_g_sersic_errp(:),log_M_dyn_r_sersic_errp(:)
double precision, allocatable :: log_M_dyn_g_errm(:),log_M_dyn_r_errm(:),log_M_dyn_i_errm(:),log_M_dyn_z_errm(:)
double precision, allocatable :: log_M_dyn_g_sersic_errm(:),log_M_dyn_r_sersic_errm(:)
double precision, allocatable :: log_lum_g_err(:),log_lum_r_err(:)
double precision, allocatable :: log_lum_g_sersic_err(:),log_lum_r_sersic_err(:)
double precision, allocatable :: M_star_err(:),log_M_star_err(:),ml_ratio_star_err(:)
double precision, allocatable :: M_star_sersic_err(:),log_M_star_sersic_err(:),ml_ratio_star_sersic_err(:)

!K correction coefficients
double precision, dimension(0:5,0:3) :: K_coeff_r,K_coeff_i,K_coeff_z
double precision, dimension(0:7,0:3) :: K_coeff_g
! bin data
integer, dimension(0:100) :: logR0_bin_g,logR0_bin_r,logR0_bin_i,logR0_bin_z
integer, dimension(0:70) :: logsigma_bin_g,logsigma_bin_r,logsigma_bin_i,logsigma_bin_z
double precision , dimension(0:20) :: magabs_bin_g,magabs_bin_r,magabs_bin_i,magabs_bin_z
double precision , dimension(0:20) :: cmagabs_bin_g,cmagabs_bin_r,cmagabs_bin_i,cmagabs_bin_z
double precision , dimension(0:40) :: sersic_index_bin_cand,sersic_index_bin
double precision , dimension(0:40) :: dV_sersic_index_bin,S_sersic_index_bin
double precision , dimension(0:20) :: ml_basic_bin,ml_cand_bin,ml_taylor_bin,ml_sersic_bins,ml_trujillo_bin
double precision , dimension(0:10) :: ba_ratio_dV,ba_ratio_all,ba_ratio_T,ba_ratio_Trujillo
logical  :: foundmatch,continueloop

double precision :: t1,t2,t3,D_limit,z_limit,V_limit,V_sum_g,V_sum_r,V_sum_i,V_sum_z,zmax,zmin
double precision :: mag_sol_g,mag_sol_r,mag_sol_i,mag_sol_z,K01_g,K01_r,K01_i,K01_z
double precision :: dist_d_g,dist_d_r,dist_d_i,dist_d_z,dist_k_g,dist_k_r,dist_k_i,dist_k_z
double precision :: av_ml,sigma_ml,av_ml_biascor,sigma_ml_biascor,h_sum,h_sum_biascor,beta,Vmin


! variables for least square fitting
double precision, dimension(1:3,1:3) :: Amatrix_g,Bmatrix1_g,Amatrix_r,Bmatrix1_r
double precision, dimension(1:3,1:3) :: Bmatrix2_g,Bmatrix3_g,Bmatrix2_r,Bmatrix3_r
double precision, dimension(1:3) :: Yvector_g,Yvector_r
double precision :: detA_g,detA_r,detB1_g,detB1_r,detB2_g,detB2_r,detB3_g,detB3_r
double precision :: sa_g,sb_g,sc_g,sa_r,sb_r,sc_r,srms_g,srms_r
double precision :: sdelta_a_g,sdelta_b_g,sdelta_c_g,sdelta_a_r,sdelta_b_r,sdelta_c_r
double precision :: sa_err_g,sb_err_g,sc_err_g,sa_err_r,sb_err_r,sc_err_r
double precision, allocatable :: sdeviation_g(:),sdeviation_r(:),sotherside_g(:),sotherside_r(:)

double precision :: sdist_k_g,sdist_k_r
double precision :: sdist_d_g,sdist_d_r
double precision :: Vol1,Vol2,solve_t1,solve_t2
double precision :: weight_sum2_g,weight_sum2_r
double precision, allocatable :: helplist_g(:),helplist_r(:),sfp_dist_g(:),sfp_dist_r(:)

double precision :: R0_bar_r_sersic,R0_sigma_r_sersic,av_t_ml_dyns,av_t_ml_stars,sigma_ml_dyn,sigma_ml_star  
double precision :: sigma_bar_r_sersic,sigma_sigma_r_sersic,av_t_ml_dyndv,av_t_ml_stardv
double precision :: devfitk_r_sersic,comp_d_r_sersic,devfitd_r_sersic
double precision :: R0_bar_g_sersic,R0_sigma_g_sersic
double precision :: sigma_bar_g_sersic,sigma_sigma_g_sersic
double precision :: devfitk_g_sersic,comp_d_g_sersic,devfitd_g_sersic
double precision :: devrms_g_sersic,devrms_r_sersic,logr_2_g_sersic,logr_2_r_sersic
double precision :: min_sersic,min_sigma,sfp_dist_err_g,sfp_dist_err_r,solve_t3

double precision, allocatable :: taylor_ra(:),taylor_dec(:),trujillo_ra(:),trujillo_dec(:)
double precision :: Dmin,Vminsat,dist_dsat_g,dist_dsat_r,dist_dsat_i,dist_dsat_z,sdist_dsat_g,sdist_dsat_r

integer :: n_taylor2010,n_trujillo2009,n_vdokkum2008,ttmdyn_on,n_spect,n_vdbosch2012,n_zahid2015
integer :: n_belli2014,n_vdsande2013,n_hetngs
double precision, allocatable :: mstar_taylor2010(:),reff_taylor2010(:),mstar_trujillo2009(:)
double precision, allocatable :: reff_trujillo2009(:),mstar_vdokkum2008(:),reff_vdokkum2008(:)
double precision, allocatable :: mstar_damjanov2009(:),reff_damjanov2009(:)
double precision, allocatable :: z_damjanov2009(:),z_vdokkum2008(:),z_trujillo2009(:),z_taylor2010(:)
double precision, allocatable :: z_vdbosch2012(:)
logical :: notlast_round
INTEGER(KIND=8), allocatable :: spect_objid(:)
double precision, allocatable :: spect_z(:),spect_veldisp(:),spect_zErr(:),spect_veldisperr(:),spect_RA(:),spect_dec(:)
double precision, allocatable :: taylor_veldisp(:),taylor_Mdyn(:),trujillo_veldisp(:),trujillo_Mdyn(:)
double precision, allocatable :: vdisp_taylor2010(:),nsersic_taylor2010(:)
double precision, allocatable :: mstar_vdbosch2012(:),reff_vdbosch2012(:),veldisp_vdbosch2012(:),ell_vdbosch2012(:)
double precision, allocatable :: mdyn_vdbosch2012(:),rcor_vdbosch2012(:)
double precision, allocatable :: reff_zahid2015(:),sigma_zahid2015(:),z_zahid2015(:)
double precision, allocatable :: mstar_zahid2015(:),mdyn_zahid2015(:)
double precision, allocatable :: z_sande13(:),Re_sande13(:),sigma_sande13(:),ns_sande13(:),ba_sande13(:)
double precision, allocatable :: logmdyn_sande13(:),logmstar_sande13(:)
double precision, allocatable :: z_belli14(:),Re_belli14(:),sigma_belli14(:),ns_belli14(:),ba_belli14(:)
double precision, allocatable :: logmdyn_belli14(:),logmstar_belli14(:)
double precision, allocatable :: hetngs_ra(:),hetngs_dec(:)

double precision :: spacedensity,sdss_cover,av_mm_cand,av_mm_basic,av_mm_high_int,mmsigma_min,mmsigma_max
double precision :: ang_min,dang_max,zang_max,density_trujillo,density_taylor,density_damjanov
double precision, allocatable :: visvolume(:)

double precision, dimension(1:6) :: candels_z,candels_m1075,candels_m1125



OPEN(30,file='output/protocol.txt')

! define constants
PI=ACOS(-1.D0) !pi
light=299792.458D0 !speed of light
G=4.302D-3 !in pc/Msol * (km/s)**2
G=G/1000.D0 !in kpc/Msol * (km/s)**2
veryhugenumber=huge(0.D0)
zmax=0.4D0
zmin=0.005D0
maxloop=10

mmsigma_min=323.2D0
mmsigma_max=400.D0

WRITE(*,*) '-----program started-----'
WRITE(30,*) '-----program started-----'
CALL SYSTEM_CLOCK(hcount)
hcount=hcount-INT(hcount/100000)*100000
call srand(hcount) 





! read input file
OPEN(53,file='input/input.txt')
READ(53,*) 
READ(53,*) H0,omega_m,omega_lambda
READ(53,*)
READ(53,*)
READ(53,*) maxmag_g,minmag_g
READ(53,*)
READ(53,*) maxmag_r,minmag_r
READ(53,*)
READ(53,*) maxmag_i,minmag_i
READ(53,*)
READ(53,*) maxmag_z,minmag_z
READ(53,*)
READ(53,*) mag_evolution_g,mag_evolution_r,mag_evolution_i,mag_evolution_z
READ(53,*)
READ(53,*) min_sigma_dev
READ(53,*)
READ(53,*) min_R0_dev
READ(53,*)
READ(53,*) min_corr_dev
READ(53,*) 
READ(53,*) usenewdata
READ(53,*) 
READ(53,*) ttmdyn_on

 CLOSE(53)

q0=omega_m/2.D0-omega_lambda !decaleration parameter 

z_limit=zmin
divisor=(SQRT(1.D0+2.D0*q0*z_limit)+1.D0+q0*z_limit)
D_limit=light/H0*z_limit*(1.D0+((z_limit*(1.D0-q0))/divisor))
D_limit=D_limit*((1.D0+z_limit)**(-1.D0))!comoving diameter distance
Vmin=D_limit**3


! get length of file
OPEN(50,file='input/trujillo2009.txt')
io_err=0
n_trujillo=0
DO WHILE (io_err==0) 
READ(50,*,iostat=io_err) 
n_trujillo=n_trujillo+1
END DO
 CLOSE(50)
n_trujillo=n_trujillo-2 !header


n_allearly=0
OPEN(50,file='input/radii_early.txt')
io_err=0
n_allearly=0
DO WHILE (io_err==0) 
READ(50,*,iostat=io_err) 
n_allearly=n_allearly+1
END DO
 CLOSE(50)
n_allearly=n_allearly-2 !header


OPEN(50,file='input/candels_fit.txt')
READ(50,*) 
DO i=1,6
READ(50,*) candels_z(i),candels_m1075(i),candels_m1125(i)
END DO
 CLOSE(50)


! get length of file
OPEN(50,file='input/taylor2010.txt')
io_err=0
n_taylor=0
DO WHILE (io_err==0) 
READ(50,*,iostat=io_err) 
n_taylor=n_taylor+1
END DO
 CLOSE(50)
n_taylor=n_taylor-2 !header


arcsec=1.D0/3600.D0



IF (usenewdata==1) THEN

! get length of file
OPEN(50,file='input/ell.txt')
io_err=0
n=0
DO WHILE (io_err==0) 
READ(50,*,iostat=io_err) 
n=n+1
END DO
 CLOSE(50)
n=n-2 !header

! get length of file
OPEN(50,file='input/sersic_catalogue.txt')
io_err=0
n_sersic=0
DO WHILE (io_err==0) 
READ(50,*,iostat=io_err) 
n_sersic=n_sersic+1
END DO
 CLOSE(50)
n_sersic=n_sersic-45 !header


! get length of file
OPEN(50,file='input/SDSS_DR7.txt')
io_err=0
n_dr7=0
DO WHILE (io_err==0) 
READ(50,*,iostat=io_err) 
n_dr7=n_dr7+1
END DO
 CLOSE(50)
n_dr7=n_dr7-2 !header


! get length of file
OPEN(50,file='input/mendel_stellarmasses.txt')
io_err=0
n_mendel=0
DO WHILE (io_err==0) 
READ(50,*,iostat=io_err) 
n_mendel=n_mendel+1
END DO
 CLOSE(50)
n_mendel=n_mendel-3 !header



! allocate arrays
allocate(objid(1:n))
allocate(gb(1:n))
allocate(gl(1:n))
allocate(RA(1:n))
allocate(dec(1:n))
allocate(z(1:n))
allocate(veldisp(1:n))
allocate(ba_g(1:n))
allocate(ba_r(1:n))
allocate(ba_i(1:n))
allocate(ba_z(1:n))
allocate(deVRad_g(1:n))
allocate(deVRad_r(1:n))
allocate(deVRad_i(1:n))
allocate(deVRad_z(1:n))
allocate(deVMag_g(1:n))
allocate(deVMag_r(1:n))
allocate(deVMag_i(1:n))
allocate(deVMag_z(1:n))
allocate(extinction_g(1:n))
allocate(extinction_r(1:n))
allocate(extinction_i(1:n))
allocate(extinction_z(1:n))
allocate(zErr(1:n))
allocate(veldisperr(1:n))
allocate(deVRadErr_g(1:n))
allocate(deVRadErr_r(1:n))
allocate(deVRadErr_i(1:n))
allocate(deVRadErr_z(1:n))
allocate(deVMagErr_g(1:n))
allocate(deVMagErr_r(1:n))
allocate(deVMagErr_i(1:n))
allocate(deVMagErr_z(1:n))
allocate(lnLDeV_g(1:n))
allocate(lnLDeV_r(1:n))
allocate(lnLDeV_i(1:n))
allocate(lnLDeV_z(1:n))
allocate(lnLExp_g(1:n))
allocate(lnLExp_r(1:n))
allocate(lnLExp_i(1:n))
allocate(lnLExp_z(1:n))
allocate(Zoo_el(1:n))
allocate(Zoo_nvote(1:n))


allocate(new_scale_sersic(1:n))
allocate(new_mag_g_sersic(1:n))
allocate(new_mag_r_sersic(1:n))
allocate(new_r_g_sersic(1:n))
allocate(new_r_r_sersic(1:n))
allocate(new_ellipticity_sersic(1:n))
allocate(new_sersic_index(1:n))
allocate(new_logmstars(1:n))
allocate(new_logmstarc(1:n))
allocate(new_mag_g_err_sersic(1:n_sersic))
allocate(new_mag_r_err_sersic(1:n_sersic))
allocate(new_sersic_err_index(1:n_sersic))

allocate(SDSS_DR7_id(1:n_sersic))
allocate(z_sersic(1:n_sersic))
allocate(spec_index(1:n_sersic))
allocate(scale_sersic(1:n_sersic))
allocate(mag_g_sersic(1:n_sersic))
allocate(mag_r_sersic(1:n_sersic))
allocate(r_g_sersic(1:n_sersic))
allocate(r_r_sersic(1:n_sersic))
allocate(ellipticity_sersic(1:n_sersic))
allocate(sersic_index(1:n_sersic))
allocate(sersic_active(1:n_sersic))
allocate(SDSS_DR7_id_s_int(1:n_sersic))
allocate(mag_g_err_sersic(1:n_sersic))
allocate(mag_r_err_sersic(1:n_sersic))
allocate(sersic_err_index(1:n_sersic))

allocate(active(1:n))


allocate(SDSS_ID_junk(1:n_dr7))
allocate(RA_DR7(1:n_dr7))
allocate(dec_DR7(1:n_dr7))
allocate(z_DR7(1:n_dr7))
allocate(SDSS_DR7_id_c_int(1:n_dr7))
allocate(unmatched(1:n_dr7))

allocate(RA_sersic(1:n_sersic))
allocate(dec_sersic(1:n_sersic))
allocate(unmatched2(1:n_sersic))

allocate(SDSS_DR7_id_m_int(1:n_mendel))
allocate(objid_mendel(1:n_mendel))
allocate(logmstars_mendel(1:n_mendel))
allocate(logmstarc_mendel(1:n_mendel))

allocate(logmstars_sersic(1:n_sersic))
allocate(logmstarc_sersic(1:n_sersic))


! read file
OPEN(50,file='input/ell.txt')
READ(50,*) 
DO i=1,n 
READ(50,*) objid(i),gb(i),gl(i),RA(i),dec(i),&
z(i),veldisp(i),zErr(i),veldisperr(i),&
deVRad_g(i),deVRad_r(i),deVRad_i(i),deVRad_z(i),&
deVRadErr_g(i),deVRadErr_r(i),deVRadErr_i(i),deVRadErr_z(i),&
deVMag_g(i),deVMag_r(i),deVMag_i(i),deVMag_z(i),&
deVMagErr_g(i),deVMagErr_r(i),deVMagErr_i(i),deVMagErr_z(i),&
ba_g(i),ba_r(i),ba_i(i),ba_z(i),&
extinction_g(i),extinction_r(i),extinction_i(i),extinction_z(i),&
lnLDeV_g(i),lnLDeV_r(i),lnLDeV_i(i),lnLDeV_z(i),&
lnLExp_g(i),lnLExp_r(i),lnLExp_i(i),lnLExp_z(i),&
Zoo_el(i),Zoo_nvote(i)
END DO
 CLOSE(50)



WRITE(*,*) 'read in data for ',n,' elliptical galaxies from SDSS DR10'
WRITE(30,*) 'read in data for ',n,' elliptical galaxies from SDSS DR10'




! get length of file
OPEN(50,file='input/SDSS_DR7.txt')
READ(50,*) 
DO i=1,n_dr7 
READ(50,*) SDSS_ID_junk(i),RA_DR7(i),dec_DR7(i),z_DR7(i)
END DO
 CLOSE(50)



OPEN(50,file='input/SDSS_DR7.txt')
READ(50,*) 
DO i=1,n_dr7 
READ(50,*) read_string,useless_string,useless_string,useless_string
SDSS_id_string=TRIM(adjustl(read_string))
READ(SDSS_id_string,*) SDSS_DR7_id_c_int(i)
! WRITE(*,*) read_string,SDSS_DR7_id_c_int(i)
END DO

 CLOSE(50)

DO i=1,n_dr7 
unmatched(i)=.TRUE.
END DO

WRITE(*,*) 'read in data for ',n_dr7,' galaxies from SDSS DR7'
WRITE(30,*) 'read in data for ',n_dr7,' galaxies from SDSS DR7'



! read file
OPEN(50,file='input/sersic_catalogue.txt')
DO i=1,43 
READ(50,*) 
END DO
DO i=1,n_sersic 
READ(50,*) dummy_var,SDSS_DR7_id(i),z_sersic(i),spec_index(i),scale_sersic(i),dummy_var,mag_g_sersic(i),mag_g_err_sersic(i),&
mag_r_sersic(i),mag_r_err_sersic(i),dummy_var,dummy_var,dummy_var,dummy_var,dummy_var,r_g_sersic(i),r_r_sersic(i),&
ellipticity_sersic(i),dummy_var,dummy_var,dummy_var,dummy_var,dummy_var,dummy_var,dummy_var,dummy_var,dummy_var,&
dummy_var,dummy_var,dummy_var,dummy_var,dummy_var,dummy_var,dummy_var,dummy_var,sersic_index(i),sersic_err_index(i)
END DO
 CLOSE(50)


OPEN(50,file='input/sersic_catalogue.txt')
DO i=1,43 
READ(50,*) 
END DO
DO i=1,n_sersic 
READ(50,*) useless_string,read_string,useless_string,useless_string,useless_string,useless_string,useless_string,&
useless_string,useless_string,useless_string,useless_string,useless_string,&
useless_string,useless_string,useless_string,useless_string,useless_string,&
useless_string,useless_string,useless_string,useless_string,useless_string,&
useless_string,useless_string,useless_string,useless_string,useless_string,&
useless_string,useless_string,useless_string,useless_string,useless_string,&
useless_string,useless_string,useless_string,useless_string,useless_string

SDSS_id_string=TRIM(adjustl(read_string))
READ(SDSS_id_string,*) SDSS_DR7_id_s_int(i)
! WRITE(*,*) read_string,SDSS_DR7_id_s_int(i)
END DO

 CLOSE(50)
WRITE(*,*) 'read in data for ',n_sersic,' objects from Sersic catalogue'
WRITE(30,*) 'read in data for ',n_sersic,' objects from Sersic catalogue'

! read file
OPEN(50,file='input/mendel_stellarmasses.txt')
DO i=1,2 
READ(50,*) 
END DO
DO i=1,n_mendel
! WRITE(*,*) i
READ(50,*) objid_mendel(i),logmstars_mendel(i),logmstarc_mendel(i)
END DO
 CLOSE(50)



OPEN(50,file='input/mendel_stellarmasses.txt')
DO i=1,2 
READ(50,*) 
END DO
DO i=1,n_mendel
READ(50,*) read_string,useless_string,useless_string
SDSS_id_string=TRIM(adjustl(read_string))
READ(SDSS_id_string,*) SDSS_DR7_id_m_int(i)
! WRITE(*,*) read_string,SDSS_DR7_id_s_int(i)
END DO

 CLOSE(50)


WRITE(*,*) 'read in data for ',n_mendel,' objects from the Mendel catalogue'
WRITE(30,*) 'read in data for ',n_mendel,' objects from the Mendel catalogue'



hcount=0
DO i=1,n_sersic
IF (NINT(spec_index(i))==2) THEN
sersic_active(i)=.TRUE.
hcount=hcount+1
ELSE
sersic_active(i)=.FALSE.
END IF
END DO



WRITE(*,*) 'of which are ',hcount,' galaxies'
WRITE(30,*) 'of which are ',hcount,' galaxies'









DO i=1,n_sersic
IF (sersic_active(i)) THEN
! WRITE(*,*) i
foundmatch=.FALSE.
ii=0
DO WHILE ((ii<n_dr7).AND.(foundmatch.eqv..FALSE.))
ii=ii+1
IF (unmatched(ii)) THEN
IF (SDSS_DR7_id_s_int(i)==SDSS_DR7_id_c_int(ii)) THEN
RA_sersic(i)=RA_DR7(ii)
dec_sersic(i)=dec_DR7(ii)
foundmatch=.TRUE.
unmatched(ii)=.FALSE.
END IF
END IF

END DO

sersic_active(i)=foundmatch

END IF
END DO



hcount=0
DO i=1,n_sersic
IF (sersic_active(i)) THEN
hcount=hcount+1
END IF
END DO


WRITE(*,*) 'matches in DR7 for ',hcount,' galaxies found'
WRITE(30,*) 'matches in DR7 for ',hcount,' galaxies found'

!add stellar masses to sample
DO i=1,n_sersic
logmstars_sersic(i)=-101.D0
logmstarc_sersic(i)=-101.D0
IF (sersic_active(i)) THEN
DO ii=1,n_mendel
IF (SDSS_DR7_id_s_int(i)==SDSS_DR7_id_m_int(ii)) THEN
logmstars_sersic(i)=logmstars_mendel(ii)
logmstarc_sersic(i)=logmstarc_mendel(ii)
END IF
END DO
END IF
END DO





DO i=1,n
active(i)=.TRUE.
END DO


DO i=1,n_sersic 
unmatched2(i)=.TRUE.
END DO





DO i=1,n
IF (active(i)) THEN

foundmatch=.FALSE.
ii=0
DO WHILE ((ii<n_sersic).AND.(foundmatch.eqv..FALSE.))
ii=ii+1

IF (sersic_active(ii)) THEN
IF (unmatched2(ii)) THEN

IF ((z_sersic(ii)>(z(i)-0.001)).AND.(z_sersic(ii)<(z(i)+0.001))) THEN

angular_sep=COS(dec(i)*PI/180.D0)*COS(dec_sersic(ii)*PI/180.D0)*COS((RA_sersic(ii)-RA(i))*PI/180.D0)
angular_sep=angular_sep+SIN(dec(i)*PI/180.D0)*SIN(dec_sersic(ii)*PI/180.D0)
angular_sep=ACOS(angular_sep)*180.D0/PI

IF (angular_sep<0.D0) THEN
angular_sep=-angular_sep
END IF
 
 
 IF (angular_sep<(arcsec)) THEN


foundmatch=.TRUE.
unmatched2(ii)=.FALSE.
new_scale_sersic(i)=scale_sersic(ii)
new_mag_g_sersic(i)=mag_g_sersic(ii)
new_mag_r_sersic(i)=mag_r_sersic(ii)
new_r_g_sersic(i)=r_g_sersic(ii)
new_r_r_sersic(i)=r_r_sersic(ii)
new_ellipticity_sersic(i)=ellipticity_sersic(ii)
new_sersic_index(i)=sersic_index(ii)
new_logmstars(i)=logmstars_sersic(ii)
new_logmstarc(i)=logmstarc_sersic(ii)
new_mag_g_err_sersic(i)=mag_g_err_sersic(ii)
new_mag_r_err_sersic(i)=mag_r_err_sersic(ii)
new_sersic_err_index(i)=sersic_err_index(ii)

END IF
END IF
END IF
END IF

END DO

active(i)=foundmatch


END IF
END DO




hcount=0
DO i=1,n
IF (active(i)) THEN
hcount=hcount+1

END IF
END DO




WRITE(*,*) hcount,'galaxies left after crossmatching all data'
WRITE(30,*) hcount,'galaxies left after crossmatching all data'




OPEN(50,file='input/fulldata.txt')
DO i=1,n 
IF (active(i)) THEN
dummy_var=1.D0
ELSE
dummy_var=-1.D0
END IF
WRITE(50,*) dummy_var,new_scale_sersic(i),&
new_mag_g_sersic(i),new_mag_r_sersic(i),new_r_g_sersic(i),new_r_r_sersic(i),&
new_ellipticity_sersic(i),new_sersic_index(i),new_logmstars(i),new_logmstarc(i),&
new_mag_g_err_sersic(i),new_mag_r_err_sersic(i),new_sersic_err_index(i)
END DO
 CLOSE(50)


WRITE(*,*) 'crossmatched data stored'
WRITE(30,*) 'crossmatched data stored'

ELSE


! get length of file
OPEN(50,file='input/fulldata.txt')
io_err=0
n=0
DO WHILE (io_err==0) 
READ(50,*,iostat=io_err) 
n=n+1
END DO
 CLOSE(50)
n=n-2 !last line 
! WRITE(*,*) 'a'

! allocate arrays
allocate(objid(1:n))
allocate(gb(1:n))
allocate(gl(1:n))
allocate(RA(1:n))
allocate(dec(1:n))
allocate(z(1:n))
allocate(veldisp(1:n))
allocate(ba_g(1:n))
allocate(ba_r(1:n))
allocate(ba_i(1:n))
allocate(ba_z(1:n))
allocate(deVRad_g(1:n))
allocate(deVRad_r(1:n))
allocate(deVRad_i(1:n))
allocate(deVRad_z(1:n))
allocate(deVMag_g(1:n))
allocate(deVMag_r(1:n))
allocate(deVMag_i(1:n))
allocate(deVMag_z(1:n))
allocate(extinction_g(1:n))
allocate(extinction_r(1:n))
allocate(extinction_i(1:n))
allocate(extinction_z(1:n))
allocate(zErr(1:n))
allocate(veldisperr(1:n))
allocate(deVRadErr_g(1:n))
allocate(deVRadErr_r(1:n))
allocate(deVRadErr_i(1:n))
allocate(deVRadErr_z(1:n))
allocate(deVMagErr_g(1:n))
allocate(deVMagErr_r(1:n))
allocate(deVMagErr_i(1:n))
allocate(deVMagErr_z(1:n))
allocate(lnLDeV_g(1:n))
allocate(lnLDeV_r(1:n))
allocate(lnLDeV_i(1:n))
allocate(lnLDeV_z(1:n))
allocate(lnLExp_g(1:n))
allocate(lnLExp_r(1:n))
allocate(lnLExp_i(1:n))
allocate(lnLExp_z(1:n))
allocate(Zoo_el(1:n))
allocate(Zoo_nvote(1:n))

allocate(new_scale_sersic(1:n))
allocate(new_mag_g_sersic(1:n))
allocate(new_mag_r_sersic(1:n))
allocate(new_r_g_sersic(1:n))
allocate(new_r_r_sersic(1:n))
allocate(new_ellipticity_sersic(1:n))
allocate(new_sersic_index(1:n))
allocate(new_logmstars(1:n))
allocate(new_logmstarc(1:n))
allocate(new_mag_g_err_sersic(1:n))
allocate(new_mag_r_err_sersic(1:n))
allocate(new_sersic_err_index(1:n))


allocate(active(1:n))
! WRITE(*,*) 'b'
! get length of file
OPEN(50,file='input/sersic_catalogue.txt')
io_err=0
n_sersic=0
DO WHILE (io_err==0) 
READ(50,*,iostat=io_err) 
n_sersic=n_sersic+1
END DO
 CLOSE(50)
n_sersic=n_sersic-45 !header
allocate(SDSS_DR7_id(1:n_sersic))
allocate(z_sersic(1:n_sersic))
allocate(spec_index(1:n_sersic))
allocate(scale_sersic(1:n_sersic))
allocate(mag_g_sersic(1:n_sersic))
allocate(mag_r_sersic(1:n_sersic))
allocate(r_g_sersic(1:n_sersic))
allocate(r_r_sersic(1:n_sersic))
allocate(ellipticity_sersic(1:n_sersic))
allocate(sersic_index(1:n_sersic))
allocate(sersic_active(1:n_sersic))
allocate(SDSS_DR7_id_s_int(1:n_sersic))
allocate(mag_g_err_sersic(1:n_sersic))
allocate(mag_r_err_sersic(1:n_sersic))
allocate(sersic_err_index(1:n_sersic))

! WRITE(*,*) 'c'
! read file
OPEN(50,file='input/sersic_catalogue.txt')
DO i=1,43 
READ(50,*) 
END DO
DO i=1,n_sersic 
READ(50,*) dummy_var,SDSS_DR7_id(i),z_sersic(i),spec_index(i),scale_sersic(i),dummy_var,mag_g_sersic(i),mag_g_err_sersic(i),&
mag_r_sersic(i),mag_r_err_sersic(i),dummy_var,dummy_var,dummy_var,dummy_var,dummy_var,r_g_sersic(i),r_r_sersic(i),&
ellipticity_sersic(i),dummy_var,dummy_var,dummy_var,dummy_var,dummy_var,dummy_var,dummy_var,dummy_var,dummy_var,&
dummy_var,dummy_var,dummy_var,dummy_var,dummy_var,dummy_var,dummy_var,dummy_var,sersic_index(i),sersic_err_index(i)
END DO
 CLOSE(50)


OPEN(50,file='input/sersic_catalogue.txt')
DO i=1,43 
READ(50,*) 
END DO
DO i=1,n_sersic 
READ(50,*) useless_string,read_string,useless_string,useless_string,useless_string,useless_string,useless_string,&
useless_string,useless_string,useless_string,useless_string,useless_string,&
useless_string,useless_string,useless_string,useless_string,useless_string,&
useless_string,useless_string,useless_string,useless_string,useless_string,&
useless_string,useless_string,useless_string,useless_string,useless_string,&
useless_string,useless_string,useless_string,useless_string,useless_string,&
useless_string,useless_string,useless_string,useless_string,useless_string

SDSS_id_string=TRIM(adjustl(read_string))
READ(SDSS_id_string,*) SDSS_DR7_id_s_int(i)
! WRITE(*,*) read_string,SDSS_DR7_id_s_int(i)
END DO

 CLOSE(50)



hcount=0
DO i=1,n_sersic
IF (NINT(spec_index(i))==2) THEN
sersic_active(i)=.TRUE.
hcount=hcount+1
ELSE
sersic_active(i)=.FALSE.
END IF
END DO







! WRITE(*,*) 'a'





DO i=1,n
active(i)=.TRUE.
END DO

! WRITE(*,*) n

OPEN(50,file='input/fulldata.txt')
DO i=1,n 
READ(50,*) dummy_var,new_scale_sersic(i),&
new_mag_g_sersic(i),new_mag_r_sersic(i),new_r_g_sersic(i),new_r_r_sersic(i),&
new_ellipticity_sersic(i),new_sersic_index(i),new_logmstars(i),new_logmstarc(i),&
new_mag_g_err_sersic(i),new_mag_r_err_sersic(i),new_sersic_err_index(i)
IF (dummy_var<0.D0) THEN
active(i)=.FALSE.
! ELSE
! WRITE(*,*) new_mag_r_sersic(i)
END IF

END DO
 CLOSE(50)


! read file
OPEN(50,file='input/ell.txt')
READ(50,*) 
DO i=1,n 
READ(50,*) objid(i),gb(i),gl(i),RA(i),dec(i),&
z(i),veldisp(i),zErr(i),veldisperr(i),&
deVRad_g(i),deVRad_r(i),deVRad_i(i),deVRad_z(i),&
deVRadErr_g(i),deVRadErr_r(i),deVRadErr_i(i),deVRadErr_z(i),&
deVMag_g(i),deVMag_r(i),deVMag_i(i),deVMag_z(i),&
deVMagErr_g(i),deVMagErr_r(i),deVMagErr_i(i),deVMagErr_z(i),&
ba_g(i),ba_r(i),ba_i(i),ba_z(i),&
extinction_g(i),extinction_r(i),extinction_i(i),extinction_z(i),&
lnLDeV_g(i),lnLDeV_r(i),lnLDeV_i(i),lnLDeV_z(i),&
lnLExp_g(i),lnLExp_r(i),lnLExp_i(i),lnLExp_z(i),&
Zoo_el(i),Zoo_nvote(i)
END DO
 CLOSE(50)


hcount=0
DO i=1,n
IF (active(i)) THEN
hcount=hcount+1

END IF
END DO



WRITE(*,*) 'read in data for ',hcount,' elliptical galaxies from already crossmatched files'
WRITE(30,*) 'read in data for ',hcount,' elliptical galaxies from already crossmatched files'






END IF





!set parameters
r_fiber=1.5D0


!prepare for calculation of correction for CMB motion
! values for the motion of the sun relativ to the CMB
v_cmb=369.D0
l_cmb=263.99D0
b_cmb=48.26D0

! calculate sun's motion in z space relativ to the CMB
z_cmb=v_cmb/light
gal_b=b_cmb*PI/180.D0
gal_l=l_cmb*PI/180.D0
z_cmb_x=z_cmb*COS(gal_b)*COS(gal_l)
z_cmb_y=z_cmb*COS(gal_b)*SIN(gal_l)
z_cmb_z=z_cmb*SIN(gal_b)




!get parameters for K correction  
OPEN(52,file='input/K_correction_g.txt')
DO i=0,7
READ(52,*) K_coeff_g(i,0:3)
END DO
OPEN(52,file='input/K_correction_r.txt')
DO i=0,5
READ(52,*) K_coeff_r(i,0:3)
END DO
 CLOSE(52)
OPEN(52,file='input/K_correction_i.txt')
DO i=0,5
READ(52,*) K_coeff_i(i,0:3)
END DO
 CLOSE(52)
OPEN(52,file='input/K_correction_z.txt')
DO i=0,5
READ(52,*) K_coeff_z(i,0:3)
END DO
 CLOSE(52)
 
 
 
OPEN(52,file='input/fitparameters.txt')

READ(52,*) a_g,b_g,c_g
READ(52,*) dist_fp,dist_fp,dist_fp,rms_g
READ(52,*) a_r,b_r,c_r
READ(52,*) dist_fp,dist_fp,dist_fp,rms_r
READ(52,*) a_i,b_i,c_i
READ(52,*) dist_fp,dist_fp,dist_fp,rms_i
READ(52,*) a_z,b_z,c_z
READ(52,*) dist_fp,dist_fp,dist_fp,rms_z


 CLOSE(52)
 
 OPEN(52,file='output/fp_3rms.txt')

WRITE(52,*) 'rms=',3.D0*rms_r

 CLOSE(52)
 
 
 
 OPEN(52,file='input/redsequence.txt')

READ(52,*) cc1
READ(52,*) cc2
READ(52,*) cc3
READ(52,*) cmd_rms

 CLOSE(52)
 


! allocate arrays
allocate(distance(1:n))
allocate(d_com(1:n))
allocate(Mag_g(1:n))
allocate(Mag_r(1:n))
allocate(Mag_i(1:n))
allocate(Mag_z(1:n))
allocate(K_g(1:n))
allocate(K_r(1:n))
allocate(K_i(1:n))
allocate(K_z(1:n))


allocate(r_cor_g(1:n))
allocate(r_cor_r(1:n))
allocate(r_cor_i(1:n))
allocate(r_cor_z(1:n))

allocate(sigma_cor_g(1:n))
allocate(sigma_cor_r(1:n))
allocate(sigma_cor_i(1:n))
allocate(sigma_cor_z(1:n))

allocate(logI0_g(1:n))
allocate(logI0_r(1:n))
allocate(logI0_i(1:n))
allocate(logI0_z(1:n))

allocate(I0_g(1:n))
allocate(I0_r(1:n))
allocate(I0_i(1:n))
allocate(I0_z(1:n))

allocate(z_cor(1:n))
allocate(alpha_g(1:n))
allocate(alpha_r(1:n))
allocate(alpha_i(1:n))
allocate(alpha_z(1:n))

allocate(R0_g(1:n))
allocate(R0_r(1:n))
allocate(R0_i(1:n))
allocate(R0_z(1:n))

allocate(logR0_g(1:n))
allocate(logR0_r(1:n))
allocate(logR0_i(1:n))
allocate(logR0_z(1:n))

allocate(logsigma_g(1:n))
allocate(logsigma_r(1:n))
allocate(logsigma_i(1:n))
allocate(logsigma_z(1:n))

allocate(m_g_sersic(1:n))
allocate(m_r_sersic(1:n))
allocate(K_g_sersic(1:n))
allocate(K_r_sersic(1:n))
allocate(rac_g_sersic(1:n))
allocate(rac_r_sersic(1:n))
allocate(sigma_g_sersic(1:n))
allocate(sigma_r_sersic(1:n))
allocate(Mag_app_g_sersic(1:n))
allocate(logI0_g_sersic(1:n))
allocate(I0_g_sersic(1:n))
allocate(Mag_app_r_sersic(1:n))
allocate(logI0_r_sersic(1:n))
allocate(I0_r_sersic(1:n))
allocate(alpha_g_sersic(1:n))
allocate(alpha_r_sersic(1:n))
allocate(R0_g_sersic(1:n))
allocate(R0_r_sersic(1:n))
allocate(logR0_g_sersic(1:n))
allocate(logR0_r_sersic(1:n))
allocate(logsigma_g_sersic(1:n))
allocate(logsigma_r_sersic(1:n))
allocate(magabs_g_sersic(1:n))
allocate(magabs_r_sersic(1:n))

allocate(magabs_g(1:n))
allocate(magabs_r(1:n))
allocate(magabs_i(1:n))
allocate(magabs_z(1:n))

allocate(Mag_app_g(1:n))
allocate(Mag_app_r(1:n))
allocate(Mag_app_i(1:n))
allocate(Mag_app_z(1:n))

allocate(d_g(1:n))
allocate(d_r(1:n))
allocate(d_i(1:n))
allocate(d_z(1:n))
allocate(act(1:n))
allocate(act_dV(1:n))
allocate(act_S(1:n))
allocate(act_vdbosch15(1:n))
allocate(act_vdbosch15_basic(1:n))
allocate(act_old(1:n))

allocate(ratioL_g(1:n))
allocate(ratioL_r(1:n))
allocate(ratioL_i(1:n))
allocate(ratioL_z(1:n))

allocate(dist_fp_g(1:n))
allocate(dist_fp_r(1:n))
allocate(dist_fp_i(1:n))
allocate(dist_fp_z(1:n))

allocate(otherside_g(1:n))
allocate(otherside_r(1:n))
allocate(otherside_i(1:n))
allocate(otherside_z(1:n))

allocate(sdeviation_g(1:n))
allocate(sdeviation_r(1:n))
allocate(sotherside_g(1:n))
allocate(sotherside_r(1:n))

allocate(logdistlum(1:n))

allocate(M_dyn_g(1:n))
allocate(M_dyn_r(1:n))
allocate(M_dyn_i(1:n))
allocate(M_dyn_z(1:n))
allocate(M_dyn_g_sersic(1:n))
allocate(M_dyn_r_sersic(1:n))

allocate(log_M_dyn_g(1:n))
allocate(log_M_dyn_r(1:n))
allocate(log_M_dyn_i(1:n))
allocate(log_M_dyn_z(1:n))
allocate(log_M_dyn_g_sersic(1:n))
allocate(log_M_dyn_r_sersic(1:n))

allocate(vweight_g(1:n))
allocate(vweight_r(1:n))
allocate(vweight_i(1:n))
allocate(vweight_z(1:n))
allocate(vweight_g_sersic(1:n))
allocate(vweight_r_sersic(1:n))
allocate(lum_g(1:n))
allocate(lum_r(1:n))
allocate(lum_g_sersic(1:n))
allocate(lum_r_sersic(1:n))
allocate(ml_ratio_g(1:n))
allocate(ml_ratio_r(1:n))
allocate(ml_ratio_g_sersic(1:n))
allocate(ml_ratio_r_sersic(1:n))
allocate(log_lum_g(1:n))
allocate(log_lum_r(1:n))
allocate(log_lum_g_sersic(1:n))
allocate(log_lum_r_sersic(1:n))

allocate(M_star(1:n))
allocate(log_M_star(1:n))
allocate(ml_ratio_star(1:n))
allocate(M_star_sersic(1:n))
allocate(log_M_star_sersic(1:n))
allocate(ml_ratio_star_sersic(1:n))

allocate(helplist_g(1:n))
allocate(helplist_r(1:n))

allocate(err_g(1:n))
allocate(err_r(1:n))
allocate(act_fp(1:n))
allocate(sfp_dist_g(1:n))
allocate(sfp_dist_r(1:n))

allocate(act_taylor(1:n))
allocate(taylor_id_sample(1:n))
allocate(act_crossmatchtaylor(1:n))
allocate(taylor_dec(1:n_taylor))
allocate(taylor_ra(1:n_taylor))

allocate(act_trujillo(1:n))
allocate(trujillo_id_sample(1:n))
allocate(act_crossmatchtrujillo(1:n))
allocate(trujillo_dec(1:n_trujillo))
allocate(trujillo_ra(1:n_trujillo))
allocate(trujillo_id(1:n_trujillo))

allocate(err_sigma_cor_g(1:n))
allocate(err_sigma_cor_r(1:n))
allocate(err_sigma_cor_i(1:n))
allocate(err_sigma_cor_z(1:n))
allocate(err_sigma_g_sersic(1:n))
allocate(err_sigma_r_sersic(1:n))
allocate(magapp_g_err(1:n))
allocate(sbm_err_g(1:n))
allocate(magapp_r_err(1:n))
allocate(sbm_err_r(1:n))
allocate(magapp_i_err(1:n))
allocate(sbm_err_i(1:n))
allocate(magapp_z_err(1:n))
allocate(sbm_err_z(1:n))
allocate(magapp_sersic_g_err(1:n))
allocate(sb_err_g_sersic(1:n))
allocate(magapp_sersic_r_err(1:n))
allocate(sb_err_r_sersic(1:n))
allocate(disterr(1:n))
allocate(R_Err_g(1:n))
allocate(R_Err_r(1:n))
allocate(R_Err_i(1:n))
allocate(R_Err_z(1:n))
allocate(R_Err_g_sersic(1:n))
allocate(R_Err_r_sersic(1:n))
allocate(M_dyn_g_err(1:n))
allocate(M_dyn_r_err(1:n))
allocate(M_dyn_i_err(1:n))
allocate(M_dyn_z_err(1:n))
allocate(M_dyn_g_sersic_err(1:n))
allocate(M_dyn_r_sersic_err(1:n))
allocate(magabs_g_err(1:n))
allocate(magabs_r_err(1:n))
allocate(magabs_i_err(1:n))
allocate(magabs_z_err(1:n))
allocate(magabs_sersic_g_err(1:n))
allocate(magabs_sersic_r_err(1:n))

allocate(lum_g_err(1:n))
allocate(lum_r_err(1:n))
allocate(lum_g_sersic_err(1:n))
allocate(lum_r_sersic_err(1:n))
allocate(ml_ratio_g_err(1:n))
allocate(ml_ratio_r_err(1:n))
allocate(ml_ratio_g_sersic_err(1:n))
allocate(ml_ratio_r_sersic_err(1:n))
allocate(log_M_dyn_g_errp(1:n))
allocate(log_M_dyn_r_errp(1:n))
allocate(log_M_dyn_i_errp(1:n))
allocate(log_M_dyn_z_errp(1:n))
allocate(log_M_dyn_g_sersic_errp(1:n))
allocate(log_M_dyn_r_sersic_errp(1:n))
allocate(log_M_dyn_g_errm(1:n))
allocate(log_M_dyn_r_errm(1:n))
allocate(log_M_dyn_i_errm(1:n))
allocate(log_M_dyn_z_errm(1:n))
allocate(log_M_dyn_g_sersic_errm(1:n))
allocate(log_M_dyn_r_sersic_errm(1:n))
allocate(log_lum_g_err(1:n))
allocate(log_lum_r_err(1:n))
allocate(log_lum_g_sersic_err(1:n))
allocate(log_lum_r_sersic_err(1:n))
allocate(M_star_err(1:n))
allocate(log_M_star_err(1:n))
allocate(ml_ratio_star_err(1:n))
allocate(M_star_sersic_err(1:n))
allocate(log_M_star_sersic_err(1:n))
allocate(ml_ratio_star_sersic_err(1:n))

allocate(rad_r_allearly(1:n_allearly))

OPEN(50,file='input/taylor2010.txt')
READ(50,*) 
DO i=1,n_taylor
READ(50,*) taylor_ra(i),taylor_dec(i),dummy_var,dummy_var,dummy_var,dummy_var,dummy_var,&
dummy_var,dummy_var,dummy_var,dummy_var,dummy_var,dummy_var

END DO
 CLOSE(50)
 
OPEN(50,file='input/trujillo2009.txt')
READ(50,*) 
DO i=1,n_trujillo
READ(50,*) trujillo_id(i),trujillo_ra(i),trujillo_dec(i),dummy_var,dummy_var,dummy_var
! WRITE(*,*) i
END DO
 CLOSE(50)

 OPEN(50,file='input/radii_early.txt')
READ(50,*) 
DO i=1,n_allearly
READ(50,*) rad_r_allearly(i)

END DO
 CLOSE(50)
 

! of course, all data is fine at the beginning
DO i=1,n
IF (active(i)) THEN
act(i)=.TRUE.
ELSE
act(i)=.FALSE.
END IF
END DO

DO i=1,n
IF (active(i)) THEN

IF (new_logmstars(i)<-100.D0) THEN
active(i)=.FALSE.
END IF

IF (new_logmstarc(i)<-100.D0) THEN
active(i)=.FALSE.
END IF

END IF
END DO







 
DO i=1,n
! IF (zoo_el(i)<0.8) THEN 
! active(i)=.FALSE.
! END IF
! 
! IF (zoo_nvote(i)<11) THEN
! active(i)=.FALSE.
! END IF
IF (veldisp(i)>420.D0) THEN
active(i)=.FALSE.
END IF
! 
IF (lnLDeV_g(i)<lnLExp_g(i)) THEN
active(i)=.FALSE.
END IF
IF (lnLDeV_r(i)<lnLExp_r(i)) THEN
active(i)=.FALSE.
END IF
IF (lnLDeV_i(i)<lnLExp_i(i)) THEN
active(i)=.FALSE.
END IF
IF (lnLDeV_z(i)<lnLExp_z(i)) THEN
active(i)=.FALSE.
END IF
END DO

! READ(52,*) cc1
! READ(52,*) cc2
! READ(52,*) cc3
! READ(52,*) cmd_rms

DO i=1,n
IF (ba_g(i)<0.D0) THEN
active(i)=.FALSE.
END IF
IF (ba_g(i)>1.D0) THEN
active(i)=.FALSE.
END IF

IF (ba_r(i)<0.D0) THEN
active(i)=.FALSE.
END IF
IF (ba_r(i)>1.D0) THEN
active(i)=.FALSE.
END IF

IF (ba_i(i)<0.D0) THEN
active(i)=.FALSE.
END IF
IF (ba_i(i)>1.D0) THEN
active(i)=.FALSE.
END IF

IF (ba_z(i)<0.D0) THEN
active(i)=.FALSE.
END IF
IF (ba_z(i)>1.D0) THEN
active(i)=.FALSE.
END IF
END DO






WRITE(*,*) 'initizialization done'
WRITE(30,*) 'initizialization done'

!correct for galactic extinction
DO i=1,n
IF (active(i)) THEN
Mag_g(i)=deVMag_g(i)-extinction_g(i)
Mag_r(i)=deVMag_r(i)-extinction_r(i)
Mag_i(i)=deVMag_i(i)-extinction_i(i)
Mag_z(i)=deVMag_z(i)-extinction_z(i)
m_g_sersic(i)=new_mag_g_sersic(i)-extinction_g(i)
m_r_sersic(i)=new_mag_r_sersic(i)-extinction_r(i)

END IF
END DO




WRITE(*,*) 'corrected for galactic extinction'
WRITE(30,*) 'corrected for galactic extinction'


!K-correction
DO i=1,n
IF (active(i)) THEN
K_g(i)=0.D0
DO ii=0,7
DO iii=0,3
K_g(i)=K_g(i)+K_coeff_g(ii,iii)*(z(i)**ii)*((Mag_g(i)-Mag_r(i))**iii)
END DO
END DO

K_r(i)=0.D0
DO ii=0,5
DO iii=0,3
K_r(i)=K_r(i)+K_coeff_r(ii,iii)*(z(i)**ii)*((Mag_g(i)-Mag_r(i))**iii)
END DO
END DO

K_i(i)=0.D0
DO ii=0,5
DO iii=0,3
K_i(i)=K_i(i)+K_coeff_i(ii,iii)*(z(i)**ii)*((Mag_g(i)-Mag_i(i))**iii)
END DO
END DO

K_z(i)=0.D0
DO ii=0,5
DO iii=0,3
K_z(i)=K_z(i)+K_coeff_z(ii,iii)*(z(i)**ii)*((Mag_g(i)-Mag_z(i))**iii)
END DO
END DO



K_g_sersic(i)=0.D0
DO ii=0,7
DO iii=0,3
K_g_sersic(i)=K_g_sersic(i)+K_coeff_g(ii,iii)*(z(i)**ii)*((m_g_sersic(i)-m_r_sersic(i))**iii)
END DO
END DO

K_r_sersic(i)=0.D0
DO ii=0,5
DO iii=0,3
K_r_sersic(i)=K_r_sersic(i)+K_coeff_r(ii,iii)*(z(i)**ii)*((m_g_sersic(i)-m_r_sersic(i))**iii)
END DO
END DO


END IF

END DO 
WRITE(*,*) 'K-correction applied'
WRITE(30,*) 'K-correction applied'

iii=0
av_cirularisation=0.D0
!correct for ellipticity
DO i=1,n
IF (active(i)) THEN

r_cor_g(i)=deVRad_g(i)*SQRT(ba_g(i))
r_cor_r(i)=deVRad_r(i)*SQRT(ba_r(i))
r_cor_i(i)=deVRad_i(i)*SQRT(ba_i(i))
r_cor_z(i)=deVRad_z(i)*SQRT(ba_z(i))

iii=iii+1
av_cirularisation=av_cirularisation+(r_cor_r(i)/deVRad_r(i))

deVRadErr_g(i)=deVRadErr_g(i)*SQRT(ba_g(i))
deVRadErr_r(i)=deVRadErr_r(i)*SQRT(ba_r(i))
deVRadErr_i(i)=deVRadErr_i(i)*SQRT(ba_i(i))
deVRadErr_z(i)=deVRadErr_z(i)*SQRT(ba_z(i))

!ERROR PROPAGATION

rac_g_sersic(i)=new_r_g_sersic(i)/new_scale_sersic(i)
rac_r_sersic(i)=new_r_r_sersic(i)/new_scale_sersic(i)
! SQRT(1.D0-new_ellipticity_sersic(i))
END IF
END DO
WRITE(*,*) 'corrected for ellipticity and dimming'
WRITE(30,*) 'corrected for ellipticity and dimming'

av_cirularisation=av_cirularisation/DBLE(iii)


!correction for fixed aperature for the velocity dispersion measurment
DO i=1,n
IF (active(i)) THEN

divisor=(r_fiber/(r_cor_g(i)/8.D0))
sigma_cor_g(i)=veldisp(i)*(divisor**0.04D0)

err_sigma_cor_g(i)=(deVRadErr_g(i)*0.04D0*veldisp(i)*((8.D0*r_fiber)**0.04D0)*(r_cor_g(i)**(-1.04D0)))**2
err_sigma_cor_g(i)=err_sigma_cor_g(i)+((veldisperr(i)*(divisor**0.04D0))**2)
err_sigma_cor_g(i)=SQRT(err_sigma_cor_g(i))

divisor=(r_fiber/(r_cor_r(i)/8.D0))
sigma_cor_r(i)=veldisp(i)*(divisor**0.04D0)

err_sigma_cor_r(i)=(deVRadErr_r(i)*0.04D0*veldisp(i)*((8.D0*r_fiber)**0.04D0)*(r_cor_r(i)**(-1.04D0)))**2
err_sigma_cor_r(i)=err_sigma_cor_r(i)+((veldisperr(i)*(divisor**0.04D0))**2)
err_sigma_cor_r(i)=SQRT(err_sigma_cor_r(i))

divisor=(r_fiber/(r_cor_i(i)/8.D0))
sigma_cor_i(i)=veldisp(i)*(divisor**0.04D0)

err_sigma_cor_i(i)=(deVRadErr_i(i)*0.04D0*veldisp(i)*((8.D0*r_fiber)**0.04D0)*(r_cor_i(i)**(-1.04D0)))**2
err_sigma_cor_i(i)=err_sigma_cor_i(i)+((veldisperr(i)*(divisor**0.04D0))**2)
err_sigma_cor_i(i)=SQRT(err_sigma_cor_i(i))

divisor=(r_fiber/(r_cor_z(i)/8.D0))
sigma_cor_z(i)=veldisp(i)*(divisor**0.04D0)

err_sigma_cor_z(i)=(deVRadErr_z(i)*0.04D0*veldisp(i)*((8.D0*r_fiber)**0.04D0)*(r_cor_z(i)**(-1.04D0)))**2
err_sigma_cor_z(i)=err_sigma_cor_z(i)+((veldisperr(i)*(divisor**0.04D0))**2)
err_sigma_cor_z(i)=SQRT(err_sigma_cor_z(i))


divisor=(r_fiber/(rac_g_sersic(i)/8.D0))
sigma_g_sersic(i)=veldisp(i)*(divisor**0.04D0)

err_sigma_g_sersic(i)=veldisperr(i)*(divisor**0.04D0)

divisor=(r_fiber/(rac_r_sersic(i)/8.D0))
sigma_r_sersic(i)=veldisp(i)*(divisor**0.04D0)

err_sigma_r_sersic(i)=veldisperr(i)*(divisor**0.04D0)


END IF
END DO
WRITE(*,*) 'corrected for fixed aperature diameter'
WRITE(30,*) 'corrected for fixed aperature diameter'



!correct redshift for motion relativ to the CMB
DO i=1,n
IF (active(i)) THEN
gal_b=gb(i)*PI/180.D0
gal_l=gl(i)*PI/180.D0
z_gal_x=z(i)*COS(gal_b)*COS(gal_l)
z_gal_y=z(i)*COS(gal_b)*SIN(gal_l)
z_gal_z=z(i)*SIN(gal_b)
z_gal_x=z_gal_x+z_cmb_x
z_gal_y=z_gal_y+z_cmb_y
z_gal_z=z_gal_z+z_cmb_z
z_cor(i)=z_gal_x*COS(gal_b)*COS(gal_l)+z_gal_y*COS(gal_b)*SIN(gal_l)+z_gal_z*SIN(gal_b)
END IF
END DO
WRITE(*,*) 'corrected for motion relativ to the CMB'
WRITE(30,*) 'corrected for motion relativ to the CMB'




DO i=1,n
IF (active(i)) THEN

magabs_g(i)=Mag_g(i)-K_g(i) ! corrected apparent magnitudes
!correct for potential redshift evolution
! magabs_g(i)=magabs_g(i)!
Mag_app_g(i)=magabs_g(i)

magapp_g_err(i)=K_g(i)*SQRT(((zErr(i)/z(i))**2)+((SQRT(deVMagErr_g(i)**2+deVMagErr_r(i)**2)/(Mag_g(i)-Mag_r(i)))**2))
magapp_g_err(i)=SQRT(magapp_g_err(i)**2+(deVMagErr_g(i)**2))



logI0_g(i)=magabs_g(i)+2.5D0*LOG10(2.D0*PI*(r_cor_g(i)**2.D0))-10.D0*LOG10(1.D0+z_cor(i))+mag_evolution_g*z_cor(i)

sbm_err_g(i)=SQRT((magapp_g_err(i)**2)+((deVRadErr_g(i)*5.D0/(LOG(10.D0)*r_cor_g(i)))**2)+&
((10.D0/LOG(10.D0)*zErr(i)/z_cor(i))**2)+((mag_evolution_g*zErr(i))**2))

! surface brightness  - last term corrects for cosmological dimming
logI0_g(i)=logI0_g(i)/(-2.5D0) !rescaling (it's just a matter of definition)


I0_g(i)=10.D0**(logI0_g(i))


magabs_r(i)=Mag_r(i)-K_r(i) ! corrected apparent magnitudes
!correct for potential redshift evolution
Mag_app_r(i)=magabs_r(i)

magapp_r_err(i)=K_r(i)*SQRT(((zErr(i)/z(i))**2)+((SQRT(deVMagErr_g(i)**2+deVMagErr_r(i)**2)/(Mag_g(i)-Mag_r(i)))**2))
magapp_r_err(i)=SQRT(magapp_r_err(i)**2+(deVMagErr_r(i)**2))

logI0_r(i)=magabs_r(i)+2.5D0*LOG10(2.D0*PI*(r_cor_r(i)**2.D0))-10.D0*LOG10(1.D0+z_cor(i))+mag_evolution_r*z_cor(i)

sbm_err_r(i)=SQRT((magapp_r_err(i)**2)+((deVRadErr_r(i)*5.D0/(LOG(10.D0)*r_cor_r(i)))**2)+&
((10.D0/LOG(10.D0)*zErr(i)/z_cor(i))**2)+((mag_evolution_r*zErr(i))**2))

! surface brightness  - last term corrects for cosmological dimming
logI0_r(i)=logI0_r(i)/(-2.5D0) !rescaling (it's just a matter of definition)


I0_r(i)=10.D0**(logI0_r(i))

magabs_i(i)=Mag_i(i)-K_i(i) ! corrected apparent magnitudes
!correct for potential redshift evolution

Mag_app_i(i)=magabs_i(i)

magapp_i_err(i)=K_i(i)*SQRT(((zErr(i)/z(i))**2)+((SQRT(deVMagErr_g(i)**2+deVMagErr_i(i)**2)/(Mag_g(i)-Mag_i(i)))**2))
magapp_i_err(i)=SQRT((magapp_i_err(i)**2)+(deVMagErr_i(i)**2))

logI0_i(i)=magabs_i(i)+2.5D0*LOG10(2.D0*PI*(r_cor_i(i)**2.D0))-10.D0*LOG10(1.D0+z_cor(i))+mag_evolution_i*z_cor(i)

sbm_err_i(i)=SQRT((magapp_i_err(i)**2)+((deVRadErr_i(i)*5.D0/(LOG(10.D0)*r_cor_i(i)))**2)+&
((10.D0/LOG(10.D0)*zErr(i)/z_cor(i))**2)+((mag_evolution_i*zErr(i))**2))
! surface brightness  - last term corrects for cosmological dimming
logI0_i(i)=logI0_i(i)/(-2.5D0) !rescaling (it's just a matter of definition)



I0_i(i)=10.D0**(logI0_i(i))


magabs_z(i)=Mag_z(i)-K_z(i) ! corrected apparent magnitudes
!correct for potential redshift evolution

Mag_app_z(i)=magabs_z(i)


magapp_z_err(i)=K_z(i)*SQRT(((zErr(i)/z(i))**2)+((SQRT(deVMagErr_g(i)**2+deVMagErr_z(i)**2)/(Mag_g(i)-Mag_z(i)))**2))
magapp_z_err(i)=SQRT((magapp_z_err(i)**2)+(deVMagErr_z(i)**2))


logI0_z(i)=magabs_z(i)+2.5D0*LOG10(2.D0*PI*(r_cor_z(i)**2.D0))-10.D0*LOG10(1.D0+z_cor(i))+mag_evolution_z*z_cor(i)


sbm_err_z(i)=SQRT((magapp_z_err(i)**2)+((deVRadErr_z(i)*5.D0/(LOG(10.D0)*r_cor_z(i)))**2)+&
((10.D0/LOG(10.D0)*zErr(i)/z_cor(i))**2)+((mag_evolution_z*zErr(i))**2))

! surface brightness  - last term corrects for cosmological dimming
logI0_z(i)=logI0_z(i)/(-2.5D0) !rescaling (it's just a matter of definition)



I0_z(i)=10.D0**(logI0_z(i))






magabs_g_sersic(i)=m_g_sersic(i)-K_g_sersic(i) ! corrected apparent magnitudes
!correct for potential redshift evolution
Mag_app_g_sersic(i)=magabs_g_sersic(i)


magapp_sersic_g_err(i)=K_z(i)*SQRT(((zErr(i)/z(i))**2)+((SQRT(new_mag_g_err_sersic(i)**2+&
new_mag_r_err_sersic(i)**2)/(magabs_g_sersic(i)-magabs_r_sersic(i)))**2))
magapp_sersic_g_err(i)=(magapp_sersic_g_err(i)**2)+(new_mag_g_err_sersic(i)**2)
magapp_sersic_g_err(i)=SQRT(magapp_sersic_g_err(i))


logI0_g_sersic(i)=magabs_g_sersic(i)+2.5D0*LOG10(2.D0*PI*(rac_g_sersic(i)**2.D0))-10.D0*LOG10(1.D0+z_cor(i)) 
logI0_g_sersic(i)=logI0_g_sersic(i)+mag_evolution_g*z_cor(i)
sb_err_g_sersic(i)=SQRT((magapp_sersic_g_err(i)**2)+((10.D0/LOG(10.D0)*zErr(i)/z_cor(i))**2)+&
((mag_evolution_z*zErr(i))**2))



! surface brightness  - last term corrects for cosmological dimming
logI0_g_sersic(i)=logI0_g_sersic(i)/(-2.5D0) !rescaling (it's just a matter of definition)


I0_g_sersic(i)=10.D0**(logI0_g_sersic(i))






magabs_r_sersic(i)=m_r_sersic(i)-K_r_sersic(i) ! corrected apparent magnitudes
!correct for potential redshift evolution
Mag_app_r_sersic(i)=magabs_r_sersic(i)

magapp_sersic_r_err(i)=K_z(i)*SQRT(((zErr(i)/z(i))**2)+((SQRT(new_mag_g_err_sersic(i)**2+&
new_mag_r_err_sersic(i)**2)/(magabs_g_sersic(i)-magabs_r_sersic(i)))**2))
magapp_sersic_r_err(i)=(magapp_sersic_r_err(i)**2)+(new_mag_r_err_sersic(i)**2)
magapp_sersic_r_err(i)=SQRT(magapp_sersic_r_err(i))


logI0_r_sersic(i)=magabs_r_sersic(i)+2.5D0*LOG10(2.D0*PI*(rac_r_sersic(i)**2.D0))-10.D0*LOG10(1.D0+z_cor(i)) 
logI0_r_sersic(i)=logI0_r_sersic(i)+mag_evolution_r*z_cor(i)

sb_err_r_sersic(i)=SQRT((magapp_sersic_r_err(i)**2)+((10.D0/LOG(10.D0)*zErr(i)/z_cor(i))**2)+&
((mag_evolution_z*zErr(i))**2))


! surface brightness  - last term corrects for cosmological dimming
logI0_r_sersic(i)=logI0_r_sersic(i)/(-2.5D0) !rescaling (it's just a matter of definition)


I0_r_sersic(i)=10.D0**(logI0_r_sersic(i))




END IF
END DO
WRITE(*,*) 'surfacebrightness calculated and corrected for cosmological dimming'
WRITE(30,*) 'surfacebrightness calculated and corrected for cosmological dimming'



!calculate the redshift distance
DO i=1,n
IF (active(i)) THEN
!distance(i)=light/H0*z_cor(i)*((1.D0-(((1.D0+q0)/2.D0)*z_cor(i)))/(1.D0+z_cor(i))) !old version
divisor=(SQRT(1.D0+2.D0*q0*z_cor(i))+1.D0+q0*z_cor(i))
!luminosity distance
distance(i)=light/H0*z_cor(i)*(1.D0+((z_cor(i)*(1.D0-q0))/divisor))
logdistlum(i)=distance(i)*1.D6
!angular diameter distance
distance(i)=distance(i)*((1.D0+z_cor(i))**(-2.D0))
d_com(i)=distance(i)*((1.D0+z_cor(i))**(-1.D0))
!distance in kpc
distance(i)=distance(i)*1000.D0

disterr(i)=light/H0*zerr(i)*1000.D0

logdistlum(i)=LOG10(logdistlum(i))

END IF
END DO
WRITE(*,*) 'distances calculated'
WRITE(30,*) 'distances calculated'



!transform arcseconds to radiant
DO i=1,n
IF (active(i)) THEN
alpha_g(i)=r_cor_g(i)*2.D0*PI/(360.D0*60.D0*60.D0)
alpha_r(i)=r_cor_r(i)*2.D0*PI/(360.D0*60.D0*60.D0)
alpha_i(i)=r_cor_i(i)*2.D0*PI/(360.D0*60.D0*60.D0)
alpha_z(i)=r_cor_z(i)*2.D0*PI/(360.D0*60.D0*60.D0)



alpha_g_sersic(i)=rac_g_sersic(i)*2.D0*PI/(360.D0*60.D0*60.D0)
alpha_r_sersic(i)=rac_r_sersic(i)*2.D0*PI/(360.D0*60.D0*60.D0)
END IF
END DO
WRITE(*,*) 'angles transformed to radiant'
WRITE(30,*) 'angles transformed to radiant'


!calculate effective radius in kpc
DO i=1,n
IF (active(i)) THEN
R0_g(i)=TAN(alpha_g(i))*distance(i)
R0_r(i)=TAN(alpha_r(i))*distance(i)
R0_i(i)=TAN(alpha_i(i))*distance(i)
R0_z(i)=TAN(alpha_z(i))*distance(i)

R_Err_g(i)=SQRT(((deVRadErr_g(i)/r_cor_g(i))**2)+((disterr(i)/distance(i))**2))*R0_g(i)
R_Err_r(i)=SQRT(((deVRadErr_r(i)/r_cor_r(i))**2)+((disterr(i)/distance(i))**2))*R0_r(i)
R_Err_i(i)=SQRT(((deVRadErr_i(i)/r_cor_i(i))**2)+((disterr(i)/distance(i))**2))*R0_i(i)
R_Err_z(i)=SQRT(((deVRadErr_z(i)/r_cor_z(i))**2)+((disterr(i)/distance(i))**2))*R0_z(i)


R0_g_sersic(i)=TAN(alpha_g_sersic(i))*distance(i)
R0_r_sersic(i)=TAN(alpha_r_sersic(i))*distance(i)

R_Err_g_sersic(i)=(disterr(i)/distance(i))*R0_g_sersic(i)
R_Err_r_sersic(i)=(disterr(i)/distance(i))*R0_r_sersic(i)



END IF
END DO
WRITE(*,*) 'effective radius calculated'
WRITE(30,*) 'effective radius calculated'


DO i=1,n
IF (active(i)) THEN

M_dyn_g(i)=(sigma_cor_g(i)**2)*R0_g(i)*5.D0/G
M_dyn_r(i)=(sigma_cor_r(i)**2)*R0_r(i)*5.D0/G
M_dyn_i(i)=(sigma_cor_i(i)**2)*R0_i(i)*5.D0/G
M_dyn_z(i)=(sigma_cor_z(i)**2)*R0_z(i)*5.D0/G

!(Cappellari et al.2006):
beta=8.87D0-0.831D0*new_sersic_index(i)+0.0241D0*(new_sersic_index(i)**2)
M_dyn_g_sersic(i)=(sigma_g_sersic(i)**2)*R0_g_sersic(i)*beta/G
M_dyn_r_sersic(i)=(sigma_r_sersic(i)**2)*R0_r_sersic(i)*beta/G



M_dyn_g_err(i)=SQRT(((R_Err_g(i)/R0_g(i))**2)+((err_sigma_cor_g(i)/sigma_cor_g(i))**2))*M_dyn_g(i)
M_dyn_r_err(i)=SQRT(((R_Err_r(i)/R0_r(i))**2)+((err_sigma_cor_r(i)/sigma_cor_r(i))**2))*M_dyn_r(i)
M_dyn_i_err(i)=SQRT(((R_Err_i(i)/R0_i(i))**2)+((err_sigma_cor_i(i)/sigma_cor_i(i))**2))*M_dyn_i(i)
M_dyn_z_err(i)=SQRT(((R_Err_z(i)/R0_z(i))**2)+((err_sigma_cor_z(i)/sigma_cor_z(i))**2))*M_dyn_z(i)

M_dyn_g_sersic_err(i)=((R_Err_g_sersic(i)/R0_g_sersic(i))**2)+((err_sigma_g_sersic(i)/sigma_g_sersic(i))**2)
M_dyn_g_sersic_err(i)=M_dyn_g_sersic_err(i)+((new_sersic_err_index(i)/new_sersic_index(i))**2)
M_dyn_g_sersic_err(i)=SQRT(M_dyn_g_sersic_err(i))*M_dyn_g_sersic(i)

M_dyn_r_sersic_err(i)=((R_Err_r_sersic(i)/R0_r_sersic(i))**2)+((err_sigma_r_sersic(i)/sigma_r_sersic(i))**2)
M_dyn_r_sersic_err(i)=M_dyn_r_sersic_err(i)+((new_sersic_err_index(i)/new_sersic_index(i))**2)
M_dyn_r_sersic_err(i)=SQRT(M_dyn_r_sersic_err(i))*M_dyn_r_sersic(i)


log_M_dyn_g(i)=LOG10(M_dyn_g(i))
log_M_dyn_r(i)=LOG10(M_dyn_r(i))
log_M_dyn_i(i)=LOG10(M_dyn_i(i))
log_M_dyn_z(i)=LOG10(M_dyn_z(i))

log_M_dyn_g_sersic(i)=LOG10(M_dyn_g_sersic(i))
log_M_dyn_r_sersic(i)=LOG10(M_dyn_r_sersic(i))




! log_M_dyn_g_errm(i)=LOG10(M_dyn_g(i))-(LOG10(M_dyn_g(i)-M_dyn_g_err(i)))
! log_M_dyn_r_errm(i)=LOG10(M_dyn_r(i))-(LOG10(M_dyn_r(i)-M_dyn_r_err(i)))
log_M_dyn_g_errm(i)=LOG10((M_dyn_g_err(i)/M_dyn_g(i))+1.D0)
log_M_dyn_r_errm(i)=LOG10((M_dyn_r_err(i)/M_dyn_r(i))+1.D0)
! log_M_dyn_i_errm(i)=LOG10(M_dyn_i(i))-(LOG10(M_dyn_i(i)-M_dyn_i_err(i)))
! log_M_dyn_z_errm(i)=LOG10(M_dyn_z(i))-(LOG10(M_dyn_z(i)-M_dyn_z_err(i)))
log_M_dyn_i_errm(i)=LOG10((M_dyn_i_err(i)/M_dyn_i(i))+1.D0)
log_M_dyn_z_errm(i)=LOG10((M_dyn_z_err(i)/M_dyn_z(i))+1.D0)

log_M_dyn_g_errp(i)=-LOG10(M_dyn_g(i))+(LOG10(M_dyn_g(i)+M_dyn_g_err(i)))
log_M_dyn_r_errp(i)=-LOG10(M_dyn_r(i))+(LOG10(M_dyn_r(i)+M_dyn_r_err(i)))
log_M_dyn_i_errp(i)=-LOG10(M_dyn_i(i))+(LOG10(M_dyn_i(i)+M_dyn_i_err(i)))
log_M_dyn_z_errp(i)=-LOG10(M_dyn_z(i))+(LOG10(M_dyn_z(i)+M_dyn_z_err(i)))

log_M_dyn_g_sersic(i)=LOG10(M_dyn_g_sersic(i))
log_M_dyn_r_sersic(i)=LOG10(M_dyn_r_sersic(i))


log_M_dyn_g_sersic_errm(i)=LOG10((M_dyn_g_sersic_err(i)/M_dyn_g_sersic(i))+1.D0)
log_M_dyn_r_sersic_errm(i)=LOG10((M_dyn_r_sersic_err(i)/M_dyn_r_sersic(i))+1.D0)


log_M_dyn_g_sersic_errp(i)=-LOG10(M_dyn_g_sersic(i))+(LOG10(M_dyn_g_sersic(i)+M_dyn_g_sersic_err(i)))
log_M_dyn_r_sersic_errp(i)=-LOG10(M_dyn_r_sersic(i))+(LOG10(M_dyn_r_sersic(i)+M_dyn_r_sersic_err(i)))





END IF
END DO

WRITE(*,*) 'dynamical mass calculated'
WRITE(30,*) 'dynamical mass calculated'



!transform to log(R0)
DO i=1,n
IF (active(i)) THEN
logR0_g(i)=LOG10(R0_g(i))
logR0_r(i)=LOG10(R0_r(i))
logR0_i(i)=LOG10(R0_i(i))
logR0_z(i)=LOG10(R0_z(i))

logR0_g_sersic(i)=LOG10(R0_g_sersic(i))
logR0_r_sersic(i)=LOG10(R0_r_sersic(i))



!transform to log(sigma)
logsigma_g(i)=LOG10(sigma_cor_g(i))
logsigma_r(i)=LOG10(sigma_cor_r(i))
logsigma_i(i)=LOG10(sigma_cor_i(i))
logsigma_z(i)=LOG10(sigma_cor_z(i))

logsigma_g_sersic(i)=LOG10(sigma_g_sersic(i))
logsigma_r_sersic(i)=LOG10(sigma_r_sersic(i))

END IF
END DO
WRITE(*,*) 'parameters logaritmized'
WRITE(30,*) 'parameters logaritmized'


! preselecting sample

DO i=1,n
!note - angular diameter distance to luminosity distance 
IF (active(i)) THEN

magabs_g(i)=magabs_g(i)-5.D0*LOG10(((1.D0+z_cor(i))**2.D0)*distance(i)*1000.D0)+5.D0
magabs_r(i)=magabs_r(i)-5.D0*LOG10(((1.D0+z_cor(i))**2.D0)*distance(i)*1000.D0)+5.D0
magabs_i(i)=magabs_i(i)-5.D0*LOG10(((1.D0+z_cor(i))**2.D0)*distance(i)*1000.D0)+5.D0
magabs_z(i)=magabs_z(i)-5.D0*LOG10(((1.D0+z_cor(i))**2.D0)*distance(i)*1000.D0)+5.D0

magabs_g_err(i)=SQRT((magapp_g_err(i)**2)+((magabs_g(i)*disterr(i)/distance(i))**2))
magabs_r_err(i)=SQRT((magapp_r_err(i)**2)+((magabs_r(i)*disterr(i)/distance(i))**2))
magabs_i_err(i)=SQRT((magapp_i_err(i)**2)+((magabs_i(i)*disterr(i)/distance(i))**2))
magabs_z_err(i)=SQRT((magapp_z_err(i)**2)+((magabs_z(i)*disterr(i)/distance(i))**2))




magabs_g_sersic(i)=magabs_g_sersic(i)-5.D0*LOG10(((1.D0+z_cor(i))**2.D0)*distance(i)*1000.D0)+5.D0
magabs_r_sersic(i)=magabs_r_sersic(i)-5.D0*LOG10(((1.D0+z_cor(i))**2.D0)*distance(i)*1000.D0)+5.D0



magabs_sersic_g_err(i)=SQRT((magapp_sersic_g_err(i)**2)+((magabs_g_sersic(i)*disterr(i)/distance(i))**2))
magabs_sersic_r_err(i)=SQRT((magapp_sersic_r_err(i)**2)+((magabs_r_sersic(i)*disterr(i)/distance(i))**2))







END IF
END DO


DO i=1,n
IF (active(i)) THEN
dummy_var=cc1*((magabs_z(i))**2)+cc2*(magabs_z(i))+cc3-3.D0*cmd_rms
IF ((magabs_g(i)-magabs_r(i))<dummy_var) THEN
active(i)=.FALSE.
END IF
END IF
END DO

DO i=1,n
IF (active(i)) THEN

IF (zoo_el(i)<0.5) THEN 
active(i)=.FALSE.
END IF


! IF (new_sersic_index(i)<2.5D0) THEN
! active(i)=.FALSE.
! END IF
END IF 
END DO

DO i=1,n
IF (active(i)) THEN

IF (z_cor(i)<0.D0) THEN
active(i)=.FALSE.
END IF

IF (magabs_g(i)<maxmag_g) THEN
active(i)=.FALSE.
END IF
IF (magabs_g(i)>minmag_g) THEN
active(i)=.FALSE.
END IF

IF (magabs_r(i)<maxmag_r) THEN
active(i)=.FALSE.
END IF
IF (magabs_r(i)>minmag_r) THEN
active(i)=.FALSE.
END IF

IF (magabs_g_sersic(i)<maxmag_g) THEN
active(i)=.FALSE.
END IF
IF (magabs_g_sersic(i)>minmag_g) THEN
active(i)=.FALSE.
END IF

IF (magabs_r_sersic(i)<maxmag_r) THEN
active(i)=.FALSE.
END IF
IF (magabs_r_sersic(i)>minmag_r) THEN
active(i)=.FALSE.
END IF

IF (magabs_i(i)<maxmag_i) THEN
active(i)=.FALSE.
END IF
IF (magabs_i(i)>minmag_i) THEN
active(i)=.FALSE.
END IF

IF (magabs_z(i)<maxmag_z) THEN
active(i)=.FALSE.
END IF
IF (magabs_z(i)>minmag_z) THEN
active(i)=.FALSE.
END IF



IF (isnan(logR0_g_sersic(i))) THEN
active(i)=.FALSE.
END IF

IF (isnan(logR0_r_sersic(i))) THEN
active(i)=.FALSE.
END IF

IF (logR0_g(i)>2.5D0) THEN
active(i)=.FALSE.
END IF
IF (logR0_r(i)>2.5D0) THEN
active(i)=.FALSE.
END IF

IF (logR0_g_sersic(i)>2.5D0) THEN
active(i)=.FALSE.
END IF
IF (logR0_r_sersic(i)>2.5D0) THEN
active(i)=.FALSE.
END IF

IF (logR0_i(i)>2.5D0) THEN
active(i)=.FALSE.
END IF
IF (logR0_z(i)>2.5D0) THEN
active(i)=.FALSE.
END IF


END IF
END DO

galactive=0
DO i=1,n
IF (active(i)) THEN
galactive=galactive+1
END IF
END DO

! 
! OPEN(70,file='R0_sersic_list.txt')
! DO i=1,n
! IF (active(i)) THEN
! WRITE(70,*) logR0_r_sersic(i)
! END IF
! END DO
!  CLOSE (70)
! 
! 
! 

OPEN(70,file='input/dist_limits_for_mag.txt')
READ(70,*) dist_k_g,dist_d_g,dist_dsat_g
READ(70,*) dist_k_r,dist_d_r,dist_dsat_r
READ(70,*) dist_k_i,dist_d_i,dist_dsat_i
READ(70,*) dist_k_z,dist_d_z,dist_dsat_z
 CLOSE (70)

V_sum_g=0.D0
V_sum_r=0.D0
V_sum_i=0.D0
V_sum_z=0.D0



DO i=1,n
IF (active(i)) THEN


D_limit=dist_k_g*magabs_g(i)+dist_d_g
D_limit=10.D0**D_limit
D_limit=D_limit/1.D6


t1=(light**2)*q0-(light**2)
t2=(light**4)*(q0**2)-2.D0*(light**4)*q0+(light**4)+2.D0*(light**3)*D_limit*H0*(q0**2)
t2=t2-4.D0*(light**3)*D_limit*H0*q0+2.D0*(light**3)*D_limit*H0
t2=SQRT(t2)
t3=light*D_limit*H0*q0

z_limit=1/(light**2)*(t1+t2+t3)

IF (z_limit>zmax) THEN
z_limit=zmax
divisor=(SQRT(1.D0+2.D0*q0*z_limit)+1.D0+q0*z_limit)
D_limit=light/H0*z_limit*(1.D0+((z_limit*(1.D0-q0))/divisor))
END IF

D_limit=D_limit*((1.D0+z_limit)**(-1.D0))!comoving diameter distance




Dmin=dist_k_g*magabs_g(i)+dist_dsat_g
Dmin=10.D0**Dmin
Dmin=Dmin/1.D6

t1=(light**2)*q0-(light**2)
t2=(light**4)*(q0**2)-2.D0*(light**4)*q0+(light**4)+2.D0*(light**3)*Dmin*H0*(q0**2)
t2=t2-4.D0*(light**3)*Dmin*H0*q0+2.D0*(light**3)*Dmin*H0
t2=SQRT(t2)
t3=light*Dmin*H0*q0

z_limit=1/(light**2)*(t1+t2+t3)
Dmin=Dmin*((1.D0+z_limit)**(-1.D0))!comoving diameter distance

Vminsat=(Dmin**3)

IF (Vminsat<Vmin) THEN
Vminsat=Vmin
END IF

V_limit=(D_limit**3)-Vminsat
vweight_g(i)=1.D0/V_limit
V_sum_g=V_sum_g+1.D0/V_limit

D_limit=dist_k_r*magabs_r(i)+dist_d_r
D_limit=10.D0**D_limit
D_limit=D_limit/1.D6



t1=(light**2)*q0-(light**2)
t2=(light**4)*(q0**2)-2.D0*(light**4)*q0+(light**4)+2.D0*(light**3)*D_limit*H0*(q0**2)
t2=t2-4.D0*(light**3)*D_limit*H0*q0+2.D0*(light**3)*D_limit*H0
t2=SQRT(t2)
t3=light*D_limit*H0*q0

z_limit=1/(light**2)*(t1+t2+t3)

IF (z_limit>zmax) THEN
z_limit=zmax
divisor=(SQRT(1.D0+2.D0*q0*z_limit)+1.D0+q0*z_limit)
D_limit=light/H0*z_limit*(1.D0+((z_limit*(1.D0-q0))/divisor))
END IF

D_limit=D_limit*((1.D0+z_limit)**(-1.D0))!comoving diameter distance



Dmin=dist_k_r*magabs_r(i)+dist_dsat_r
Dmin=10.D0**Dmin
Dmin=Dmin/1.D6

t1=(light**2)*q0-(light**2)
t2=(light**4)*(q0**2)-2.D0*(light**4)*q0+(light**4)+2.D0*(light**3)*Dmin*H0*(q0**2)
t2=t2-4.D0*(light**3)*Dmin*H0*q0+2.D0*(light**3)*Dmin*H0
t2=SQRT(t2)
t3=light*Dmin*H0*q0

z_limit=1/(light**2)*(t1+t2+t3)
Dmin=Dmin*((1.D0+z_limit)**(-1.D0))!comoving diameter distance

Vminsat=(Dmin**3)

IF (Vminsat<Vmin) THEN
Vminsat=Vmin
END IF

V_limit=(D_limit**3)-Vminsat
vweight_r(i)=1.D0/V_limit
V_sum_r=V_sum_r+1.D0/V_limit

D_limit=dist_k_i*magabs_i(i)+dist_d_i
D_limit=10.D0**D_limit
D_limit=D_limit/1.D6


t1=(light**2)*q0-(light**2)
t2=(light**4)*(q0**2)-2.D0*(light**4)*q0+(light**4)+2.D0*(light**3)*D_limit*H0*(q0**2)
t2=t2-4.D0*(light**3)*D_limit*H0*q0+2.D0*(light**3)*D_limit*H0
t2=SQRT(t2)
t3=light*D_limit*H0*q0

z_limit=1/(light**2)*(t1+t2+t3)

IF (z_limit>zmax) THEN
z_limit=zmax
divisor=(SQRT(1.D0+2.D0*q0*z_limit)+1.D0+q0*z_limit)
D_limit=light/H0*z_limit*(1.D0+((z_limit*(1.D0-q0))/divisor))
END IF

D_limit=D_limit*((1.D0+z_limit)**(-1.D0))!comoving diameter distance



Dmin=dist_k_i*magabs_i(i)+dist_dsat_i
Dmin=10.D0**Dmin
Dmin=Dmin/1.D6

t1=(light**2)*q0-(light**2)
t2=(light**4)*(q0**2)-2.D0*(light**4)*q0+(light**4)+2.D0*(light**3)*Dmin*H0*(q0**2)
t2=t2-4.D0*(light**3)*Dmin*H0*q0+2.D0*(light**3)*Dmin*H0
t2=SQRT(t2)
t3=light*Dmin*H0*q0

z_limit=1/(light**2)*(t1+t2+t3)
Dmin=Dmin*((1.D0+z_limit)**(-1.D0))!comoving diameter distance

Vminsat=(Dmin**3)

IF (Vminsat<Vmin) THEN
Vminsat=Vmin
END IF

V_limit=(D_limit**3)-Vminsat
vweight_i(i)=1.D0/V_limit
V_sum_i=V_sum_i+1.D0/V_limit

D_limit=dist_k_z*magabs_z(i)+dist_d_z
D_limit=10.D0**D_limit
D_limit=D_limit/1.D6



t1=(light**2)*q0-(light**2)
t2=(light**4)*(q0**2)-2.D0*(light**4)*q0+(light**4)+2.D0*(light**3)*D_limit*H0*(q0**2)
t2=t2-4.D0*(light**3)*D_limit*H0*q0+2.D0*(light**3)*D_limit*H0
t2=SQRT(t2)
t3=light*D_limit*H0*q0

z_limit=1/(light**2)*(t1+t2+t3)

IF (z_limit>zmax) THEN
z_limit=zmax
divisor=(SQRT(1.D0+2.D0*q0*z_limit)+1.D0+q0*z_limit)
D_limit=light/H0*z_limit*(1.D0+((z_limit*(1.D0-q0))/divisor))
END IF

D_limit=D_limit*((1.D0+z_limit)**(-1.D0))!comoving diameter distance


Dmin=dist_k_z*magabs_z(i)+dist_dsat_z
Dmin=10.D0**Dmin
Dmin=Dmin/1.D6

t1=(light**2)*q0-(light**2)
t2=(light**4)*(q0**2)-2.D0*(light**4)*q0+(light**4)+2.D0*(light**3)*Dmin*H0*(q0**2)
t2=t2-4.D0*(light**3)*Dmin*H0*q0+2.D0*(light**3)*Dmin*H0
t2=SQRT(t2)
t3=light*Dmin*H0*q0

z_limit=1/(light**2)*(t1+t2+t3)
Dmin=Dmin*((1.D0+z_limit)**(-1.D0))!comoving diameter distance

Vminsat=(Dmin**3)

IF (Vminsat<Vmin) THEN
Vminsat=Vmin
END IF

V_limit=(D_limit**3)-Vminsat
vweight_z(i)=1.D0/V_limit
V_sum_z=V_sum_z+1.D0/V_limit


END IF
END DO


DO i=1,n
IF (active(i)) THEN
vweight_g(i)=vweight_g(i)/V_sum_g
vweight_r(i)=vweight_r(i)/V_sum_r
vweight_i(i)=vweight_i(i)/V_sum_i
vweight_z(i)=vweight_z(i)/V_sum_z
END IF
END DO

!solar magnitudes at z=0.1 by Blanton 2003
OPEN(70,file='input/magsol.txt')
READ(70,*) mag_sol_g
READ(70,*) mag_sol_r
READ(70,*) mag_sol_i
READ(70,*) mag_sol_z
 CLOSE (70)
 
 
 
K01_g=0.D0
DO ii=0,7
DO iii=0,3
K01_g=K01_g+K_coeff_g(ii,iii)*(0.1D0**ii)*((mag_sol_g-mag_sol_r)**iii)
END DO
END DO

K01_r=0.D0
DO ii=0,5
DO iii=0,3
K01_r=K01_r+K_coeff_r(ii,iii)*(0.1D0**ii)*((mag_sol_g-mag_sol_r)**iii)
END DO
END DO

K01_i=0.D0
DO ii=0,5
DO iii=0,3
K01_i=K01_i+K_coeff_i(ii,iii)*(0.1D0**ii)*((mag_sol_g-mag_sol_i)**iii)
END DO
END DO

K01_z=0.D0
DO ii=0,5
DO iii=0,3
K01_z=K01_z+K_coeff_z(ii,iii)*(0.1D0**ii)*((mag_sol_g-mag_sol_z)**iii)
END DO
END DO
 
 
 !solar maginutde at z=0
mag_sol_g=mag_sol_g-K01_g
mag_sol_r=mag_sol_r-K01_r 
mag_sol_i=mag_sol_i-K01_i 
mag_sol_z=mag_sol_z-K01_z 
 
 
!  WRITE(*,*) mag_sol_g,mag_sol_r
 
 
DO i=1,n
IF (active(i)) THEN
lum_g(i)=10.D0**(-0.4D0*(magabs_g(i)-mag_sol_g))
lum_r(i)=10.D0**(-0.4D0*(magabs_r(i)-mag_sol_r))
lum_g_sersic(i)=10.D0**(-0.4D0*(magabs_g_sersic(i)-mag_sol_g))
lum_r_sersic(i)=10.D0**(-0.4D0*(magabs_r_sersic(i)-mag_sol_r))

lum_g_err(i)=lum_g(i)*((10.D0**magabs_g_err(i))-1.D0)
lum_r_err(i)=lum_r(i)*((10.D0**magabs_r_err(i))-1.D0)
lum_g_sersic_err(i)=lum_g_sersic(i)*((10.D0**magabs_sersic_g_err(i))-1.D0)
lum_r_sersic_err(i)=lum_r_sersic(i)*((10.D0**magabs_sersic_r_err(i))-1.D0)


log_lum_g(i)=LOG10(lum_g(i))
log_lum_r(i)=LOG10(lum_r(i))
log_lum_g_sersic(i)=LOG10(lum_g_sersic(i))
log_lum_r_sersic(i)=LOG10(lum_r_sersic(i))

log_lum_g_err(i)=magabs_g_err(i)*ABS(log_lum_g(i)/magabs_g(i))
log_lum_r_err(i)=magabs_g_err(i)*ABS(log_lum_r(i)/magabs_r(i))
log_lum_g_sersic_err(i)=magabs_sersic_g_err(i)*ABS(log_lum_g_sersic(i)/magabs_g_sersic(i))
log_lum_r_sersic_err(i)=magabs_sersic_r_err(i)*ABS(log_lum_r_sersic(i)/magabs_r_sersic(i))

END IF
END DO




DO i=1,n
IF (active(i)) THEN
ml_ratio_g(i)=M_dyn_g(i)/lum_g(i)
ml_ratio_r(i)=M_dyn_r(i)/lum_r(i)
ml_ratio_g_sersic(i)=M_dyn_g_sersic(i)/lum_g_sersic(i)
ml_ratio_r_sersic(i)=M_dyn_r_sersic(i)/lum_r_sersic(i)

ml_ratio_g_err(i)=ml_ratio_g(i)*SQRT(((M_dyn_g_err(i)/M_dyn_g(i))**2)+((lum_g_err(i)/lum_g(i))**2))
ml_ratio_r_err(i)=ml_ratio_r(i)*SQRT(((M_dyn_r_err(i)/M_dyn_r(i))**2)+((lum_r_err(i)/lum_r(i))**2))

ml_ratio_g_sersic_err(i)=ml_ratio_g_sersic(i)*&
SQRT(((M_dyn_g_sersic_err(i)/M_dyn_g_sersic(i))**2)+((lum_g_sersic_err(i)/lum_g_sersic(i))**2))

ml_ratio_r_sersic_err(i)=ml_ratio_r_sersic(i)*&
SQRT(((M_dyn_r_sersic_err(i)/M_dyn_r_sersic(i))**2)+((lum_r_sersic_err(i)/lum_r_sersic(i))**2))
END IF
END DO


DO i=1,n
IF (active(i)) THEN

M_star(i)=10.D0**new_logmstarc(i)
M_star_err(i)=M_star(i)*((10.D0**0.15D0)-1.D0)
ml_ratio_star(i)=M_star(i)/lum_r(i)
ml_ratio_star_err(i)=ml_ratio_star(i)*SQRT(((M_star_err(i)/M_star(i))**2)+((lum_r_err(i)/lum_r(i))**2))

M_star_sersic(i)=10.D0**new_logmstars(i)
M_star_sersic_err(i)=M_star_sersic(i)*((10.D0**0.15D0)-1.D0)
ml_ratio_star_sersic(i)=M_star_sersic(i)/lum_r_sersic(i)
ml_ratio_star_sersic_err(i)=ml_ratio_star_sersic(i)*&
SQRT(((M_star_sersic_err(i)/M_star_sersic(i))**2)+((lum_r_sersic_err(i)/lum_r_sersic(i))**2))
END IF
END DO







DO i=1,n
IF (active(i)) THEN

otherside_g(i)=a_g*logsigma_g(i)+b_g*logI0_g(i)+c_g
dist_fp_g(i)=a_g*logsigma_g(i)+b_g*logI0_g(i)+c_g-logR0_g(i)

otherside_r(i)=a_r*logsigma_r(i)+b_r*logI0_r(i)+c_r
dist_fp_r(i)=a_r*logsigma_r(i)+b_r*logI0_r(i)+c_r-logR0_r(i)

otherside_i(i)=a_i*logsigma_i(i)+b_i*logI0_i(i)+c_i
dist_fp_i(i)=a_i*logsigma_i(i)+b_i*logI0_i(i)+c_i-logR0_i(i)

otherside_z(i)=a_z*logsigma_z(i)+b_z*logI0_z(i)+c_z
dist_fp_z(i)=a_z*logsigma_z(i)+b_z*logI0_z(i)+c_z-logR0_z(i)

END IF
END DO






sdist_k_g=-0.2D0
sdist_k_r=-0.2D0



 hcount=0
 DO i=1,n
 IF (active(i)) THEN
 hcount=hcount+1
 helplist_g(hcount)=-magabs_g_sersic(i)*sdist_k_g+logdistlum(i)
 helplist_r(hcount)=-magabs_r_sersic(i)*sdist_k_r+logdistlum(i)

 END IF
 END DO


 DO ii=1,hcount
 DO iii=ii,hcount

 IF (helplist_g(ii)<helplist_g(iii)) THEN
 helpflip=helplist_g(ii)
 helplist_g(ii)=helplist_g(iii)
 helplist_g(iii)=helpflip
 END IF
 IF (helplist_r(ii)<helplist_r(iii)) THEN
 helpflip=helplist_r(ii)
 helplist_r(ii)=helplist_r(iii)
 helplist_r(iii)=helpflip
 END IF


 END DO
 END DO

n1percent=CEILING(DBLE(hcount)/1000.D0*3D0) !99.7% limit =~3 sigma
n_threesigma=hcount-n1percent

sdist_d_g=helplist_g(n1percent)

sdist_d_r=helplist_r(n1percent)


sdist_dsat_g=helplist_g(n_threesigma)

sdist_dsat_r=helplist_r(n_threesigma)


OPEN(70,file='output/sersic_dist_limits_for_mag.txt')
WRITE(70,*) sdist_k_g,sdist_d_g,sdist_dsat_g
WRITE(70,*) sdist_k_r,sdist_d_r,sdist_dsat_r
 CLOSE (70)


OPEN(70,file='output/sersic_dist_limits_for_mag_plot.txt')

solve_t1=1.D0/sdist_k_g
solve_t2=-sdist_d_g/sdist_k_g
solve_t3=-sdist_dsat_g/sdist_k_g
WRITE(70,*) 'sdistkg=',solve_t1
WRITE(70,*) 'sdistdg=',solve_t2
WRITE(70,*) 'sdistdsatg=',solve_t3

solve_t1=1.D0/sdist_k_r
solve_t2=-sdist_d_r/sdist_k_r
solve_t3=-sdist_dsat_r/sdist_k_r
WRITE(70,*) 'sdistkr=',solve_t1
WRITE(70,*) 'sdistdr=',solve_t2
WRITE(70,*) 'sdistdsatr=',solve_t3


 CLOSE (70)
WRITE(*,*) 'sersic parameters prepared'
WRITE(30,*) 'sersic parameters prepared'



DO i=1,n
IF (active(i)) THEN
act_fp(i)=.TRUE.
ELSE
act_fp(i)=.FALSE.
END IF
END DO


DO i=1,n
IF (active(i)) THEN

IF (zoo_el(i)<0.8) THEN
act_fp(i)=.FALSE.
END IF


! IF (veldisp(i)>420.D0) THEN
! act_fp(i)=.FALSE.
! END IF

IF (logR0_g_sersic(i)<-0.5D0) THEN
act_fp(i)=.FALSE.
END IF

IF (logR0_r_sersic(i)<-0.5D0) THEN
act_fp(i)=.FALSE.
END IF


END IF
END DO

OPEN(70,file='output/sersic_fp_3d.txt')
DO i=1,n
IF (act_fp(i)) THEN
WRITE(70,*) logR0_r_sersic(i),logsigma_r_sersic(i),logI0_r_sersic(i)
END IF
END DO
 CLOSE (70)


ee=0

sdelta_a_g=0.D0
sdelta_b_g=0.D0
sdelta_c_g=0.D0
sdelta_a_r=0.D0
sdelta_b_r=0.D0
sdelta_c_r=0.D0


 continueloop=.TRUE.
! do loop for opitmization
DO WHILE (continueloop)
ee=ee+1


V_sum_g=0.D0
V_sum_r=0.D0



DO i=1,n
IF (act_fp(i)) THEN


D_limit=sdist_k_g*magabs_g_sersic(i)+sdist_d_g
D_limit=10.D0**D_limit
D_limit=D_limit/1.D6

t1=(light**2)*q0-(light**2)
t2=(light**4)*(q0**2)-2.D0*(light**4)*q0+(light**4)+2.D0*(light**3)*D_limit*H0*(q0**2)
t2=t2-4.D0*(light**3)*D_limit*H0*q0+2.D0*(light**3)*D_limit*H0
t2=SQRT(t2)
t3=light*D_limit*H0*q0

z_limit=1/(light**2)*(t1+t2+t3)

IF (z_limit>zmax) THEN
z_limit=zmax
divisor=(SQRT(1.D0+2.D0*q0*z_limit)+1.D0+q0*z_limit)
D_limit=light/H0*z_limit*(1.D0+((z_limit*(1.D0-q0))/divisor))
END IF

D_limit=D_limit*((1.D0+z_limit)**(-1.D0))!comoving diameter distance


Dmin=sdist_k_g*magabs_g_sersic(i)+sdist_dsat_g
Dmin=10.D0**Dmin
Dmin=Dmin/1.D6

t1=(light**2)*q0-(light**2)
t2=(light**4)*(q0**2)-2.D0*(light**4)*q0+(light**4)+2.D0*(light**3)*Dmin*H0*(q0**2)
t2=t2-4.D0*(light**3)*Dmin*H0*q0+2.D0*(light**3)*Dmin*H0
t2=SQRT(t2)
t3=light*Dmin*H0*q0

z_limit=1/(light**2)*(t1+t2+t3)
Dmin=Dmin*((1.D0+z_limit)**(-1.D0))!comoving diameter distance

Vminsat=(Dmin**3)

IF (Vminsat<Vmin) THEN
Vminsat=Vmin
END IF

V_limit=(D_limit**3)-Vminsat
vweight_g_sersic(i)=1.D0/V_limit
V_sum_g=V_sum_g+1.D0/V_limit





D_limit=sdist_k_r*magabs_r_sersic(i)+sdist_d_r
D_limit=10.D0**D_limit
D_limit=D_limit/1.D6

t1=(light**2)*q0-(light**2)
t2=(light**4)*(q0**2)-2.D0*(light**4)*q0+(light**4)+2.D0*(light**3)*D_limit*H0*(q0**2)
t2=t2-4.D0*(light**3)*D_limit*H0*q0+2.D0*(light**3)*D_limit*H0
t2=SQRT(t2)
t3=light*D_limit*H0*q0

z_limit=1/(light**2)*(t1+t2+t3)

IF (z_limit>zmax) THEN
z_limit=zmax
divisor=(SQRT(1.D0+2.D0*q0*z_limit)+1.D0+q0*z_limit)
D_limit=light/H0*z_limit*(1.D0+((z_limit*(1.D0-q0))/divisor))
END IF

D_limit=D_limit*((1.D0+z_limit)**(-1.D0))!comoving diameter distance




Dmin=sdist_k_r*magabs_r_sersic(i)+sdist_dsat_r
Dmin=10.D0**Dmin
Dmin=Dmin/1.D6

t1=(light**2)*q0-(light**2)
t2=(light**4)*(q0**2)-2.D0*(light**4)*q0+(light**4)+2.D0*(light**3)*Dmin*H0*(q0**2)
t2=t2-4.D0*(light**3)*Dmin*H0*q0+2.D0*(light**3)*Dmin*H0
t2=SQRT(t2)
t3=light*Dmin*H0*q0

z_limit=1/(light**2)*(t1+t2+t3)
Dmin=Dmin*((1.D0+z_limit)**(-1.D0))!comoving diameter distance

Vminsat=(Dmin**3)

IF (Vminsat<Vmin) THEN
Vminsat=Vmin
END IF

V_limit=(D_limit**3)-Vminsat
vweight_r_sersic(i)=1.D0/V_limit
V_sum_r=V_sum_r+1.D0/V_limit

END IF
END DO


DO i=1,n
IF (act_fp(i)) THEN
vweight_g_sersic(i)=vweight_g_sersic(i)/V_sum_g
vweight_r_sersic(i)=vweight_r_sersic(i)/V_sum_r
END IF
END DO















! count galaxies still in use
galactive=0
DO i=1,n
IF (act_fp(i)) THEN
galactive=galactive+1
END IF
END DO

! WRITE(*,*) galactive


! DO i=1,n
! IF (act_fp(i)) THEN
! 
! err_g(i)=1.D0
! 
! err_r(i)=1.D0
! 
! END IF
! END DO




DO i=1,n
IF (act_fp(i)) THEN

err_g(i)=vweight_g_sersic(i)*DBLE(galactive)

err_r(i)=vweight_r_sersic(i)*DBLE(galactive)


END IF
END DO


! OPEN(70,file='weights.txt')
! DO i=1,n
! IF (act_fp(i)) THEN
! WRITE(70,*) err_g(i),err_r(i)
! END IF
! END DO
!  CLOSE (70)
! 
! 

!preparing matrizes
DO i=1,3 
Yvector_g(i)=0.D0
Yvector_r(i)=0.D0
DO ii=1,3
Amatrix_g(i,ii)=0.D0
Amatrix_r(i,ii)=0.D0
Bmatrix1_g(i,ii)=0.D0
Bmatrix2_g(i,ii)=0.D0
Bmatrix3_g(i,ii)=0.D0
Bmatrix1_r(i,ii)=0.D0
Bmatrix2_r(i,ii)=0.D0
Bmatrix3_r(i,ii)=0.D0
END DO
END DO

!calculating basic matrix und vector
DO i=1,n
IF (act_fp(i)) THEN

Amatrix_g(1,1)=Amatrix_g(1,1)+logsigma_g_sersic(i)*logsigma_g_sersic(i)*err_g(i)
Amatrix_g(2,2)=Amatrix_g(2,2)+logI0_g_sersic(i)*logI0_g_sersic(i)*err_g(i)
Amatrix_g(3,3)=Amatrix_g(3,3)+1.D0*err_g(i)
Amatrix_g(1,2)=Amatrix_g(1,2)+logsigma_g_sersic(i)*logI0_g_sersic(i)*err_g(i)
Amatrix_g(2,1)=Amatrix_g(2,1)+logsigma_g_sersic(i)*logI0_g_sersic(i)*err_g(i)
Amatrix_g(1,3)=Amatrix_g(1,3)+logsigma_g_sersic(i)*err_g(i)
Amatrix_g(3,1)=Amatrix_g(3,1)+logsigma_g_sersic(i)*err_g(i)
Amatrix_g(2,3)=Amatrix_g(2,3)+logI0_g_sersic(i)*err_g(i)
Amatrix_g(3,2)=Amatrix_g(3,2)+logI0_g_sersic(i)*err_g(i)
Yvector_g(1)=Yvector_g(1)+logR0_g_sersic(i)*logsigma_g_sersic(i)*err_g(i)
Yvector_g(2)=Yvector_g(2)+logR0_g_sersic(i)*logI0_g_sersic(i)*err_g(i)
Yvector_g(3)=Yvector_g(3)+logR0_g_sersic(i)*err_g(i)

Amatrix_r(1,1)=Amatrix_r(1,1)+logsigma_r_sersic(i)*logsigma_r_sersic(i)*err_r(i)
Amatrix_r(2,2)=Amatrix_r(2,2)+logI0_r_sersic(i)*logI0_r_sersic(i)*err_r(i)
Amatrix_r(3,3)=Amatrix_r(3,3)+1.D0*err_r(i)
Amatrix_r(1,2)=Amatrix_r(1,2)+logsigma_r_sersic(i)*logI0_r_sersic(i)*err_r(i)
Amatrix_r(2,1)=Amatrix_r(2,1)+logsigma_r_sersic(i)*logI0_r_sersic(i)*err_r(i)
Amatrix_r(1,3)=Amatrix_r(1,3)+logsigma_r_sersic(i)*err_r(i)
Amatrix_r(3,1)=Amatrix_r(3,1)+logsigma_r_sersic(i)*err_r(i)
Amatrix_r(2,3)=Amatrix_r(2,3)+logI0_r_sersic(i)*err_r(i)
Amatrix_r(3,2)=Amatrix_r(3,2)+logI0_r_sersic(i)*err_r(i)
Yvector_r(1)=Yvector_r(1)+logR0_r_sersic(i)*logsigma_r_sersic(i)*err_r(i)
Yvector_r(2)=Yvector_r(2)+logR0_r_sersic(i)*logI0_r_sersic(i)*err_r(i)
Yvector_r(3)=Yvector_r(3)+logR0_r_sersic(i)*err_r(i)


END IF
END DO

!get determinat of Amatrix


detA_g=Amatrix_g(1,1)*Amatrix_g(2,2)*Amatrix_g(3,3)
detA_g=detA_g+Amatrix_g(2,1)*Amatrix_g(3,2)*Amatrix_g(1,3)
detA_g=detA_g+Amatrix_g(1,2)*Amatrix_g(2,3)*Amatrix_g(3,1)
detA_g=detA_g-Amatrix_g(1,3)*Amatrix_g(2,2)*Amatrix_g(3,1)
detA_g=detA_g-Amatrix_g(2,1)*Amatrix_g(1,2)*Amatrix_g(3,3)
detA_g=detA_g-Amatrix_g(2,3)*Amatrix_g(3,2)*Amatrix_g(1,1)

detA_r=Amatrix_r(1,1)*Amatrix_r(2,2)*Amatrix_r(3,3)
detA_r=detA_r+Amatrix_r(2,1)*Amatrix_r(3,2)*Amatrix_r(1,3)
detA_r=detA_r+Amatrix_r(1,2)*Amatrix_r(2,3)*Amatrix_r(3,1)
detA_r=detA_r-Amatrix_r(1,3)*Amatrix_r(2,2)*Amatrix_r(3,1)
detA_r=detA_r-Amatrix_r(2,1)*Amatrix_r(1,2)*Amatrix_r(3,3)
detA_r=detA_r-Amatrix_r(2,3)*Amatrix_r(3,2)*Amatrix_r(1,1)


!calculate B matrizes
DO i=1,3
DO ii=1,3


Bmatrix1_g(i,ii)=Amatrix_g(i,ii)
Bmatrix2_g(i,ii)=Amatrix_g(i,ii)
Bmatrix3_g(i,ii)=Amatrix_g(i,ii)

Bmatrix1_r(i,ii)=Amatrix_r(i,ii)
Bmatrix2_r(i,ii)=Amatrix_r(i,ii)
Bmatrix3_r(i,ii)=Amatrix_r(i,ii)


END DO
END DO

DO i=1,3


Bmatrix1_g(1,i)=Yvector_g(i)
Bmatrix2_g(2,i)=Yvector_g(i)
Bmatrix3_g(3,i)=Yvector_g(i)

Bmatrix1_r(1,i)=Yvector_r(i)
Bmatrix2_r(2,i)=Yvector_r(i)
Bmatrix3_r(3,i)=Yvector_r(i)



END DO


! get determinat of Bmatrizes



detB1_g=Bmatrix1_g(1,1)*Bmatrix1_g(2,2)*Bmatrix1_g(3,3)
detB1_g=detB1_g+Bmatrix1_g(2,1)*Bmatrix1_g(3,2)*Bmatrix1_g(1,3)
detB1_g=detB1_g+Bmatrix1_g(1,2)*Bmatrix1_g(2,3)*Bmatrix1_g(3,1)
detB1_g=detB1_g-Bmatrix1_g(1,3)*Bmatrix1_g(2,2)*Bmatrix1_g(3,1)
detB1_g=detB1_g-Bmatrix1_g(2,1)*Bmatrix1_g(1,2)*Bmatrix1_g(3,3)
detB1_g=detB1_g-Bmatrix1_g(2,3)*Bmatrix1_g(3,2)*Bmatrix1_g(1,1)
detB2_g=Bmatrix2_g(1,1)*Bmatrix2_g(2,2)*Bmatrix2_g(3,3)
detB2_g=detB2_g+Bmatrix2_g(2,1)*Bmatrix2_g(3,2)*Bmatrix2_g(1,3)
detB2_g=detB2_g+Bmatrix2_g(1,2)*Bmatrix2_g(2,3)*Bmatrix2_g(3,1)
detB2_g=detB2_g-Bmatrix2_g(1,3)*Bmatrix2_g(2,2)*Bmatrix2_g(3,1)
detB2_g=detB2_g-Bmatrix2_g(2,1)*Bmatrix2_g(1,2)*Bmatrix2_g(3,3)
detB2_g=detB2_g-Bmatrix2_g(2,3)*Bmatrix2_g(3,2)*Bmatrix2_g(1,1)
detB3_g=Bmatrix3_g(1,1)*Bmatrix3_g(2,2)*Bmatrix3_g(3,3)
detB3_g=detB3_g+Bmatrix3_g(2,1)*Bmatrix3_g(3,2)*Bmatrix3_g(1,3)
detB3_g=detB3_g+Bmatrix3_g(1,2)*Bmatrix3_g(2,3)*Bmatrix3_g(3,1)
detB3_g=detB3_g-Bmatrix3_g(1,3)*Bmatrix3_g(2,2)*Bmatrix3_g(3,1)
detB3_g=detB3_g-Bmatrix3_g(2,1)*Bmatrix3_g(1,2)*Bmatrix3_g(3,3)
detB3_g=detB3_g-Bmatrix3_g(2,3)*Bmatrix3_g(3,2)*Bmatrix3_g(1,1)

detB1_r=Bmatrix1_r(1,1)*Bmatrix1_r(2,2)*Bmatrix1_r(3,3)
detB1_r=detB1_r+Bmatrix1_r(2,1)*Bmatrix1_r(3,2)*Bmatrix1_r(1,3)
detB1_r=detB1_r+Bmatrix1_r(1,2)*Bmatrix1_r(2,3)*Bmatrix1_r(3,1)
detB1_r=detB1_r-Bmatrix1_r(1,3)*Bmatrix1_r(2,2)*Bmatrix1_r(3,1)
detB1_r=detB1_r-Bmatrix1_r(2,1)*Bmatrix1_r(1,2)*Bmatrix1_r(3,3)
detB1_r=detB1_r-Bmatrix1_r(2,3)*Bmatrix1_r(3,2)*Bmatrix1_r(1,1)
detB2_r=Bmatrix2_r(1,1)*Bmatrix2_r(2,2)*Bmatrix2_r(3,3)
detB2_r=detB2_r+Bmatrix2_r(2,1)*Bmatrix2_r(3,2)*Bmatrix2_r(1,3)
detB2_r=detB2_r+Bmatrix2_r(1,2)*Bmatrix2_r(2,3)*Bmatrix2_r(3,1)
detB2_r=detB2_r-Bmatrix2_r(1,3)*Bmatrix2_r(2,2)*Bmatrix2_r(3,1)
detB2_r=detB2_r-Bmatrix2_r(2,1)*Bmatrix2_r(1,2)*Bmatrix2_r(3,3)
detB2_r=detB2_r-Bmatrix2_r(2,3)*Bmatrix2_r(3,2)*Bmatrix2_r(1,1)
detB3_r=Bmatrix3_r(1,1)*Bmatrix3_r(2,2)*Bmatrix3_r(3,3)
detB3_r=detB3_r+Bmatrix3_r(2,1)*Bmatrix3_r(3,2)*Bmatrix3_r(1,3)
detB3_r=detB3_r+Bmatrix3_r(1,2)*Bmatrix3_r(2,3)*Bmatrix3_r(3,1)
detB3_r=detB3_r-Bmatrix3_r(1,3)*Bmatrix3_r(2,2)*Bmatrix3_r(3,1)
detB3_r=detB3_r-Bmatrix3_r(2,1)*Bmatrix3_r(1,2)*Bmatrix3_r(3,3)
detB3_r=detB3_r-Bmatrix3_r(2,3)*Bmatrix3_r(3,2)*Bmatrix3_r(1,1)


! get solutions


 sa_g=detB1_g/detA_g
 sb_g=detB2_g/detA_g
 sc_g=detB3_g/detA_g

 sa_r=detB1_r/detA_r
 sb_r=detB2_r/detA_r
 sc_r=detB3_r/detA_r

!  WRITE(*,*) detA_g,detA_r
!    WRITE(*,*) detB1_g,detB2_g,detB3_g
!   WRITE(*,*) detB1_r,detB2_r,detB3_r
! WRITE(*,*) sa_g,sb_g,sc_g
! WRITE(*,*) sa_r,sb_r,sc_r

!calculate right side of fundamental plane
DO i=1,n
IF (act_fp(i)) THEN


sotherside_g(i)=sa_g*logsigma_g_sersic(i)+sb_g*logI0_g_sersic(i)+sc_g
sotherside_r(i)=sa_r*logsigma_r_sersic(i)+sb_r*logI0_r_sersic(i)+sc_r

END IF
END DO

! propagation of error
!root mean square
srms_g=0.D0
srms_r=0.D0

DO i=1,n
IF (act_fp(i)) THEN



sdeviation_g(i)=sotherside_g(i)-logR0_g_sersic(i)
sdeviation_r(i)=sotherside_r(i)-logR0_r_sersic(i)


srms_g=srms_g+err_g(i)*((sdeviation_g(i))**2)
srms_r=srms_r+err_r(i)*((sdeviation_r(i))**2)


END IF
END DO



srms_g=SQRT(srms_g/DBLE(galactive))
srms_r=SQRT(srms_r/DBLE(galactive))


! error of fitting parameters


 sa_err_g=(Amatrix_g(2,2)*Amatrix_g(3,3)-Amatrix_g(2,3)*Amatrix_g(3,2))/detA_g
 sa_err_g=SQRT(sa_err_g)
 sb_err_g=(Amatrix_g(1,1)*Amatrix_g(3,3)-Amatrix_g(1,3)*Amatrix_g(3,1))/detA_g
 sb_err_g=SQRT(sb_err_g)
 sc_err_g=(Amatrix_g(1,1)*Amatrix_g(2,2)-Amatrix_g(1,2)*Amatrix_g(2,1))/detA_g
 sc_err_g=SQRT(sc_err_g)

 sa_err_r=(Amatrix_r(2,2)*Amatrix_r(3,3)-Amatrix_r(2,3)*Amatrix_r(3,2))/detA_r
 sa_err_r=SQRT(sa_err_r)
 sb_err_r=(Amatrix_r(1,1)*Amatrix_r(3,3)-Amatrix_r(1,3)*Amatrix_r(3,1))/detA_r
 sb_err_r=SQRT(sb_err_r)
 sc_err_r=(Amatrix_r(1,1)*Amatrix_r(2,2)-Amatrix_r(1,2)*Amatrix_r(2,1))/detA_r
 sc_err_r=SQRT(sc_err_r)


 
 

!see if another loop is still nessecary


sdelta_a_g=sdelta_a_g-sa_g
sdelta_b_g=sdelta_b_g-sb_g
sdelta_c_g=sdelta_c_g-sc_g
sdelta_a_g=sdelta_a_g*3.D0
sdelta_b_g=sdelta_b_g*3.D0
sdelta_c_g=sdelta_c_g*3.D0
sdelta_a_g=sdelta_a_g**2
sdelta_b_g=sdelta_b_g**2
sdelta_c_g=sdelta_c_g**2

sdelta_a_r=sdelta_a_r-sa_r
sdelta_b_r=sdelta_b_r-sb_r
sdelta_c_r=sdelta_c_r-sc_r
sdelta_a_r=sdelta_a_r*3.D0
sdelta_b_r=sdelta_b_r*3.D0
sdelta_c_r=sdelta_c_r*3.D0
sdelta_a_r=sdelta_a_r**2
sdelta_b_r=sdelta_b_r**2
sdelta_c_r=sdelta_c_r**2




 continueloop=.FALSE.



IF (sdelta_a_g>(sa_err_g**2)) THEN
 continueloop=.TRUE.
END IF
IF (sdelta_b_g>(sb_err_g**2)) THEN
 continueloop=.TRUE.
END IF
IF (sdelta_c_g>(sc_err_g**2)) THEN
 continueloop=.TRUE.
END IF


IF (sdelta_a_r>(sa_err_r**2)) THEN
 continueloop=.TRUE.
END IF
IF (sdelta_b_r>(sb_err_r**2)) THEN
 continueloop=.TRUE.
END IF
IF (sdelta_c_r>(sc_err_r**2)) THEN
 continueloop=.TRUE.
END IF





sdelta_a_g=sa_g
sdelta_b_g=sb_g
sdelta_c_g=sc_g

sdelta_a_r=sa_r
sdelta_b_r=sb_r
sdelta_c_r=sc_r


IF (ee>maxloop) THEN
 continueloop=.FALSE.
END IF




IF (continueloop) THEN

!3-sigma-clipping
DO i=1,n
IF (act_fp(i)) THEN


IF ((sdeviation_g(i)**2.D0)>((3.D0*srms_g)**2.D0)) THEN
act_fp(i)=.FALSE.
END IF

IF ((sdeviation_r(i)**2.D0)>((3.D0*srms_r)**2.D0)) THEN
act_fp(i)=.FALSE.
END IF

END IF
END DO
WRITE(*,*) '3-sigma clipping done'
WRITE(30,*) '3-sigma clipping done'



! count galaxies still in use
galactive=0
DO i=1,n
IF (act_fp(i)) THEN
galactive=galactive+1
END IF
END DO
WRITE(*,*) 'basis data selection improved for the ',ee,' time'
WRITE(*,*) 'redo fitting with ',galactive,' galaxies'
WRITE(30,*) 'basis data selection improved for the ',ee,' time'
WRITE(30,*) 'redo fitting with ',galactive,' galaxies'





END IF

! end long loop
END DO
 
 
 
 galactive=0
DO i=1,n
IF (act_fp(i)) THEN
galactive=galactive+1
END IF
END DO
 
 

WRITE(*,*) 'final fp fit with ',galactive,' galaxies'
WRITE(30,*) 'final fp fit with ',galactive,' galaxies'
 
 

WRITE(*,*) 'fitting the fundamental plane completed'
WRITE(30,*) 'fitting the fundamental plane completed'



! output fitparameter results
OPEN(60,file='output/fitparameters_sersic.txt')


WRITE(60,*) sa_g,sb_g,sc_g
WRITE(60,*) sa_err_g,sb_err_g,sc_err_g,srms_g
WRITE(60,*) sa_r,sb_r,sc_r
WRITE(60,*) sa_err_r,sb_err_r,sc_err_r,srms_r


 CLOSE(60)



  OPEN(52,file='output/fp_3rms_sersic.txt')

WRITE(52,*) 'rms_sersic=',3.D0*srms_r

 CLOSE(52)
 
 
 


DO i=1,n
IF (act_fp(i)) THEN

sfp_dist_g(i)=sa_g*logsigma_g_sersic(i)+sb_g*logI0_g_sersic(i)+sc_g
sfp_dist_r(i)=sa_r*logsigma_r_sersic(i)+sb_r*logI0_r_sersic(i)+sc_r

END IF
END DO

DO i=1,n
IF (act_fp(i)) THEN

sfp_dist_g(i)=(10.D0**sfp_dist_g(i))/TAN(alpha_g_sersic(i))
sfp_dist_r(i)=(10.D0**sfp_dist_r(i))/TAN(alpha_r_sersic(i))

END IF
END DO

! 
!total

sfp_dist_err_g=0.D0
sfp_dist_err_r=0.D0


DO i=1,n
IF (act_fp(i)) THEN

sfp_dist_err_g=sfp_dist_err_g+((distance(i)-sfp_dist_g(i))/(distance(i)))**2
sfp_dist_err_r=sfp_dist_err_r+((distance(i)-sfp_dist_r(i))/(distance(i)))**2
END IF
END DO


sfp_dist_err_g=SQRT(sfp_dist_err_g/DBLE(galactive))
sfp_dist_err_r=SQRT(sfp_dist_err_r/DBLE(galactive))





OPEN(61,file='output/fp_rel_dist_err_sersic.txt')
WRITE(61,*) sfp_dist_err_g,sfp_dist_err_r
 CLOSE(61)




 
DO i=1,n
IF (active(i)) THEN


sotherside_g(i)=sa_g*logsigma_g_sersic(i)+sb_g*logI0_g_sersic(i)+sc_g
sotherside_r(i)=sa_r*logsigma_r_sersic(i)+sb_r*logI0_r_sersic(i)+sc_r

END IF
END DO






galactive=0
DO i=1,n
IF (active(i)) THEN
galactive=galactive+1
END IF
END DO



DO i=1,n
IF (active(i).eqv..FALSE.) THEN
act(i)=.FALSE.

END IF
END DO

WRITE(*,*) galactive,'galaxies left after filtering'
WRITE(30,*) galactive,'galaxies left after filtering'






hcount=0


DO i=1,n
act_taylor(i)=.FALSE.
act_crossmatchtaylor(i)=.FALSE.
taylor_id_sample(i)=0
END DO


! WRITE(*,*) arcsec
DO ii=1,n_taylor
! WRITE(*,*) taylor_ra(ii),taylor_dec(ii)
DO i=1,n
IF (active(i)) THEN

angular_sep=COS(dec(i)*PI/180.D0)*COS(taylor_dec(ii)*PI/180.D0)*COS((taylor_ra(ii)-RA(i))*PI/180.D0)
angular_sep=angular_sep+SIN(dec(i)*PI/180.D0)*SIN(taylor_dec(ii)*PI/180.D0)
angular_sep=ACOS(angular_sep)*180.D0/PI

IF (angular_sep<0.D0) THEN
angular_sep=-angular_sep
END IF
 
 
 IF (angular_sep<(2.D0*arcsec)) THEN
act_taylor(i)=.TRUE.
taylor_id_sample(i)=ii
! WRITE(*,*) i
hcount=hcount+1

END IF
END IF
END DO
END DO
WRITE(*,*) hcount,'galaxies from Taylor 2010 in our sample'


hcount=0

DO i=1,n
act_trujillo(i)=.FALSE.
act_crossmatchtrujillo(i)=.FALSE.
trujillo_id_sample(i)=0
END DO



! WRITE(*,*) arcsec
DO ii=1,n_trujillo
! WRITE(*,*) taylor_ra(ii),taylor_dec(ii)
DO i=1,n
IF (active(i)) THEN

angular_sep=COS(dec(i)*PI/180.D0)*COS(trujillo_dec(ii)*PI/180.D0)*COS((trujillo_ra(ii)-RA(i))*PI/180.D0)
angular_sep=angular_sep+SIN(dec(i)*PI/180.D0)*SIN(trujillo_dec(ii)*PI/180.D0)
angular_sep=ACOS(angular_sep)*180.D0/PI

IF (angular_sep<0.D0) THEN
angular_sep=-angular_sep
END IF
 
 
 IF (angular_sep<(2.D0*arcsec)) THEN
act_trujillo(i)=.TRUE.
trujillo_id_sample(i)=trujillo_id(ii)
! WRITE(*,*) i
hcount=hcount+1

END IF
END IF
END DO
END DO
WRITE(*,*) hcount,'galaxies from Trujillo 2009 in our sample'




hcount=0




 
av_ml=0.D0
sigma_ml=0.D0
av_ml_biascor=0.D0
sigma_ml_biascor=0.D0
h_sum=0.D0
h_sum_biascor=0.D0
DO i=1,n
IF (act(i)) THEN
av_ml=av_ml+LOG10(ml_ratio_star(i))
av_ml_biascor=av_ml_biascor+LOG10(ml_ratio_star(i))*vweight_r(i)
h_sum=h_sum+1.D0
h_sum_biascor=h_sum_biascor+vweight_r(i)
END IF
END DO

av_ml=av_ml/h_sum
av_ml_biascor=av_ml_biascor/h_sum_biascor
DO i=1,n
IF (act(i)) THEN
sigma_ml=sigma_ml+((LOG10(ml_ratio_star(i))-av_ml)**2)/h_sum
sigma_ml_biascor=sigma_ml_biascor+((LOG10(ml_ratio_star(i))-av_ml_biascor)**2)*vweight_r(i)
END IF
END DO

sigma_ml=SQRT(sigma_ml)
sigma_ml_biascor=SQRT(sigma_ml_biascor)

! WRITE(*,*) sigma_ml
! WRITE(*,*) sigma_ml_biascor

OPEN(61,file='output/av_ml_star.txt')
WRITE(61,*) 'av_ml=',(10**av_ml)
WRITE(61,*) 'av_ml_biascor=',(10**av_ml_biascor)
WRITE(61,*) 'logav_ml=',av_ml
WRITE(61,*) 'logav_ml_biascor=',av_ml_biascor
WRITE(61,*) 'logav_ml_biascor_high=',av_ml_biascor+3.D0*sigma_ml_biascor
WRITE(61,*) 'logav_ml_biascor_low=',av_ml_biascor-3.D0*sigma_ml_biascor
WRITE(61,*) 'sigma_ml=',(10**sigma_ml)-1.D0
 CLOSE(61)

 

av_ml=0.D0
sigma_ml=0.D0
av_ml_biascor=0.D0
sigma_ml_biascor=0.D0
h_sum=0.D0
h_sum_biascor=0.D0
DO i=1,n
IF (act(i)) THEN
av_ml=av_ml+LOG10(ml_ratio_r(i))
av_ml_biascor=av_ml_biascor+LOG10(ml_ratio_r(i))*vweight_r(i)
h_sum=h_sum+1.D0
h_sum_biascor=h_sum_biascor+vweight_r(i)
END IF
END DO

av_ml=av_ml/h_sum
av_ml_biascor=av_ml_biascor/h_sum_biascor

DO i=1,n
IF (act(i)) THEN
sigma_ml=sigma_ml+((LOG10(ml_ratio_r(i))-av_ml)**2)/h_sum
sigma_ml_biascor=sigma_ml_biascor+((LOG10(ml_ratio_r(i))-av_ml_biascor)**2)*vweight_r(i)
END IF
END DO

sigma_ml=SQRT(sigma_ml)
sigma_ml_biascor=SQRT(sigma_ml_biascor)

! WRITE(*,*) sigma_ml
! WRITE(*,*) sigma_ml_biascor

OPEN(61,file='output/av_ml.txt')
WRITE(61,*) 'av_ml=',(10**av_ml)
WRITE(61,*) 'av_ml_biascor=',(10**av_ml_biascor)
WRITE(61,*) 'logav_ml=',av_ml
WRITE(61,*) 'logav_ml_biascor=',av_ml_biascor
WRITE(61,*) 'logav_ml_biascor_high=',av_ml_biascor+3.D0*sigma_ml_biascor
WRITE(61,*) 'logav_ml_biascor_low=',av_ml_biascor-3.D0*sigma_ml_biascor
WRITE(61,*) 'sigma_ml=',(10**sigma_ml)-1.D0
 CLOSE(61)

V_sum_g=0.D0
V_sum_r=0.D0



DO i=1,n
IF (act(i)) THEN


D_limit=sdist_k_g*magabs_g_sersic(i)+sdist_d_g
D_limit=10.D0**D_limit
D_limit=D_limit/1.D6

t1=(light**2)*q0-(light**2)
t2=(light**4)*(q0**2)-2.D0*(light**4)*q0+(light**4)+2.D0*(light**3)*D_limit*H0*(q0**2)
t2=t2-4.D0*(light**3)*D_limit*H0*q0+2.D0*(light**3)*D_limit*H0
t2=SQRT(t2)
t3=light*D_limit*H0*q0

z_limit=1/(light**2)*(t1+t2+t3)

IF (z_limit>zmax) THEN
z_limit=zmax
divisor=(SQRT(1.D0+2.D0*q0*z_limit)+1.D0+q0*z_limit)
D_limit=light/H0*z_limit*(1.D0+((z_limit*(1.D0-q0))/divisor))
END IF

D_limit=D_limit*((1.D0+z_limit)**(-1.D0))!comoving diameter distance




Dmin=sdist_k_g*magabs_g_sersic(i)+sdist_dsat_g
Dmin=10.D0**Dmin
Dmin=Dmin/1.D6

t1=(light**2)*q0-(light**2)
t2=(light**4)*(q0**2)-2.D0*(light**4)*q0+(light**4)+2.D0*(light**3)*Dmin*H0*(q0**2)
t2=t2-4.D0*(light**3)*Dmin*H0*q0+2.D0*(light**3)*Dmin*H0
t2=SQRT(t2)
t3=light*Dmin*H0*q0

z_limit=1/(light**2)*(t1+t2+t3)
Dmin=Dmin*((1.D0+z_limit)**(-1.D0))!comoving diameter distance

Vminsat=(Dmin**3)

IF (Vminsat<Vmin) THEN
Vminsat=Vmin
END IF

V_limit=(D_limit**3)-Vminsat
vweight_g_sersic(i)=1.D0/V_limit
V_sum_g=V_sum_g+1.D0/V_limit





D_limit=sdist_k_r*magabs_r_sersic(i)+sdist_d_r
D_limit=10.D0**D_limit
D_limit=D_limit/1.D6

t1=(light**2)*q0-(light**2)
t2=(light**4)*(q0**2)-2.D0*(light**4)*q0+(light**4)+2.D0*(light**3)*D_limit*H0*(q0**2)
t2=t2-4.D0*(light**3)*D_limit*H0*q0+2.D0*(light**3)*D_limit*H0
t2=SQRT(t2)
t3=light*D_limit*H0*q0

z_limit=1/(light**2)*(t1+t2+t3)

IF (z_limit>zmax) THEN
z_limit=zmax
divisor=(SQRT(1.D0+2.D0*q0*z_limit)+1.D0+q0*z_limit)
D_limit=light/H0*z_limit*(1.D0+((z_limit*(1.D0-q0))/divisor))
END IF

D_limit=D_limit*((1.D0+z_limit)**(-1.D0))!comoving diameter distance




Dmin=sdist_k_r*magabs_r_sersic(i)+sdist_dsat_r
Dmin=10.D0**Dmin
Dmin=Dmin/1.D6

t1=(light**2)*q0-(light**2)
t2=(light**4)*(q0**2)-2.D0*(light**4)*q0+(light**4)+2.D0*(light**3)*Dmin*H0*(q0**2)
t2=t2-4.D0*(light**3)*Dmin*H0*q0+2.D0*(light**3)*Dmin*H0
t2=SQRT(t2)
t3=light*Dmin*H0*q0

z_limit=1/(light**2)*(t1+t2+t3)
Dmin=Dmin*((1.D0+z_limit)**(-1.D0))!comoving diameter distance

Vminsat=(Dmin**3)

IF (Vminsat<Vmin) THEN
Vminsat=Vmin
END IF

V_limit=(D_limit**3)-Vminsat
vweight_r_sersic(i)=1.D0/V_limit
V_sum_r=V_sum_r+1.D0/V_limit

END IF
END DO


DO i=1,n
IF (act(i)) THEN
vweight_g_sersic(i)=vweight_g_sersic(i)/V_sum_g
vweight_r_sersic(i)=vweight_r_sersic(i)/V_sum_r
END IF
END DO




av_ml=0.D0
sigma_ml=0.D0
av_ml_biascor=0.D0
sigma_ml_biascor=0.D0
h_sum=0.D0
h_sum_biascor=0.D0
DO i=1,n
IF (act(i)) THEN
av_ml=av_ml+LOG10(ml_ratio_r_sersic(i))
av_ml_biascor=av_ml_biascor+LOG10(ml_ratio_r_sersic(i))*vweight_r(i)
h_sum=h_sum+1.D0
h_sum_biascor=h_sum_biascor+vweight_r_sersic(i)
END IF
END DO

av_ml=av_ml/h_sum
av_ml_biascor=av_ml_biascor/h_sum_biascor

DO i=1,n
IF (act(i)) THEN
sigma_ml=sigma_ml+((LOG10(ml_ratio_r_sersic(i))-av_ml)**2)/h_sum
sigma_ml_biascor=sigma_ml_biascor+((LOG10(ml_ratio_r_sersic(i))-av_ml_biascor)**2)*vweight_r(i)
END IF
END DO

sigma_ml=SQRT(sigma_ml)
sigma_ml_biascor=SQRT(sigma_ml_biascor)

! WRITE(*,*) sigma_ml
! WRITE(*,*) sigma_ml_biascor

OPEN(61,file='output/av_ml_sersic.txt')
WRITE(61,*) 'av_ml_sersic=',(10**av_ml)
WRITE(61,*) 'av_ml_biascor_sersic=',(10**av_ml_biascor)
WRITE(61,*) 'logav_ml_sersic=',av_ml
WRITE(61,*) 'logav_ml_biascor_sersic=',av_ml_biascor
WRITE(61,*) 'logav_ml_biascor_high_sersic=',av_ml_biascor+3.D0*sigma_ml_biascor
WRITE(61,*) 'logav_ml_biascor_low_sersic=',av_ml_biascor-3.D0*sigma_ml_biascor
 CLOSE(61)



 
 
 
 
 
 
 
 
DO i=0,500
DO ii=0,400
mapmap(i,ii)=0
END DO
END DO



DO i=1,n
IF (act(i)) THEN

help_x=NINT(((Mag_app_g(i)-Mag_app_r(i))-0.25D0)*300.D0)
help_y=NINT((ml_ratio_star(i))*50.D0)
IF ((help_x>0).AND.(help_x<400)) THEN
IF ((help_y>0).AND.(help_y<400)) THEN
mapmap(help_x,help_y)=mapmap(help_x,help_y)+1
END IF
END IF

END IF
END DO

OPEN(61,file='output/colour_MLstar_dV_map.txt')
DO i=0,400
DO ii=0,400
help_x2=((DBLE(i)/300.D0)+0.25D0)
help_y2=((DBLE(ii)/50.D0))
WRITE(61,*) help_x2,help_y2,LOG10(mapmap(i,ii)+1)
END DO
END DO
 CLOSE(61)



DO i=0,500
DO ii=0,400
mapmap(i,ii)=0
END DO
END DO



DO i=1,n
IF (act(i)) THEN

help_x=NINT(((Mag_app_g_sersic(i)-Mag_app_r_sersic(i))-0.25D0)*300.D0)
help_y=NINT((ml_ratio_star_sersic(i))*50.D0)
IF ((help_x>0).AND.(help_x<400)) THEN
IF ((help_y>0).AND.(help_y<400)) THEN
mapmap(help_x,help_y)=mapmap(help_x,help_y)+1
END IF
END IF

END IF
END DO

OPEN(61,file='output/colour_MLstar_S_map.txt')
DO i=0,400
DO ii=0,400
help_x2=((DBLE(i)/300.D0)+0.25D0)
help_y2=((DBLE(ii)/50.D0))
WRITE(61,*) help_x2,help_y2,LOG10(mapmap(i,ii)+1)
END DO
END DO
 CLOSE(61)


 
 
 
 
 
 
 
 
 
 
 
 
DO i=0,500
DO ii=0,400
mapmap(i,ii)=0
END DO
END DO



DO i=1,n
IF (act(i)) THEN

help_x=NINT((logsigma_r(i)-2.D0)*500.D0)
help_y=NINT(((log_M_dyn_r(i)-new_logmstarc(i))+0.5D0)*200.D0)
IF ((help_x>0).AND.(help_x<350)) THEN
IF ((help_y>0).AND.(help_y<350)) THEN
mapmap(help_x,help_y)=mapmap(help_x,help_y)+1
END IF
END IF

END IF
END DO

OPEN(61,file='output/sigma_mstar_mdyn_dV_map.txt')
DO i=0,350
DO ii=0,350
help_x2=((DBLE(i)/500.D0)+2.D0)
help_y2=((DBLE(ii)/200.D0)-0.5D0)
WRITE(61,*) help_x2,help_y2,LOG10(mapmap(i,ii)+1)
END DO
END DO
 CLOSE(61)



DO i=0,500
DO ii=0,400
mapmap(i,ii)=0
END DO
END DO



DO i=1,n
IF (act(i)) THEN

help_x=NINT((logsigma_r_sersic(i)-2.D0)*500.D0)
help_y=NINT(((log_M_dyn_r_sersic(i)-new_logmstars(i))+0.5D0)*200.D0)
IF ((help_x>0).AND.(help_x<350)) THEN
IF ((help_y>0).AND.(help_y<350)) THEN
mapmap(help_x,help_y)=mapmap(help_x,help_y)+1
END IF
END IF

END IF
END DO

OPEN(61,file='output/sigma_mstar_mdyn_S_map.txt')
DO i=0,350
DO ii=0,350
help_x2=((DBLE(i)/500.D0)+2.D0)
help_y2=((DBLE(ii)/200.D0)-0.5D0)
WRITE(61,*) help_x2,help_y2,LOG10(mapmap(i,ii)+1)
END DO
END DO
 CLOSE(61)


 
 
 
 
 
DO i=0,500
DO ii=0,400
mapmap(i,ii)=0
END DO
END DO



DO i=1,n
IF (act(i)) THEN

help_x=NINT((new_logmstarc(i)-9.5D0)*100.D0)
help_y=NINT((logR0_r(i)+0.5D0)*100.D0)
IF ((help_x>0).AND.(help_x<300)) THEN
IF ((help_y>0).AND.(help_y<250)) THEN
mapmap(help_x,help_y)=mapmap(help_x,help_y)+1
END IF
END IF

END IF
END DO

OPEN(61,file='output/mstar_R0_dV_map.txt')
DO i=0,300
DO ii=0,250
help_x2=((DBLE(i)/100.D0)+9.5D0)
help_y2=((DBLE(ii)/100.D0)-0.5D0)
WRITE(61,*) help_x2,help_y2,LOG10(mapmap(i,ii)+1)
END DO
END DO
 CLOSE(61)


 
 
  
DO i=0,500
DO ii=0,400
mapmap(i,ii)=0
END DO
END DO



DO i=1,n
IF (act(i)) THEN

help_x=NINT((new_logmstars(i)-9.5D0)*100.D0)
help_y=NINT((logR0_r_sersic(i)+0.5D0)*100.D0)
IF ((help_x>0).AND.(help_x<300)) THEN
IF ((help_y>0).AND.(help_y<250)) THEN
mapmap(help_x,help_y)=mapmap(help_x,help_y)+1
END IF
END IF

END IF
END DO

OPEN(61,file='output/mstar_R0_S_map.txt')
DO i=0,300
DO ii=0,250
help_x2=((DBLE(i)/100.D0)+9.5D0)
help_y2=((DBLE(ii)/100.D0)-0.5D0)
WRITE(61,*) help_x2,help_y2,LOG10(mapmap(i,ii)+1)
END DO
END DO
 CLOSE(61)


 
 
 
 
 
  
DO i=0,500
DO ii=0,400
mapmap(i,ii)=0
END DO
END DO



DO i=1,n
IF (act(i)) THEN

help_x=NINT((logsigma_r(i)-2.D0)*300.D0)
help_y=NINT(ml_ratio_r(i)*10.D0)
IF ((help_x>0).AND.(help_x<300)) THEN
IF ((help_y>0).AND.(help_y<300)) THEN
mapmap(help_x,help_y)=mapmap(help_x,help_y)+1
END IF
END IF

END IF
END DO

OPEN(61,file='output/sigma_ML_dyn_dV.txt')
DO i=0,300
DO ii=0,300
help_x2=((DBLE(i)/300.D0)+2.D0)
help_y2=((DBLE(ii)/10.D0))
WRITE(61,*) help_x2,help_y2,LOG10(mapmap(i,ii)+1)
END DO
END DO
 CLOSE(61)


 
 
  
DO i=0,500
DO ii=0,400
mapmap(i,ii)=0
END DO
END DO



DO i=1,n
IF (act(i)) THEN

help_x=NINT((logsigma_r_sersic(i)-2.D0)*300.D0)
help_y=NINT(ml_ratio_r_sersic(i)*10.D0)
IF ((help_x>0).AND.(help_x<300)) THEN
IF ((help_y>0).AND.(help_y<300)) THEN
mapmap(help_x,help_y)=mapmap(help_x,help_y)+1
END IF
END IF

END IF
END DO

OPEN(61,file='output/sigma_ML_dyn_S.txt')
DO i=0,300
DO ii=0,300
help_x2=((DBLE(i)/300.D0)+2.D0)
help_y2=((DBLE(ii)/10.D0))
WRITE(61,*) help_x2,help_y2,LOG10(mapmap(i,ii)+1)
END DO
END DO
 CLOSE(61)


  
 
DO i=0,500
DO ii=0,400
mapmap(i,ii)=0
END DO
END DO



DO i=1,n
IF (act(i)) THEN

help_x=NINT((logsigma_r(i)-2.D0)*300.D0)
help_y=NINT(ml_ratio_star(i)*20.D0)
IF ((help_x>0).AND.(help_x<300)) THEN
IF ((help_y>0).AND.(help_y<300)) THEN
mapmap(help_x,help_y)=mapmap(help_x,help_y)+1
END IF
END IF

END IF
END DO

OPEN(61,file='output/sigma_ML_star_dV.txt')
DO i=0,300
DO ii=0,300
help_x2=((DBLE(i)/300.D0)+2.D0)
help_y2=((DBLE(ii)/20.D0))
WRITE(61,*) help_x2,help_y2,LOG10(mapmap(i,ii)+1)
END DO
END DO
 CLOSE(61)


 
 
  
DO i=0,500
DO ii=0,400
mapmap(i,ii)=0
END DO
END DO



DO i=1,n
IF (act(i)) THEN

help_x=NINT((logsigma_r_sersic(i)-2.D0)*300.D0)
help_y=NINT(ml_ratio_star_sersic(i)*20.D0)
IF ((help_x>0).AND.(help_x<300)) THEN
IF ((help_y>0).AND.(help_y<300)) THEN
mapmap(help_x,help_y)=mapmap(help_x,help_y)+1
END IF
END IF

END IF
END DO

OPEN(61,file='output/sigma_ML_star_S.txt')
DO i=0,300
DO ii=0,300
help_x2=((DBLE(i)/300.D0)+2.D0)
help_y2=((DBLE(ii)/20.D0))
WRITE(61,*) help_x2,help_y2,LOG10(mapmap(i,ii)+1)
END DO
END DO
 CLOSE(61)


 
 
 
 
 
DO i=0,500
DO ii=0,400
mapmap(i,ii)=0
END DO
END DO

DO i=1,n
IF (act(i)) THEN


help_x=NINT((log_M_dyn_r(i)-9.5D0)*100.D0)
help_y=NINT((new_logmstarc(i)-9.5D0)*100.D0)
IF ((help_x>0).AND.(help_x<400)) THEN
IF ((help_y>0).AND.(help_y<400)) THEN
mapmap(help_x,help_y)=mapmap(help_x,help_y)+1
END IF
END IF

END IF
END DO

OPEN(61,file='output/Mdyn_Mstar_dV_map.txt')
DO i=0,400
DO ii=0,400
help_x2=((DBLE(i)/100.D0)+9.5D0)
help_y2=((DBLE(ii)/100.D0)+9.5D0)
WRITE(61,*) help_x2,help_y2,LOG10(mapmap(i,ii)+1)
END DO
END DO
 CLOSE(61)
 
 
DO i=0,500
DO ii=0,400
mapmap(i,ii)=0
END DO
END DO

DO i=1,n
IF (act(i)) THEN


help_x=NINT((log_M_dyn_r_sersic(i)-9.5D0)*100.D0)
help_y=NINT((new_logmstars(i)-9.5D0)*100.D0)
IF ((help_x>0).AND.(help_x<400)) THEN
IF ((help_y>0).AND.(help_y<400)) THEN
mapmap(help_x,help_y)=mapmap(help_x,help_y)+1
END IF
END IF

END IF
END DO

OPEN(61,file='output/Mdyn_Mstar_S_map.txt')
DO i=0,400
DO ii=0,400
help_x2=((DBLE(i)/100.D0)+9.5D0)
help_y2=((DBLE(ii)/100.D0)+9.5D0)
WRITE(61,*) help_x2,help_y2,LOG10(mapmap(i,ii)+1)
END DO
END DO
 CLOSE(61)
 
 
  
 
 
 
 
 
DO i=0,500
DO ii=0,400
mapmap(i,ii)=0
END DO
END DO



DO i=1,n
IF (act(i)) THEN


help_x=NINT((magabs_r(i)+25.D0)*50.D0)
help_y=NINT((logR0_r(i)+0.5D0)*100.D0)
IF ((help_x>0).AND.(help_x<300)) THEN
IF ((help_y>0).AND.(help_y<300)) THEN
mapmap(help_x,help_y)=mapmap(help_x,help_y)+1
END IF
END IF

END IF
END DO

OPEN(61,file='output/mag_R0_map_dV.txt')
DO i=0,300
DO ii=0,300
help_x2=((DBLE(i)/50.D0)-25.D0)
help_y2=((DBLE(ii)/100.D0)-0.5D0)
WRITE(61,*) help_x2,help_y2,LOG10(mapmap(i,ii)+1)
END DO
END DO
 CLOSE(61)

 
 
 
DO i=0,500
DO ii=0,400
mapmap(i,ii)=0
END DO
END DO



DO i=1,n
IF (act(i)) THEN


help_x=NINT((magabs_r_sersic(i)+25.D0)*50.D0)
help_y=NINT((logR0_r_sersic(i)+0.5D0)*100.D0)
IF ((help_x>0).AND.(help_x<300)) THEN
IF ((help_y>0).AND.(help_y<300)) THEN
mapmap(help_x,help_y)=mapmap(help_x,help_y)+1
END IF
END IF

END IF
END DO

OPEN(61,file='output/mag_R0_map_S.txt')
DO i=0,300
DO ii=0,300
help_x2=((DBLE(i)/50.D0)-25.D0)
help_y2=((DBLE(ii)/100.D0)-0.5D0)
WRITE(61,*) help_x2,help_y2,LOG10(mapmap(i,ii)+1)
END DO
END DO
 CLOSE(61)

 
  
 
 
  
DO i=0,500
DO ii=0,400
mapmap(i,ii)=0
END DO
END DO


DO i=1,n
IF (act(i)) THEN


help_x=NINT((log_M_dyn_r(i)-10.D0)*100.D0)
help_y=NINT((log_lum_r(i)-9.5D0)*100.D0)
IF ((help_x>0).AND.(help_x<300)) THEN
IF ((help_y>0).AND.(help_y<250)) THEN
mapmap(help_x,help_y)=mapmap(help_x,help_y)+1
END IF
END IF

END IF
END DO

OPEN(61,file='output/mass_luminosity_map_dV.txt')
DO i=0,300
DO ii=0,250
help_x2=((DBLE(i)/100.D0)+10.D0)
help_y2=((DBLE(ii)/100.D0)+9.5D0)
WRITE(61,*) help_x2,help_y2,LOG10(mapmap(i,ii)+1)
END DO
END DO
 CLOSE(61)

 
DO i=0,500
DO ii=0,400
mapmap(i,ii)=0
END DO
END DO


DO i=1,n
IF (act(i)) THEN


help_x=NINT((log_M_dyn_r_sersic(i)-10.D0)*100.D0)
help_y=NINT((log_lum_r_sersic(i)-9.5D0)*100.D0)
IF ((help_x>0).AND.(help_x<300)) THEN
IF ((help_y>0).AND.(help_y<250)) THEN
mapmap(help_x,help_y)=mapmap(help_x,help_y)+1
END IF
END IF

END IF
END DO

OPEN(61,file='output/mass_luminosity_map_S.txt')
DO i=0,300
DO ii=0,250
help_x2=((DBLE(i)/100.D0)+10.D0)
help_y2=((DBLE(ii)/100.D0)+9.5D0)
WRITE(61,*) help_x2,help_y2,LOG10(mapmap(i,ii)+1)
END DO
END DO
 CLOSE(61)

 
 
DO i=0,500
DO ii=0,400
mapmap(i,ii)=0
END DO
END DO


DO i=1,n
IF (act(i)) THEN

help_x=NINT((log_M_dyn_r(i)-10.D0)*100.D0)
help_y=NINT((logR0_r(i)+0.5D0)*100.D0)
IF ((help_x>0).AND.(help_x<300)) THEN
IF ((help_y>0).AND.(help_y<250)) THEN
mapmap(help_x,help_y)=mapmap(help_x,help_y)+1
END IF
END IF

END IF
END DO

OPEN(61,file='output/R0_vs_M_dyn_map_dV.txt')
DO i=0,300
DO ii=0,250
help_x2=((DBLE(i)/100.D0)+10.D0)
help_y2=((DBLE(ii)/100.D0)-0.5D0)
WRITE(61,*) help_x2,help_y2,LOG10(mapmap(i,ii)+1)
END DO
END DO
 CLOSE(61)

 

 
DO i=0,500
DO ii=0,400
mapmap(i,ii)=0
END DO
END DO


DO i=1,n
IF (act(i)) THEN

help_x=NINT((log_M_dyn_r_sersic(i)-10.D0)*100.D0)
help_y=NINT((logR0_r_sersic(i)+0.5D0)*100.D0)
IF ((help_x>0).AND.(help_x<300)) THEN
IF ((help_y>0).AND.(help_y<250)) THEN
mapmap(help_x,help_y)=mapmap(help_x,help_y)+1
END IF
END IF

END IF
END DO

OPEN(61,file='output/R0_vs_M_dyn_map_S.txt')
DO i=0,300
DO ii=0,250
help_x2=((DBLE(i)/100.D0)+10.D0)
help_y2=((DBLE(ii)/100.D0)-0.5D0)
WRITE(61,*) help_x2,help_y2,LOG10(mapmap(i,ii)+1)
END DO
END DO
 CLOSE(61)

 

 


DO i=0,500
DO ii=0,400
mapmap(i,ii)=0
END DO
END DO



DO i=1,n
IF (act(i)) THEN

help_x=NINT((logdistlum(i)-7.5D0)*250.D0)
help_y=NINT((-magabs_r(i)-17.D0)*50.D0)
IF ((help_x>0).AND.(help_x<500)) THEN
IF ((help_y>0).AND.(help_y<400)) THEN
mapmap(help_x,help_y)=mapmap(help_x,help_y)+1
END IF
END IF

END IF
END DO

OPEN(61,file='output/absmag_vs_lumdist_dV.txt')
DO i=0,500
DO ii=0,400
help_x2=((DBLE(i))/250.D0)+7.5D0
help_y2=-((DBLE(ii))/50.D0)-17.D0
WRITE(61,*) help_x2,help_y2,LOG10(mapmap(i,ii)+1)
END DO
END DO
 CLOSE(61)


 
 av_mm_basic=0.D0
  hhcount_g=0
 DO i=1,n
IF (act(i)) THEN
hhcount_g=hhcount_g+1
 av_mm_basic=av_mm_basic+LOG10(M_dyn_r(i)/M_star(i))
 END IF
 END DO
  av_mm_basic=av_mm_basic/DBLE(hhcount_g)
 
 av_mm_high_int=0.D0
   hhcount_g=0
 DO i=1,n
IF (act(i)) THEN
IF (sigma_cor_r(i)>mmsigma_min) THEN
IF (sigma_cor_r(i)<mmsigma_max) THEN
hhcount_g=hhcount_g+1
 av_mm_high_int=av_mm_high_int+LOG10(M_dyn_r(i)/M_star(i))
 END IF
 END IF 
 END IF
 END DO
  av_mm_high_int=av_mm_high_int/DBLE(hhcount_g)
 

 
 hhcount_g=0
 
 DO i=0,20
ml_basic_bin(i)=0.D0
END DO

DO i=1,n

IF (act(i)) THEN
hhcount_g=hhcount_g+1
DO ii=0,20
binhelp=DBLE(ii)
IF ((ml_ratio_r(i)>(binhelp-0.5)).AND.(ml_ratio_r(i)<(binhelp+0.5))) THEN
ml_basic_bin(ii)=ml_basic_bin(ii)+1.D0
END IF
END DO
END IF

END DO

DO i=0,20
ml_basic_bin(i)=ml_basic_bin(i)/DBLE(hhcount_g)
END DO

OPEN(70,file='output/ml_basic_bin.txt')
DO i=0,20
binhelp=DBLE(i)
WRITE(70,*) binhelp,ml_basic_bin(i)
END DO
 CLOSE (70)

  
 hhcount_g=0
 
 
  DO i=0,20
ml_basic_bin(i)=0.D0
END DO

DO i=1,n

IF (act(i)) THEN
hhcount_g=hhcount_g+1
DO ii=0,20
binhelp=DBLE(ii)
IF ((ml_ratio_r_sersic(i)>(binhelp-0.5)).AND.(ml_ratio_r_sersic(i)<(binhelp+0.5))) THEN
ml_basic_bin(ii)=ml_basic_bin(ii)+1.D0
END IF
END DO
END IF

END DO

DO i=0,20
ml_basic_bin(i)=ml_basic_bin(i)/DBLE(hhcount_g)
END DO

OPEN(70,file='output/ml_basic_bin_sersic.txt')
DO i=0,20
binhelp=DBLE(i)
WRITE(70,*) binhelp,ml_basic_bin(i)
END DO
 CLOSE (70)

 
 
 
 
 
 hhcount_g=0
 
 DO i=0,20
ml_basic_bin(i)=0.D0
END DO

DO i=1,n

IF (act(i)) THEN
hhcount_g=hhcount_g+1
DO ii=0,20
binhelp=DBLE(ii)/2.D0
IF ((ml_ratio_star(i)>(binhelp-0.25)).AND.(ml_ratio_star(i)<(binhelp+0.25))) THEN
ml_basic_bin(ii)=ml_basic_bin(ii)+1.D0
END IF
END DO
END IF

END DO

DO i=0,20
ml_basic_bin(i)=ml_basic_bin(i)/DBLE(hhcount_g)
END DO

OPEN(70,file='output/ml_star_basic_bin.txt')
DO i=0,20
binhelp=DBLE(i)/2.D0
WRITE(70,*) binhelp,ml_basic_bin(i)
END DO
 CLOSE (70)

 
  
 hhcount_g=0
 
  DO i=0,20
ml_basic_bin(i)=0.D0
END DO

DO i=1,n

IF (act(i)) THEN
hhcount_g=hhcount_g+1
DO ii=0,20
binhelp=DBLE(ii)/2.D0
IF ((ml_ratio_star_sersic(i)>(binhelp-0.25)).AND.(ml_ratio_star_sersic(i)<(binhelp+0.25))) THEN
ml_basic_bin(ii)=ml_basic_bin(ii)+1.D0
END IF
END DO
END IF

END DO

DO i=0,20
ml_basic_bin(i)=ml_basic_bin(i)/DBLE(hhcount_g)
END DO

OPEN(70,file='output/ml_star_basic_bin_sersic.txt')
DO i=0,20
binhelp=DBLE(i)/2.D0
WRITE(70,*) binhelp,ml_basic_bin(i)
END DO
 CLOSE (70)

 
 
 
 

DO i=0,500
DO ii=0,400
mapmap(i,ii)=0
END DO
END DO



DO i=1,n
IF (act(i)) THEN

help_x=NINT((logdistlum(i)-7.5D0)*250.D0)
help_y=NINT((-magabs_r_sersic(i)-17.D0)*50.D0)
IF ((help_x>0).AND.(help_x<500)) THEN
IF ((help_y>0).AND.(help_y<400)) THEN
mapmap(help_x,help_y)=mapmap(help_x,help_y)+1
END IF
END IF

END IF
END DO

OPEN(61,file='output/absmag_vs_lumdist_S.txt')
DO i=0,500
DO ii=0,400
help_x2=((DBLE(i))/250.D0)+7.5D0
help_y2=-((DBLE(ii))/50.D0)-17.D0
WRITE(61,*) help_x2,help_y2,LOG10(mapmap(i,ii)+1)
END DO
END DO
 CLOSE(61)


 
 
 
 
 
 
 
 
 
 
 
 
 


DO i=0,500
DO ii=0,400
mapmap(i,ii)=0
END DO
END DO




DO i=1,n
IF (act(i)) THEN

help_x=NINT((logR0_r_sersic(i)+0.5D0)*200.D0)
help_y=NINT((logsigma_r_sersic(i)-2.D0)*500.D0)
IF ((help_x>0).AND.(help_x<500)) THEN
IF ((help_y>0).AND.(help_y<400)) THEN
mapmap(help_x,help_y)=mapmap(help_x,help_y)+1
END IF
END IF

END IF
END DO

OPEN(61,file='output/sersic_logR0_vs_logsimga_map.txt')
DO i=0,500
DO ii=0,400
help_x2=(DBLE(i)/200.D0)-0.5D0
help_y2=(DBLE(ii)/500.D0)+2.D0
WRITE(61,*) help_x2,help_y2,LOG10(mapmap(i,ii)+1)
END DO
END DO
 CLOSE(61)
 
 
 







DO i=0,500
DO ii=0,400
mapmap(i,ii)=0
END DO
END DO




DO i=1,n
IF (act(i)) THEN

help_x=NINT((logR0_r(i)+0.5D0)*250.D0)
help_y=NINT((logsigma_r(i)-2.D0)*500.D0)
IF ((help_x>0).AND.(help_x<500)) THEN
IF ((help_y>0).AND.(help_y<400)) THEN
mapmap(help_x,help_y)=mapmap(help_x,help_y)+1
END IF
END IF

END IF
END DO

OPEN(61,file='output/dV_logR0_vs_logsimga_map.txt')
DO i=0,500
DO ii=0,400
help_x2=(DBLE(i)/250.D0)-0.5D0
help_y2=(DBLE(ii)/500.D0)+2.D0
WRITE(61,*) help_x2,help_y2,LOG10(mapmap(i,ii)+1)
END DO
END DO
 CLOSE(61)


 
 
 DO i=0,500
DO ii=0,500
mapmap(i,ii)=0
END DO
END DO




DO i=1,n
IF (act(i)) THEN

help_x=NINT((logR0_r(i)+0.5D0)*200.D0)
help_y=NINT((otherside_r(i)+0.5D0)*200.D0)
IF ((help_x>0).AND.(help_x<500)) THEN
IF ((help_y>0).AND.(help_y<400)) THEN
mapmap(help_x,help_y)=mapmap(help_x,help_y)+1
END IF
END IF

END IF
END DO

OPEN(61,file='output/dV_fp_map.txt')
DO i=0,500
DO ii=0,500
help_x2=(DBLE(i)/200.D0)-0.5D0
help_y2=(DBLE(ii)/200.D0)-0.5D0
WRITE(61,*) help_x2,help_y2,LOG10(mapmap(i,ii)+1)
END DO
END DO
 CLOSE(61)
 

 
 
 DO i=0,500
DO ii=0,500
mapmap(i,ii)=0
END DO
END DO




DO i=1,n
IF (act(i)) THEN

help_x=NINT((logR0_r_sersic(i)+0.5D0)*200.D0)
help_y=NINT((sotherside_r(i)+0.5D0)*200.D0)
IF ((help_x>0).AND.(help_x<500)) THEN
IF ((help_y>0).AND.(help_y<500)) THEN
mapmap(help_x,help_y)=mapmap(help_x,help_y)+1
END IF
END IF

END IF
END DO

OPEN(61,file='output/S_fp_map.txt')
DO i=0,500
DO ii=0,500
help_x2=(DBLE(i)/200.D0)-0.5D0
help_y2=(DBLE(ii)/200.D0)-0.5D0
WRITE(61,*) help_x2,help_y2,LOG10(mapmap(i,ii)+1)
END DO
END DO
 CLOSE(61)
 
 
  
 DO i=0,500
DO ii=0,500
mapmap(i,ii)=0
END DO
END DO




DO i=1,n
IF (act(i)) THEN

help_x=NINT((logR0_g_sersic(i)+0.5D0)*200.D0)
help_y=NINT((sotherside_g(i)+0.5D0)*200.D0)
IF ((help_x>0).AND.(help_x<500)) THEN
IF ((help_y>0).AND.(help_y<500)) THEN
mapmap(help_x,help_y)=mapmap(help_x,help_y)+1
END IF
END IF

END IF
END DO

OPEN(61,file='output/S_fp_map_g.txt')
DO i=0,500
DO ii=0,500
help_x2=(DBLE(i)/200.D0)-0.5D0
help_y2=(DBLE(ii)/200.D0)-0.5D0
WRITE(61,*) help_x2,help_y2,LOG10(mapmap(i,ii)+1)
END DO
END DO
 CLOSE(61)
 
 
 
 
 
 
 
 DO i=0,500
DO ii=0,500
mapmap(i,ii)=0
END DO
END DO




DO i=1,n
IF (act_fp(i)) THEN

help_x=NINT((logR0_r_sersic(i)+0.5D0)*200.D0)
help_y=NINT((sotherside_r(i)+0.5D0)*200.D0)
IF ((help_x>0).AND.(help_x<500)) THEN
IF ((help_y>0).AND.(help_y<500)) THEN
mapmap(help_x,help_y)=mapmap(help_x,help_y)+1
END IF
END IF

END IF
END DO

OPEN(61,file='output/S_fp_map_used_r.txt')
DO i=0,500
DO ii=0,500
help_x2=(DBLE(i)/200.D0)-0.5D0
help_y2=(DBLE(ii)/200.D0)-0.5D0
WRITE(61,*) help_x2,help_y2,mapmap(i,ii)
END DO
END DO
 CLOSE(61)
 
 
  
 DO i=0,500
DO ii=0,500
mapmap(i,ii)=0
END DO
END DO




DO i=1,n
IF (act_fp(i)) THEN

help_x=NINT((logR0_g_sersic(i)+0.5D0)*200.D0)
help_y=NINT((sotherside_g(i)+0.5D0)*200.D0)
IF ((help_x>0).AND.(help_x<500)) THEN
IF ((help_y>0).AND.(help_y<500)) THEN
mapmap(help_x,help_y)=mapmap(help_x,help_y)+1
END IF
END IF

END IF
END DO

OPEN(61,file='output/S_fp_map_used_g.txt')
DO i=0,500
DO ii=0,500
help_x2=(DBLE(i)/200.D0)-0.5D0
help_y2=(DBLE(ii)/200.D0)-0.5D0
WRITE(61,*) help_x2,help_y2,mapmap(i,ii)
END DO
END DO
 CLOSE(61)
 
 
 
 
 
 
 
 


  DO i=0,500
DO ii=0,500
mapmap(i,ii)=0
END DO
END DO

DO i=1,n
IF (act(i)) THEN

help_x=NINT((-magabs_z(i)-19.D0)*83.D0)
help_y=NINT(((Mag_app_g(i)-Mag_app_r(i))-0.25D0)*320.D0)
IF ((help_x>0).AND.(help_x<500)) THEN
IF ((help_y>0).AND.(help_y<400)) THEN
mapmap(help_x,help_y)=mapmap(help_x,help_y)+1
END IF
END IF

END IF
END DO

OPEN(61,file='output/CMD_map.txt')
DO i=0,500
DO ii=0,400
help_x2=-(DBLE(i)/83.D0)-19.D0
help_y2=(DBLE(ii)/320.D0)+0.25D0
WRITE(61,*) help_x2,help_y2,LOG10(mapmap(i,ii)+1)
END DO
END DO
 CLOSE(61)

 
 
   DO i=0,500
DO ii=0,500
mapmap(i,ii)=0
END DO
END DO

DO i=1,n
IF (act(i)) THEN

help_x=NINT(z_cor(i)*500.D0)
help_y=NINT((logR0_r(i)+0.4D0)*200.D0)
IF ((help_x>0).AND.(help_x<300)) THEN
IF ((help_y>0).AND.(help_y<400)) THEN
mapmap(help_x,help_y)=mapmap(help_x,help_y)+1
END IF
END IF

END IF
END DO

OPEN(61,file='output/z_vs_size.txt')
DO i=0,500
DO ii=0,400
help_x2=(DBLE(i)/500.D0)
help_y2=(DBLE(ii)/200.D0)-0.4D0
WRITE(61,*) help_x2,help_y2,LOG10(mapmap(i,ii)+1)
END DO
END DO
 CLOSE(61)

 
 
 
   DO i=0,500
DO ii=0,500
mapmap(i,ii)=0
END DO
END DO

DO i=1,n
IF (act(i)) THEN
IF (new_logmstarc(i)>10.75) THEN
help_x=NINT(z_cor(i)*500.D0)
help_y=NINT((logR0_r(i)+0.4D0)*200.D0)
IF ((help_x>0).AND.(help_x<300)) THEN
IF ((help_y>0).AND.(help_y<400)) THEN
mapmap(help_x,help_y)=mapmap(help_x,help_y)+1
END IF
END IF
END IF

END IF
END DO

OPEN(61,file='output/z_vs_size_massive.txt')
DO i=0,500
DO ii=0,400
help_x2=(DBLE(i)/500.D0)
help_y2=(DBLE(ii)/200.D0)-0.4D0
WRITE(61,*) help_x2,help_y2,LOG10(mapmap(i,ii)+1)
END DO
END DO
 CLOSE(61)

 
   DO i=0,500
DO ii=0,500
mapmap(i,ii)=0
END DO
END DO

DO i=1,n
IF (act(i)) THEN
IF (new_logmstarc(i)>10.75) THEN
IF (new_logmstarc(i)<11.25) THEN
help_x=NINT(z_cor(i)*500.D0)
help_y=NINT((logR0_r(i)+0.4D0)*200.D0)
IF ((help_x>0).AND.(help_x<300)) THEN
IF ((help_y>0).AND.(help_y<400)) THEN
mapmap(help_x,help_y)=mapmap(help_x,help_y)+1
END IF
END IF
END IF
END IF

END IF
END DO

OPEN(61,file='output/z_vs_size_range.txt')
DO i=0,500
DO ii=0,400
help_x2=(DBLE(i)/500.D0)
help_y2=(DBLE(ii)/200.D0)-0.4D0
WRITE(61,*) help_x2,help_y2,LOG10(mapmap(i,ii)+1)
END DO
END DO
 CLOSE(61)

 
!  OPEN(50,file='input/candels_fit.txt')
! READ(50,*) 
! DO i=1,6
! READ(50,*) chandels_z(i),candels_m1075(i),candels_m1125(i)
! END DO
!  CLOSE(50)
!  
! 
! 
! ! do linear fit for dependence
! zbar=0.D0
! 
! dbar_g=0.D0
! dbar_r=0.D0
! dbar_i=0.D0
! dbar_z=0.D0
! 
! 
! DO i=1,n
! IF (active(i)) THEN
! weightzcor(i)=1.D0/DBLE(galactive)
! weight_g(i)=1.D0/DBLE(galactive)
! weight_r(i)=1.D0/DBLE(galactive)
! weight_i(i)=1.D0/DBLE(galactive)
! weight_z(i)=1.D0/DBLE(galactive)
! END IF
! END DO
! 
! 
! IF (weight_switch==1) THEN
! DO i=1,n
! IF (active(i)) THEN
! weightzcor(i)=1.D0/DBLE(galactive)
! weight_g(i)=volume_weight_g(i)
! weight_r(i)=volume_weight_r(i)
! weight_i(i)=volume_weight_i(i)
! weight_z(i)=volume_weight_z(i)
! END IF
! END DO
! 
! 
! END IF
! 
! 
! 
! 
! weight_sum2_g=0.D0
! weight_sum2_r=0.D0
! weight_sum2_i=0.D0
! weight_sum2_z=0.D0
! 
! DO i=1,n
! IF (active(i)) THEN
! weight_sum2_g=weight_sum2_g+(weight_g(i)**2)
! weight_sum2_r=weight_sum2_r+(weight_r(i)**2)
! weight_sum2_i=weight_sum2_i+(weight_i(i)**2)
! weight_sum2_z=weight_sum2_z+(weight_z(i)**2)
! END IF
! END DO
! 
! 
! 
! 
! DO i=1,n
! IF (active(i)) THEN
! zbar=zbar+z_cor(i)*weightzcor(i)
! dbar_g=dbar_g+magabs_g(i)*weight_g(i)
! dbar_r=dbar_r+magabs_r(i)*weight_r(i)
! dbar_i=dbar_i+magabs_i(i)*weight_i(i)
! dbar_z=dbar_z+magabs_z(i)*weight_z(i)
! END IF
! END DO
! 
! 
!  
!  
!  
!  
!  
!  
!  
!  
!  
!  
!  
!  
!  
!  
!  
!  
!  
!  
 

WRITE(*,*) 'general output written'
WRITE(30,*) 'general output written'
 


 
 hhcount_g=0
 

 DO i=0,8
sersic_index_bin(i)=0.D0
END DO

DO i=1,n_sersic


IF (sersic_active(i)) THEN
hhcount_g=hhcount_g+1
DO ii=0,8
binhelp=DBLE(ii)
IF ((sersic_index(i)>(binhelp-0.5)).AND.(sersic_index(i)<(binhelp+0.5))) THEN
sersic_index_bin(ii)=sersic_index_bin(ii)+1.D0
END IF
END DO
END IF


END DO


DO i=0,8


sersic_index_bin(i)=sersic_index_bin(i)/DBLE(hhcount_g)

END DO


OPEN(70,file='output/sersic_all_bin.txt')
DO i=0,8
binhelp=DBLE(i)

WRITE(70,*) binhelp,sersic_index_bin(i)



END DO
 CLOSE (70)


 
 hhcount_g=0
 

 DO i=0,8
sersic_index_bin(i)=0.D0
END DO

DO i=1,n


IF (act(i)) THEN
hhcount_g=hhcount_g+1
DO ii=0,8
binhelp=DBLE(ii)
IF ((new_sersic_index(i)>(binhelp-0.5)).AND.(new_sersic_index(i)<(binhelp+0.5))) THEN
sersic_index_bin(ii)=sersic_index_bin(ii)+1.D0
END IF
END DO
END IF


END DO


DO i=0,8


sersic_index_bin(i)=sersic_index_bin(i)/DBLE(hhcount_g)

END DO


OPEN(70,file='output/sersic_bin.txt')
DO i=0,8
binhelp=DBLE(i)
WRITE(70,*) binhelp,sersic_index_bin(i)
END DO
 CLOSE (70)

 
 
 
 hhcount_g=0
 hhcount_r=0
 hhcount_i=0
 hhcount_z=0
 
 

 DO i=0,20
magabs_bin_g(i)=0.D0
magabs_bin_r(i)=0.D0
magabs_bin_i(i)=0.D0
magabs_bin_z(i)=0.D0
END DO

DO i=1,n



IF (act(i)) THEN
hhcount_r=hhcount_r+1
DO ii=0,20
binhelp=-DBLE(ii)/2.D0-15.D0
IF ((magabs_r(i)>(binhelp-0.25)).AND.(magabs_r(i)<(binhelp+0.25))) THEN
magabs_bin_r(ii)=magabs_bin_r(ii)+1.D0
END IF
END DO
END IF

END DO


DO i=0,20



magabs_bin_r(i)=magabs_bin_r(i)/DBLE(hhcount_r)


END DO


OPEN(70,file='output/magabs_binned.txt')
DO i=0,20
binhelp=-DBLE(i)/2.D0-15.D0


WRITE(70,*) binhelp,magabs_bin_r(i)


END DO
 CLOSE (70)

 
 
  
 hhcount_g=0
 hhcount_r=0
 hhcount_i=0
 hhcount_z=0
 




 hcount=0
DO i=1,n
IF (act(i)) THEN
hcount=hcount+1
END IF
END DO
 

R0_bar_g=0.D0
R0_bar_r=0.D0
R0_bar_i=0.D0
R0_bar_z=0.D0
DO i=1,n
IF (act(i)) THEN
R0_bar_g=R0_bar_g+logR0_g(i)
R0_bar_r=R0_bar_r+logR0_r(i)
R0_bar_i=R0_bar_i+logR0_i(i)
R0_bar_z=R0_bar_z+logR0_z(i)
END IF
END DO
R0_bar_g=R0_bar_g/DBLE(hcount)
R0_bar_r=R0_bar_r/DBLE(hcount)
R0_bar_i=R0_bar_i/DBLE(hcount)
R0_bar_z=R0_bar_z/DBLE(hcount)


R0_sigma_g=0.D0
R0_sigma_r=0.D0
R0_sigma_i=0.D0
R0_sigma_z=0.D0
DO i=1,n
IF (act(i)) THEN
R0_sigma_g=R0_sigma_g+((logR0_g(i)-R0_bar_g)**2)
R0_sigma_r=R0_sigma_r+((logR0_r(i)-R0_bar_r)**2)
R0_sigma_i=R0_sigma_i+((logR0_i(i)-R0_bar_i)**2)
R0_sigma_z=R0_sigma_z+((logR0_z(i)-R0_bar_z)**2)
END IF
END DO
logR_2_g=R0_sigma_g
logR_2_r=R0_sigma_r
logR_2_i=R0_sigma_i
logR_2_z=R0_sigma_z
R0_sigma_g=SQRT(R0_sigma_g/DBLE(hcount))
R0_sigma_r=SQRT(R0_sigma_r/DBLE(hcount))
R0_sigma_i=SQRT(R0_sigma_i/DBLE(hcount))
R0_sigma_z=SQRT(R0_sigma_z/DBLE(hcount))



sigma_bar_g=0.D0
sigma_bar_r=0.D0
sigma_bar_i=0.D0
sigma_bar_z=0.D0
DO i=1,n
IF (act(i)) THEN
sigma_bar_g=sigma_bar_g+logsigma_g(i)
sigma_bar_r=sigma_bar_r+logsigma_r(i)
sigma_bar_i=sigma_bar_i+logsigma_i(i)
sigma_bar_z=sigma_bar_z+logsigma_z(i)
END IF
END DO
sigma_bar_g=sigma_bar_g/DBLE(hcount)
sigma_bar_r=sigma_bar_r/DBLE(hcount)
sigma_bar_i=sigma_bar_i/DBLE(hcount)
sigma_bar_z=sigma_bar_z/DBLE(hcount)


sigma_sigma_g=0.D0
sigma_sigma_r=0.D0
sigma_sigma_i=0.D0
sigma_sigma_z=0.D0
DO i=1,n
IF (act(i)) THEN
sigma_sigma_g=sigma_sigma_g+((logsigma_g(i)-sigma_bar_g)**2)
sigma_sigma_r=sigma_sigma_r+((logsigma_r(i)-sigma_bar_r)**2)
sigma_sigma_i=sigma_sigma_i+((logsigma_i(i)-sigma_bar_i)**2)
sigma_sigma_z=sigma_sigma_z+((logsigma_z(i)-sigma_bar_z)**2)
END IF
END DO
sigma_sigma_g=SQRT(sigma_sigma_g/DBLE(hcount))
sigma_sigma_r=SQRT(sigma_sigma_r/DBLE(hcount))
sigma_sigma_i=SQRT(sigma_sigma_i/DBLE(hcount))
sigma_sigma_z=SQRT(sigma_sigma_z/DBLE(hcount))





help_sum2_g=0.D0
help_sum2_r=0.D0
help_sum2_i=0.D0
help_sum2_z=0.D0

DO i=1,n
IF (act(i)) THEN
help_sum2_g=help_sum2_g+(logsigma_g(i)-sigma_bar_g)*(logR0_g(i)-R0_bar_g)
help_sum2_r=help_sum2_r+(logsigma_r(i)-sigma_bar_r)*(logR0_r(i)-R0_bar_r)
help_sum2_i=help_sum2_i+(logsigma_i(i)-sigma_bar_i)*(logR0_i(i)-R0_bar_i)
help_sum2_z=help_sum2_z+(logsigma_z(i)-sigma_bar_z)*(logR0_z(i)-R0_bar_z)
END IF
END DO



devfitk_g=help_sum2_g/logR_2_g
devfitk_r=help_sum2_r/logR_2_r
devfitk_i=help_sum2_i/logR_2_i
devfitk_z=help_sum2_z/logR_2_z


devfitd_g=sigma_bar_g-devfitk_g*R0_bar_g
devfitd_r=sigma_bar_r-devfitk_r*R0_bar_r
devfitd_i=sigma_bar_i-devfitk_i*R0_bar_i
devfitd_z=sigma_bar_z-devfitk_z*R0_bar_z




devRMS_g=0.D0
devRMS_r=0.D0
devRMS_i=0.D0
devRMS_z=0.D0



DO i=1,n
IF (act(i)) THEN
devRMS_g=devRMS_g+((logsigma_g(i)-devfitk_g*logR0_g(i)-devfitd_g)**2.D0)
devRMS_r=devRMS_r+((logsigma_r(i)-devfitk_r*logR0_r(i)-devfitd_r)**2.D0)
devRMS_i=devRMS_i+((logsigma_i(i)-devfitk_i*logR0_i(i)-devfitd_i)**2.D0)
devRMS_z=devRMS_z+((logsigma_z(i)-devfitk_z*logR0_z(i)-devfitd_z)**2.D0)
END IF
END DO
devRMS_g=SQRT(devRMS_g/DBLE(hcount))
devRMS_r=SQRT(devRMS_r/DBLE(hcount))
devRMS_i=SQRT(devRMS_i/DBLE(hcount))
devRMS_z=SQRT(devRMS_z/DBLE(hcount))


 comp_d_g=devfitd_g+min_corr_dev*devRMS_g
 comp_d_r=devfitd_r+min_corr_dev*devRMS_r
 comp_d_i=devfitd_i+min_corr_dev*devRMS_i
 comp_d_z=devfitd_z+min_corr_dev*devRMS_z


OPEN(61,file='output/kd.txt')

WRITE(61,*) devfitk_r
WRITE(61,*) comp_d_r


CLOSE(61)

OPEN(61,file='output/kd_fit.txt')


WRITE(61,*) 'kfit=',devfitk_r
WRITE(61,*) 'dfit=',comp_d_r


CLOSE(61)









 hcount=0
DO i=1,n
IF (act(i)) THEN
hcount=hcount+1
END IF
END DO








R0_bar_g_sersic=0.D0
R0_bar_r_sersic=0.D0
DO i=1,n
IF (act(i)) THEN
R0_bar_g_sersic=R0_bar_g_sersic+logR0_g_sersic(i)
R0_bar_r_sersic=R0_bar_r_sersic+logR0_r_sersic(i)

END IF
END DO
R0_bar_g_sersic=R0_bar_g_sersic/DBLE(hcount)
R0_bar_r_sersic=R0_bar_r_sersic/DBLE(hcount)


R0_sigma_g_sersic=0.D0
R0_sigma_r_sersic=0.D0
DO i=1,n
IF (act(i)) THEN
R0_sigma_g_sersic=R0_sigma_g_sersic+((logR0_g_sersic(i)-R0_bar_g_sersic)**2)
R0_sigma_r_sersic=R0_sigma_r_sersic+((logR0_r_sersic(i)-R0_bar_r_sersic)**2)
END IF
END DO
logR_2_g_sersic=R0_sigma_g_sersic
logR_2_r_sersic=R0_sigma_r_sersic
R0_sigma_g_sersic=SQRT(R0_sigma_g_sersic/DBLE(hcount))
R0_sigma_r_sersic=SQRT(R0_sigma_r_sersic/DBLE(hcount))

! WRITE(*,*) R0_bar_r_sersic,R0_sigma_r_sersic

sigma_bar_g_sersic=0.D0
sigma_bar_r_sersic=0.D0
DO i=1,n
IF (act(i)) THEN
sigma_bar_g_sersic=sigma_bar_g_sersic+logsigma_g_sersic(i)
sigma_bar_r_sersic=sigma_bar_r_sersic+logsigma_r_sersic(i)
END IF
END DO
sigma_bar_g_sersic=sigma_bar_g_sersic/DBLE(hcount)
sigma_bar_r_sersic=sigma_bar_r_sersic/DBLE(hcount)



sigma_sigma_g_sersic=0.D0
sigma_sigma_r_sersic=0.D0
DO i=1,n
IF (act(i)) THEN
sigma_sigma_g_sersic=sigma_sigma_g_sersic+((logsigma_g_sersic(i)-sigma_bar_g_sersic)**2)
sigma_sigma_r_sersic=sigma_sigma_r_sersic+((logsigma_r_sersic(i)-sigma_bar_r_sersic)**2)
END IF
END DO
sigma_sigma_g_sersic=SQRT(sigma_sigma_g_sersic/DBLE(hcount))
sigma_sigma_r_sersic=SQRT(sigma_sigma_r_sersic/DBLE(hcount))

! WRITE(*,*) sigma_bar_r_sersic,sigma_sigma_r_sersic

help_sum2_g=0.D0
help_sum2_r=0.D0


DO i=1,n
IF (act(i)) THEN
help_sum2_g=help_sum2_g+(logsigma_g_sersic(i)-sigma_bar_g_sersic)*(logR0_g_sersic(i)-R0_bar_g_sersic)
help_sum2_r=help_sum2_r+(logsigma_r_sersic(i)-sigma_bar_r_sersic)*(logR0_r_sersic(i)-R0_bar_r_sersic)
END IF
END DO



devfitk_g_sersic=help_sum2_g/logR_2_g_sersic
devfitk_r_sersic=help_sum2_r/logR_2_r_sersic

devfitd_g_sersic=sigma_bar_g_sersic-devfitk_g_sersic*R0_bar_g_sersic
devfitd_r_sersic=sigma_bar_r_sersic-devfitk_r_sersic*R0_bar_r_sersic




devRMS_g_sersic=0.D0
devRMS_r_sersic=0.D0


DO i=1,n
IF (act(i)) THEN
devRMS_g_sersic=devRMS_g_sersic+((logsigma_g_sersic(i)-devfitk_g_sersic*logR0_g_sersic(i)-devfitd_g_sersic)**2.D0)
devRMS_r_sersic=devRMS_r_sersic+((logsigma_r_sersic(i)-devfitk_r_sersic*logR0_r_sersic(i)-devfitd_r_sersic)**2.D0)
END IF
END DO
devRMS_g_sersic=SQRT(devRMS_g_sersic/DBLE(hcount))
devRMS_r_sersic=SQRT(devRMS_r_sersic/DBLE(hcount))


 comp_d_g_sersic=devfitd_g_sersic+min_corr_dev*devRMS_g_sersic
 comp_d_r_sersic=devfitd_r_sersic+min_corr_dev*devRMS_r_sersic


OPEN(61,file='output/kd_sersic.txt')

WRITE(61,*) devfitk_r_sersic
WRITE(61,*) comp_d_r_sersic


CLOSE(61)

OPEN(61,file='output/kd_fit_sersic.txt')


WRITE(61,*) 'kfit_sersic=',devfitk_r_sersic
WRITE(61,*) 'dfit_sersic=',comp_d_r_sersic


CLOSE(61)















WRITE(*,*) 'distribution of parameters analysed'
WRITE(30,*) 'distribution of parameters analysed'




OPEN(61,file='output/logR0_cutoff_plot.txt')

WRITE(61,*) 'R0_cut=',R0_bar_r-min_R0_dev*R0_sigma_r

CLOSE(61)
OPEN(61,file='output/logsigma0_cutoff_plot.txt')


WRITE(61,*) 'sigma_cut=',sigma_bar_r+min_sigma_dev*sigma_sigma_r

CLOSE(61)



OPEN(61,file='output/logR0_cutoff_plot_sersic.txt')

WRITE(61,*) 'R0_cut_sersic=',R0_bar_r_sersic-min_R0_dev*R0_sigma_r_sersic

CLOSE(61)
OPEN(61,file='output/logsigma0_cutoff_plot_sersic.txt')


WRITE(61,*) 'sigma_cut_sersic=',sigma_bar_r_sersic+min_sigma_dev*sigma_sigma_r_sersic

CLOSE(61)








DO i=0,10
ba_ratio_all(i)=0.D0
END DO

DO i=1,n 
IF (act(i)) THEN
DO ii=1,10
IF ((ba_r(i).GE.(DBLE(ii-1)/10.D0)).AND.(ba_r(i).LE.(DBLE(ii)/10.D0))) THEN
ba_ratio_all(ii)=ba_ratio_all(ii)+1.D0
END IF
END DO
END IF
END DO

iii=0
DO i=1,n 
IF (act(i)) THEN
iii=iii+1
END IF
END DO

DO i=1,10
ba_ratio_all(i)=ba_ratio_all(i)/DBLE(iii)
END DO



OPEN(80,file='output/bin_ba_ratios_all.txt')
DO i=1,10
WRITE(80,*) ((DBLE(i)/10.D0)-0.05D0),ba_ratio_all(i)
END DO
CLOSE(80)




DO i=1,n
IF (act(i)) THEN
act_old(i)=.TRUE.
act_dV(i)=.TRUE.
act_S(i)=.TRUE.
ELSE
act_dV(i)=.FALSE.
act_S(i)=.FALSE.
act_old(i)=.FALSE.
END IF
END DO




DO i=1,n

IF (logR0_r(i)>(R0_bar_r-min_R0_dev*R0_sigma_r)) THEN
act_dV(i)=.FALSE.
END IF

IF (logsigma_r(i)<(sigma_bar_r+min_sigma_dev*sigma_sigma_r)) THEN
act_dV(i)=.FALSE.
END IF

IF ((logsigma_r(i)-logR0_r(i)*devfitk_r)<comp_d_r) THEN
act_dV(i)=.FALSE.
END IF

END DO

DO i=1,n

IF (logR0_r_sersic(i)>(R0_bar_r_sersic-min_R0_dev*R0_sigma_r_sersic)) THEN
act_S(i)=.FALSE.
END IF

IF (logsigma_r_sersic(i)<(sigma_bar_r_sersic+min_sigma_dev*sigma_sigma_r_sersic)) THEN
act_S(i)=.FALSE.
END IF

IF ((logsigma_r_sersic(i)-logR0_r_sersic(i)*devfitk_r_sersic)<comp_d_r_sersic) THEN
act_S(i)=.FALSE.
END IF

END DO


DO i=1,n
act(i)=.FALSE.

IF (act_dv(i)) THEN
act(i)=.TRUE.
END IF

IF (act_S(i)) THEN
act(i)=.TRUE.
END IF

END DO


WRITE(*,*) 'filtering for candidates completed'
WRITE(30,*) 'filtering for candidates completed'



OPEN(61,file='output/cand_logR0_vs_logsimga.txt')
DO i=1,n
IF (act_dV(i)) THEN
WRITE(61,*) logR0_r(i),logsigma_r(i),i
END IF
END DO
CLOSE(61)

OPEN(61,file='output/cand_fp.tx')
DO i=1,n
IF (act_dV(i)) THEN
WRITE(61,*) logR0_r(i),otherside_r(i),i
END IF
END DO
CLOSE(61)

OPEN(61,file='output/scand_logR0_vs_logsimga.txt')
DO i=1,n
IF (act_S(i)) THEN
WRITE(61,*) logR0_r(i),logsigma_r(i),i
END IF
END DO
CLOSE(61)

OPEN(61,file='output/scand_fp.txt')
DO i=1,n
IF (act_S(i)) THEN
WRITE(61,*) logR0_r(i),otherside_r(i),i
END IF
END DO
CLOSE(61)



OPEN(61,file='output/cand_zoo.txt')
DO i=1,n
IF (act_dV(i)) THEN
WRITE(61,*) logR0_r(i),logsigma_r(i),zoo_el(i),zoo_nvote(i),i
END IF
END DO
CLOSE(61)




OPEN(61,file='output/cand_logR0_sersic_vs_logsimga_sersic.txt')
DO i=1,n
IF (act_dV(i)) THEN
WRITE(61,*) logR0_r_sersic(i),logsigma_r_sersic(i),i
END IF
END DO
CLOSE(61)

OPEN(61,file='output/cand_fp_sersic.txt')
DO i=1,n
IF (act_dV(i)) THEN
WRITE(61,*) logR0_r_sersic(i),sotherside_r(i),i
END IF
END DO
CLOSE(61)

OPEN(61,file='output/scand_logR0_sersic_vs_logsimga_sersic.txt')
DO i=1,n
IF (act_S(i)) THEN
WRITE(61,*) logR0_r_sersic(i),logsigma_r_sersic(i),i
END IF
END DO
CLOSE(61)

OPEN(61,file='output/scand_fp_sersic.txt')
DO i=1,n
IF (act_S(i)) THEN
WRITE(61,*) logR0_r_sersic(i),sotherside_r(i),i
END IF
END DO
CLOSE(61)




DO i=0,10
ba_ratio_dV(i)=0.D0
END DO

DO i=1,n 
IF (act_dv(i)) THEN
DO ii=1,10
IF ((ba_r(i).GE.(DBLE(ii-1)/10.D0)).AND.(ba_r(i).LE.(DBLE(ii)/10.D0))) THEN
ba_ratio_dV(ii)=ba_ratio_dV(ii)+1.D0
END IF
END DO
END IF
END DO

iii=0
DO i=1,n 
IF (act_dv(i)) THEN
iii=iii+1
END IF
END DO

DO i=1,10
ba_ratio_dV(i)=ba_ratio_dV(i)/DBLE(iii)
END DO


OPEN(80,file='output/bin_ba_ratios_dV.txt')
DO i=1,10
WRITE(80,*) ((DBLE(i)/10.D0)-0.05D0),ba_ratio_dV(i)
END DO
CLOSE(80)





n_g=0
n_r=0
n_i=0
n_z=0
av_dist_fp_g=0.D0
av_dist_fp_r=0.D0
av_dist_fp_i=0.D0
av_dist_fp_z=0.D0
OPEN(61,file='output/dist_fp.txt')
DO i=1,n
IF (act(i)) THEN
dist_fp=ABS(dist_fp_r(i))/rms_r
av_dist_fp_r=av_dist_fp_r+dist_fp
n_r=n_r+1
WRITE(61,*) dist_fp
END IF
END DO
CLOSE(61)
av_dist_fp_r=av_dist_fp_r/DBLE(n_r)

OPEN(61,file='output/av_dist_fp.txt')
WRITE(61,*) av_dist_fp_r
CLOSE(61)






OPEN(61,file='output/CMD_cand.txt')
DO i=1,n
IF (act_dV(i)) THEN
WRITE(61,*) magabs_z(i),(Mag_app_g(i)-Mag_app_r(i))
END IF
END DO
CLOSE(61)

OPEN(61,file='output/sCMD_cand.txt')
DO i=1,n
IF (act_S(i)) THEN
WRITE(61,*) magabs_z(i),(Mag_app_g(i)-Mag_app_r(i))
END IF
END DO
CLOSE(61)


 OPEN(61,file='output/cand_sigma_mstar_mdyn_dV.txt')
DO i=1,n
IF (act_dV(i)) THEN
WRITE(61,*) logsigma_r(i),(log_M_dyn_r(i)-new_logmstarc(i))
END IF
END DO
 CLOSE(61)

  OPEN(61,file='output/scand_sigma_mstar_mdyn_dV.txt')
DO i=1,n
IF (act_S(i)) THEN
WRITE(61,*) logsigma_r(i),(log_M_dyn_r(i)-new_logmstarc(i))
END IF
END DO
 CLOSE(61)
 
  OPEN(61,file='output/cand_sigma_mstar_mdyn_S.txt')
DO i=1,n
IF (act_dV(i)) THEN
WRITE(61,*) logsigma_r_sersic(i),(log_M_dyn_r_sersic(i)-new_logmstars(i))
END IF
END DO
 CLOSE(61)

   OPEN(61,file='output/scand_sigma_mstar_mdyn_S.txt')
DO i=1,n
IF (act_S(i)) THEN
WRITE(61,*) logsigma_r_sersic(i),(log_M_dyn_r_sersic(i)-new_logmstars(i))
END IF
END DO
 CLOSE(61)
 
 
 
 OPEN(61,file='output/cand_colour_MLstar_dV.txt')
DO i=1,n
IF (act_dV(i)) THEN
WRITE(61,*) (Mag_app_g(i)-Mag_app_r(i)),ml_ratio_star(i)
END IF
END DO
 CLOSE(61)

  OPEN(61,file='output/scand_colour_MLstar_dV.txt')
DO i=1,n
IF (act_S(i)) THEN
WRITE(61,*) (Mag_app_g(i)-Mag_app_r(i)),ml_ratio_star(i)
END IF
END DO
 CLOSE(61)
 
  OPEN(61,file='output/cand_colour_MLstar_S.txt')
DO i=1,n
IF (act_dV(i)) THEN
WRITE(61,*) (Mag_app_g_sersic(i)-Mag_app_r_sersic(i)),ml_ratio_star_sersic(i)
END IF
END DO
 CLOSE(61)

   OPEN(61,file='output/scand_colour_MLstar_S.txt')
DO i=1,n
IF (act_S(i)) THEN
WRITE(61,*) (Mag_app_g_sersic(i)-Mag_app_r_sersic(i)),ml_ratio_star_sersic(i)
END IF
END DO
 CLOSE(61)
 
 
 
  
 OPEN(61,file='output/cand_mstar_R0_dV.txt')
DO i=1,n
IF (act_dV(i)) THEN
WRITE(61,*) new_logmstarc(i),logR0_r(i)
END IF
END DO
 CLOSE(61)
 
  OPEN(61,file='output/scand_mstar_R0_dV.txt')
DO i=1,n
IF (act_S(i)) THEN
WRITE(61,*) new_logmstarc(i),logR0_r(i)
END IF
END DO
 CLOSE(61)

  OPEN(61,file='output/cand_mstar_R0_S.txt')
DO i=1,n
IF (act_dV(i)) THEN
WRITE(61,*) new_logmstars(i),logR0_r_sersic(i)
END IF
END DO
 CLOSE(61)

   OPEN(61,file='output/scand_mstar_R0_S.txt')
DO i=1,n
IF (act_S(i)) THEN
WRITE(61,*) new_logmstars(i),logR0_r_sersic(i)
END IF
END DO
 CLOSE(61)


OPEN(61,file='output/cand_mag_R0.txt')
DO i=1,n
IF (act_dV(i)) THEN
WRITE(61,*) magabs_r(i),logR0_r(i)
END IF
END DO
 CLOSE(61)

 OPEN(61,file='output/scand_mag_R0.txt')
DO i=1,n
IF (act_S(i)) THEN
WRITE(61,*) magabs_r(i),logR0_r(i)
END IF
END DO
 CLOSE(61)

 OPEN(61,file='output/cand_mag_sersic_R0_sersic.txt')
DO i=1,n
IF (act_dV(i)) THEN
WRITE(61,*) magabs_r_sersic(i),logR0_r_sersic(i)
END IF
END DO
 CLOSE(61)

 OPEN(61,file='output/scand_mag_sersic_R0_sersic.txt')
DO i=1,n
IF (act_S(i)) THEN
WRITE(61,*) magabs_r_sersic(i),logR0_r_sersic(i)
END IF
END DO
 CLOSE(61)




 OPEN(61,file='output/cand_absmag_vs_lumdist.txt')
DO i=1,n
IF (act_dV(i)) THEN
WRITE(61,*) logdistlum(i),magabs_r(i)
END IF
END DO
 CLOSE(61)

 OPEN(61,file='output/scand_absmag_vs_lumdist.txt')
DO i=1,n
IF (act_S(i)) THEN
WRITE(61,*) logdistlum(i),magabs_r(i)
END IF
END DO
 CLOSE(61)

 
 
  OPEN(61,file='output/cand_absmag_sersic_vs_lumdist.txt')
DO i=1,n
IF (act_dV(i)) THEN
WRITE(61,*) logdistlum(i),magabs_r_sersic(i)
END IF
END DO
 CLOSE(61)

 OPEN(61,file='output/scand_absmag_sersic_vs_lumdist.txt')
DO i=1,n
IF (act_S(i)) THEN
WRITE(61,*) logdistlum(i),magabs_r_sersic(i)
END IF
END DO
 CLOSE(61)

 
OPEN(61,file='output/cand_sigma_ML_dyn_dV.txt')
DO i=1,n
IF (act_dV(i)) THEN
WRITE(61,*) logsigma_r(i),ml_ratio_r(i)
END IF
END DO
 CLOSE(61)

 OPEN(61,file='output/scand_sigma_ML_dyn_dV.txt')
DO i=1,n
IF (act_S(i)) THEN
WRITE(61,*) logsigma_r(i),ml_ratio_r(i)
END IF
END DO
 CLOSE(61)
 

 OPEN(61,file='output/cand_sigma_ML_dyn_S.txt')
DO i=1,n
IF (act_dV(i)) THEN
WRITE(61,*) logsigma_r_sersic(i),ml_ratio_r_sersic(i)
END IF
END DO
 CLOSE(61)

 OPEN(61,file='output/scand_sigma_ML_dyn_S.txt')
DO i=1,n
IF (act_S(i)) THEN
WRITE(61,*) logsigma_r_sersic(i),ml_ratio_r_sersic(i)
END IF
END DO
 CLOSE(61)
 
 OPEN(61,file='output/cand_sigma_ML_star_dV.txt')
DO i=1,n
IF (act_dV(i)) THEN
WRITE(61,*) logsigma_r(i),ml_ratio_star(i)
END IF
END DO
 CLOSE(61)

 OPEN(61,file='output/scand_sigma_ML_star_dV.txt')
DO i=1,n
IF (act_S(i)) THEN
WRITE(61,*) logsigma_r(i),ml_ratio_star(i)
END IF
END DO
 CLOSE(61)
  
 OPEN(61,file='output/cand_sigma_ML_star_S.txt')
DO i=1,n
IF (act_dV(i)) THEN
WRITE(61,*) logsigma_r_sersic(i),ml_ratio_star_sersic(i)
END IF
END DO
 CLOSE(61)

 OPEN(61,file='output/scand_sigma_ML_star_S.txt')
DO i=1,n
IF (act_S(i)) THEN
WRITE(61,*) logsigma_r_sersic(i),ml_ratio_star_sersic(i)
END IF
END DO
 CLOSE(61)


 
 
 
 
OPEN(61,file='output/taylor_sigma_ML_dyn_dV.txt')
DO i=1,n
IF (act_taylor(i)) THEN
WRITE(61,*) logsigma_r(i),ml_ratio_r(i)
END IF
END DO
 CLOSE(61)

 OPEN(61,file='output/taylor_sigma_ML_dyn_S.txt')
DO i=1,n
IF (act_taylor(i)) THEN
WRITE(61,*) logsigma_r_sersic(i),ml_ratio_r_sersic(i)
END IF
END DO
 CLOSE(61)
 
 OPEN(61,file='output/taylor_sigma_ML_star_dV.txt')
DO i=1,n
IF (act_taylor(i)) THEN
WRITE(61,*) logsigma_r(i),ml_ratio_star(i)
END IF
END DO
 CLOSE(61)

 OPEN(61,file='output/taylor_sigma_ML_star_S.txt')
DO i=1,n
IF (act_taylor(i)) THEN
WRITE(61,*) logsigma_r_sersic(i),ml_ratio_star_sersic(i)
END IF
END DO
 CLOSE(61)


 
OPEN(61,file='output/trujillo_sigma_ML_dyn_dV.txt')
DO i=1,n
IF (act_trujillo(i)) THEN
WRITE(61,*) logsigma_r(i),ml_ratio_r(i)
END IF
END DO
 CLOSE(61)

 OPEN(61,file='output/trujillo_sigma_ML_dyn_S.txt')
DO i=1,n
IF (act_trujillo(i)) THEN
WRITE(61,*) logsigma_r_sersic(i),ml_ratio_r_sersic(i)
END IF
END DO
 CLOSE(61)
 
 OPEN(61,file='output/trujillo_sigma_ML_star_dV.txt')
DO i=1,n
IF (act_trujillo(i)) THEN
WRITE(61,*) logsigma_r(i),ml_ratio_star(i)
END IF
END DO
 CLOSE(61)

 OPEN(61,file='output/trujillo_sigma_ML_star_S.txt')
DO i=1,n
IF (act_trujillo(i)) THEN
WRITE(61,*) logsigma_r_sersic(i),ml_ratio_star_sersic(i)
END IF
END DO
 CLOSE(61)


 
 
 hhcount_g=0
 

 DO i=0,16
sersic_index_bin(i)=0.D0
END DO

DO i=1,n


IF (act(i)) THEN
hhcount_g=hhcount_g+1
DO ii=0,16
binhelp=DBLE(ii)/2.D0
IF ((new_sersic_index(i)>(binhelp-0.25)).AND.(new_sersic_index(i)<(binhelp+0.25))) THEN
sersic_index_bin(ii)=sersic_index_bin(ii)+1.D0
END IF
END DO
END IF


END DO


DO i=0,16


sersic_index_bin(i)=sersic_index_bin(i)/DBLE(hhcount_g)

END DO


OPEN(70,file='output/sersic_bronze_bin.txt')
DO i=0,16
binhelp=DBLE(i)/2.D0

WRITE(70,*) binhelp,sersic_index_bin(i)



END DO
 CLOSE (70)

 
 
 
 
 
 
 
 
 
 hhcount_g=0
 

 DO i=0,8
sersic_index_bin(i)=0.D0
END DO

DO i=1,n


IF (act_dV(i)) THEN
hhcount_g=hhcount_g+1
DO ii=0,8
binhelp=DBLE(ii)
IF ((new_sersic_index(i)>(binhelp-0.5)).AND.(new_sersic_index(i)<(binhelp+0.5))) THEN
sersic_index_bin(ii)=sersic_index_bin(ii)+1.D0
END IF
END DO
END IF


END DO


DO i=0,8


sersic_index_bin(i)=sersic_index_bin(i)/DBLE(hhcount_g)

END DO


OPEN(70,file='output/sersic_silver_dV_bin.txt')
DO i=0,8
binhelp=DBLE(i)

WRITE(70,*) binhelp,sersic_index_bin(i)



END DO
 CLOSE (70)

 
 hhcount_g=0
 

 DO i=0,8
sersic_index_bin(i)=0.D0
END DO

DO i=1,n


IF (act_S(i)) THEN
hhcount_g=hhcount_g+1
DO ii=0,8
binhelp=DBLE(ii)
IF ((new_sersic_index(i)>(binhelp-0.5)).AND.(new_sersic_index(i)<(binhelp+0.5))) THEN
sersic_index_bin(ii)=sersic_index_bin(ii)+1.D0
END IF
END DO
END IF


END DO


DO i=0,8


sersic_index_bin(i)=sersic_index_bin(i)/DBLE(hhcount_g)

END DO


OPEN(70,file='output/sersic_silver_S_bin.txt')
DO i=0,8
binhelp=DBLE(i)

WRITE(70,*) binhelp,sersic_index_bin(i)



END DO
 CLOSE (70)

 
 
 hhcount_g=0
 

 DO i=0,16
sersic_index_bin(i)=0.D0
END DO

DO i=1,n


IF ((act_dV(i)).AND.(act_S(i))) THEN
hhcount_g=hhcount_g+1
DO ii=0,16
binhelp=DBLE(ii)/2.D0
IF ((new_sersic_index(i)>(binhelp-0.25)).AND.(new_sersic_index(i)<(binhelp+0.25))) THEN
sersic_index_bin(ii)=sersic_index_bin(ii)+1.D0
END IF
END DO
END IF


END DO


DO i=0,16


sersic_index_bin(i)=sersic_index_bin(i)/DBLE(hhcount_g)

END DO


OPEN(70,file='output/sersic_gold_bin.txt')
DO i=0,16
binhelp=DBLE(i)/2.D0

WRITE(70,*) binhelp,sersic_index_bin(i)



END DO
 CLOSE (70)

 
 
 
 
 
 
 
 hhcount_g=0
 

 DO i=0,8
sersic_index_bin(i)=0.D0
END DO

DO i=1,n


IF (act_taylor(i)) THEN
hhcount_g=hhcount_g+1
DO ii=0,8
binhelp=DBLE(ii)
IF ((new_sersic_index(i)>(binhelp-0.5)).AND.(new_sersic_index(i)<(binhelp+0.5))) THEN
sersic_index_bin(ii)=sersic_index_bin(ii)+1.D0
END IF
END DO
END IF


END DO


DO i=0,8


sersic_index_bin(i)=sersic_index_bin(i)/DBLE(hhcount_g)

END DO


OPEN(70,file='output/sersic_taylor_bin.txt')
DO i=0,8
binhelp=DBLE(i)

WRITE(70,*) binhelp,sersic_index_bin(i)



END DO
 CLOSE (70)

 
 
 
 
 
 
 
 
 
 hhcount_g=0
 

 DO i=0,8
sersic_index_bin(i)=0.D0
END DO

DO i=1,n


IF (act_trujillo(i)) THEN
hhcount_g=hhcount_g+1
DO ii=0,8
binhelp=DBLE(ii)
IF ((new_sersic_index(i)>(binhelp-0.5)).AND.(new_sersic_index(i)<(binhelp+0.5))) THEN
sersic_index_bin(ii)=sersic_index_bin(ii)+1.D0
END IF
END DO
END IF


END DO


DO i=0,8


sersic_index_bin(i)=sersic_index_bin(i)/DBLE(hhcount_g)

END DO



OPEN(70,file='output/sersic_trujillo_bin.txt')
DO i=0,8
binhelp=DBLE(i)

WRITE(70,*) binhelp,sersic_index_bin(i)



END DO
 CLOSE (70)

 
 
  av_mm_cand=0.D0
   hhcount_g=0
 DO i=1,n
IF (act_dV(i)) THEN
hhcount_g=hhcount_g+1
 av_mm_cand=av_mm_cand+LOG10(M_dyn_r(i)/M_star(i))
 END IF
 END DO
  av_mm_cand=av_mm_cand/DBLE(hhcount_g)
 
 OPEN(70,file='output/av_logmm_ratios.txt')
WRITE(70,*) 'cand:',av_mm_cand
WRITE(70,*) 'basic:',av_mm_basic
WRITE(70,*) 'highsigma:',av_mm_high_int
 CLOSE (70)

 
 
 
 
 hhcount_g=0
 
 DO i=0,20
ml_cand_bin(i)=0.D0
END DO

DO i=1,n

IF (act_dV(i)) THEN
hhcount_g=hhcount_g+1
DO ii=0,20
binhelp=DBLE(ii)
IF ((ml_ratio_r(i)>(binhelp-0.5)).AND.(ml_ratio_r(i)<(binhelp+0.5))) THEN
ml_cand_bin(ii)=ml_cand_bin(ii)+1.D0
END IF
END DO
END IF

END DO

DO i=0,20
ml_cand_bin(i)=ml_cand_bin(i)/DBLE(hhcount_g)
END DO

OPEN(70,file='output/ml_cand_bin.txt')
DO i=0,20
binhelp=DBLE(i)
WRITE(70,*) binhelp,ml_cand_bin(i)
END DO
 CLOSE (70)

 
 
 
 hhcount_g=0
 
 DO i=0,20
ml_cand_bin(i)=0.D0
END DO

DO i=1,n

IF (act_S(i)) THEN
hhcount_g=hhcount_g+1
DO ii=0,20
binhelp=DBLE(ii)
IF ((ml_ratio_r_sersic(i)>(binhelp-0.5)).AND.(ml_ratio_r_sersic(i)<(binhelp+0.5))) THEN
ml_sersic_bins(ii)=ml_sersic_bins(ii)+1.D0
END IF
END DO
END IF

END DO

DO i=0,20
ml_sersic_bins(i)=ml_sersic_bins(i)/DBLE(hhcount_g)
END DO

OPEN(70,file='output/ml_sersic_bins.txt')
DO i=0,20
binhelp=DBLE(i)
WRITE(70,*) binhelp,ml_sersic_bins(i)
END DO
 CLOSE (70)

 
 
 
 
 hhcount_g=0
 
 DO i=0,20
ml_trujillo_bin(i)=0.D0
END DO

DO i=1,n

IF (act_trujillo(i)) THEN
hhcount_g=hhcount_g+1
DO ii=0,20
binhelp=DBLE(ii)
IF ((ml_ratio_r(i)>(binhelp-0.5)).AND.(ml_ratio_r(i)<(binhelp+0.5))) THEN
ml_trujillo_bin(ii)=ml_trujillo_bin(ii)+1.D0
END IF
END DO
END IF

END DO

DO i=0,20
ml_trujillo_bin(i)=ml_trujillo_bin(i)/DBLE(hhcount_g)
END DO

OPEN(70,file='output/ml_trujillo_bin.txt')
DO i=0,20
binhelp=DBLE(i)
WRITE(70,*) binhelp,ml_trujillo_bin(i)
END DO
 CLOSE (70)

 
 
 
 hhcount_g=0
 
 DO i=0,20
ml_trujillo_bin(i)=0.D0
END DO

DO i=1,n

IF (act_trujillo(i)) THEN
hhcount_g=hhcount_g+1
DO ii=0,20
binhelp=DBLE(ii)
IF ((ml_ratio_r_sersic(i)>(binhelp-0.5)).AND.(ml_ratio_r_sersic(i)<(binhelp+0.5))) THEN
ml_trujillo_bin(ii)=ml_trujillo_bin(ii)+1.D0
END IF
END DO
END IF

END DO

DO i=0,20
ml_trujillo_bin(i)=ml_trujillo_bin(i)/DBLE(hhcount_g)
END DO

OPEN(70,file='output/ml_trujillo_bin_sersic.txt')
DO i=0,20
binhelp=DBLE(i)
WRITE(70,*) binhelp,ml_trujillo_bin(i)
END DO
 CLOSE (70)

 
 hhcount_g=0
 
 DO i=0,20
ml_taylor_bin(i)=0.D0
END DO

DO i=1,n

IF (act_taylor(i)) THEN
hhcount_g=hhcount_g+1
DO ii=0,20
binhelp=DBLE(ii)
IF ((ml_ratio_r(i)>(binhelp-0.5)).AND.(ml_ratio_r(i)<(binhelp+0.5))) THEN
ml_taylor_bin(ii)=ml_taylor_bin(ii)+1.D0
END IF
END DO
END IF

END DO

DO i=0,20
ml_taylor_bin(i)=ml_taylor_bin(i)/DBLE(hhcount_g)
END DO

OPEN(70,file='output/ml_taylor_bin.txt')
DO i=0,20
binhelp=DBLE(i)
WRITE(70,*) binhelp,ml_taylor_bin(i)
END DO
 CLOSE (70)

 
 
 
 hhcount_g=0
 
 DO i=0,20
ml_taylor_bin(i)=0.D0
END DO

DO i=1,n

IF (act_taylor(i)) THEN
hhcount_g=hhcount_g+1
DO ii=0,20
binhelp=DBLE(ii)
IF ((ml_ratio_r_sersic(i)>(binhelp-0.5)).AND.(ml_ratio_r_sersic(i)<(binhelp+0.5))) THEN
ml_taylor_bin(ii)=ml_taylor_bin(ii)+1.D0
END IF
END DO
END IF

END DO

DO i=0,20
ml_taylor_bin(i)=ml_taylor_bin(i)/DBLE(hhcount_g)
END DO

OPEN(70,file='output/ml_taylor_bin_sersic.txt')
DO i=0,20
binhelp=DBLE(i)
WRITE(70,*) binhelp,ml_taylor_bin(i)
END DO
 CLOSE (70)

 

 
 
 
 
 
 hhcount_g=0
 
 DO i=0,20
ml_cand_bin(i)=0.D0
END DO

DO i=1,n

IF (act_dV(i)) THEN
hhcount_g=hhcount_g+1
DO ii=0,20
binhelp=DBLE(ii)/2.D0
IF ((ml_ratio_star(i)>(binhelp-0.25)).AND.(ml_ratio_star(i)<(binhelp+0.25))) THEN
ml_cand_bin(ii)=ml_cand_bin(ii)+1.D0
END IF
END DO
END IF

END DO

DO i=0,20
ml_cand_bin(i)=ml_cand_bin(i)/DBLE(hhcount_g)
END DO

OPEN(70,file='output/ml_star_cand_bin.txt')
DO i=0,20
binhelp=DBLE(i)/2.D0
WRITE(70,*) binhelp,ml_cand_bin(i)
END DO
 CLOSE (70)

 
 
 
 hhcount_g=0
 
 DO i=0,20
ml_cand_bin(i)=0.D0
END DO

DO i=1,n

IF (act_S(i)) THEN
hhcount_g=hhcount_g+1
DO ii=0,20
binhelp=DBLE(ii)/2.D0
IF ((ml_ratio_star_sersic(i)>(binhelp-0.25)).AND.(ml_ratio_star_sersic(i)<(binhelp+0.25))) THEN
ml_sersic_bins(ii)=ml_sersic_bins(ii)+1.D0
END IF
END DO
END IF

END DO

DO i=0,20
ml_sersic_bins(i)=ml_sersic_bins(i)/DBLE(hhcount_g)
END DO

OPEN(70,file='output/ml_star_sersic_bins.txt')
DO i=0,20
binhelp=DBLE(i)/2.D0
WRITE(70,*) binhelp,ml_sersic_bins(i)
END DO
 CLOSE (70)

 
 
 
 
 hhcount_g=0
 
 DO i=0,20
ml_trujillo_bin(i)=0.D0
END DO

DO i=1,n

IF (act_trujillo(i)) THEN
hhcount_g=hhcount_g+1
DO ii=0,20
binhelp=DBLE(ii)/2.D0
IF ((ml_ratio_star(i)>(binhelp-0.25)).AND.(ml_ratio_star(i)<(binhelp+0.25))) THEN
ml_trujillo_bin(ii)=ml_trujillo_bin(ii)+1.D0
END IF
END DO
END IF

END DO

DO i=0,20
ml_trujillo_bin(i)=ml_trujillo_bin(i)/DBLE(hhcount_g)
END DO

OPEN(70,file='output/ml_star_trujillo_bin.txt')
DO i=0,20
binhelp=DBLE(i)/2.D0
WRITE(70,*) binhelp,ml_trujillo_bin(i)
END DO
 CLOSE (70)

 
 
 
 hhcount_g=0
 
 DO i=0,20
ml_trujillo_bin(i)=0.D0
END DO

DO i=1,n

IF (act_trujillo(i)) THEN
hhcount_g=hhcount_g+1
DO ii=0,20
binhelp=DBLE(ii)/2.D0
IF ((ml_ratio_star_sersic(i)>(binhelp-0.25)).AND.(ml_ratio_star_sersic(i)<(binhelp+0.25))) THEN
ml_trujillo_bin(ii)=ml_trujillo_bin(ii)+1.D0
END IF
END DO
END IF

END DO

DO i=0,20
ml_trujillo_bin(i)=ml_trujillo_bin(i)/DBLE(hhcount_g)
END DO

OPEN(70,file='output/ml_star_trujillo_bin_sersic.txt')
DO i=0,20
binhelp=DBLE(i)/2.D0
WRITE(70,*) binhelp,ml_trujillo_bin(i)
END DO
 CLOSE (70)

 

 
 
 
 hhcount_g=0
 
 DO i=0,20
ml_taylor_bin(i)=0.D0
END DO

DO i=1,n

IF (act_taylor(i)) THEN
hhcount_g=hhcount_g+1
DO ii=0,20
binhelp=DBLE(ii)/2.D0
IF ((ml_ratio_star(i)>(binhelp-0.25)).AND.(ml_ratio_star(i)<(binhelp+0.25))) THEN
ml_taylor_bin(ii)=ml_taylor_bin(ii)+1.D0
END IF
END DO
END IF

END DO

DO i=0,20
ml_taylor_bin(i)=ml_taylor_bin(i)/DBLE(hhcount_g)
END DO

OPEN(70,file='output/ml_star_taylor_bin.txt')
DO i=0,20
binhelp=DBLE(i)/2.D0
WRITE(70,*) binhelp,ml_taylor_bin(i)
END DO
 CLOSE (70)

 
 
 
 hhcount_g=0
 
 DO i=0,20
ml_taylor_bin(i)=0.D0
END DO

DO i=1,n

IF (act_taylor(i)) THEN
hhcount_g=hhcount_g+1
DO ii=0,20
binhelp=DBLE(ii)/2.D0
IF ((ml_ratio_star_sersic(i)>(binhelp-0.25)).AND.(ml_ratio_star_sersic(i)<(binhelp+0.25))) THEN
ml_taylor_bin(ii)=ml_taylor_bin(ii)+1.D0
END IF
END DO
END IF

END DO

DO i=0,20
ml_taylor_bin(i)=ml_taylor_bin(i)/DBLE(hhcount_g)
END DO

OPEN(70,file='output/ml_star_taylor_bin_sersic.txt')
DO i=0,20
binhelp=DBLE(i)/2.D0
WRITE(70,*) binhelp,ml_taylor_bin(i)
END DO
 CLOSE (70)

 

 
 
 
 

 hhcount_g=0
 hhcount_r=0
 hhcount_i=0
 hhcount_z=0
 

 DO i=0,20
 cmagabs_bin_g(i)=0.D0
 cmagabs_bin_r(i)=0.D0
 cmagabs_bin_i(i)=0.D0
 cmagabs_bin_z(i)=0.D0
END DO

DO i=1,n



IF (act(i)) THEN
hhcount_r=hhcount_r+1
DO ii=0,20
binhelp=-DBLE(ii)/2.D0-15.D0
IF ((magabs_r(i)>(binhelp-0.25)).AND.(magabs_r(i)<(binhelp+0.25))) THEN
 cmagabs_bin_r(ii)= cmagabs_bin_r(ii)+1.D0
END IF
END DO
END IF


END DO



DO i=0,20

 cmagabs_bin_r(i)=cmagabs_bin_r(i)/DBLE(hhcount_r)

END DO


OPEN(70,file='output/cand_magabs_binned.txt')
DO i=0,20
binhelp=-DBLE(i)/2.D0-15.D0

WRITE(70,*) binhelp,cmagabs_bin_r(i)

END DO
 CLOSE (70)

 




OPEN(61,file='output/cand_R0_vs_M_dyn.txt')
DO i=1,n
IF (act_dV(i)) THEN
WRITE(61,*) log_M_dyn_r(i),logR0_r(i)
END IF
END DO
CLOSE(61)

OPEN(61,file='output/scand_R0_vs_M_dyn.txt')
DO i=1,n
IF (act_S(i)) THEN
WRITE(61,*) log_M_dyn_r(i),logR0_r(i)
END IF
END DO
CLOSE(61)


OPEN(61,file='output/cand_R0_sersic_vs_M_dyn_sersic.txt')
DO i=1,n
IF (act_dV(i)) THEN
WRITE(61,*) log_M_dyn_r_sersic(i),logR0_r_sersic(i)
END IF
END DO
CLOSE(61)

OPEN(61,file='output/scand_R0_sersic_vs_M_dyn_sersic.txt')
DO i=1,n
IF (act_S(i)) THEN
WRITE(61,*) log_M_dyn_r_sersic(i),logR0_r_sersic(i)
END IF
END DO
CLOSE(61)



OPEN(61,file='output/cand_z_vs_size.txt')
DO i=1,n
IF (act_dV(i)) THEN
WRITE(61,*) z_cor(i),logR0_r(i)
END IF
END DO
CLOSE(61)




OPEN(61,file='output/cand_z_vs_size_range.txt')
DO i=1,n
IF (act_dV(i)) THEN
IF (new_logmstarc(i)>10.75) THEN
IF (new_logmstarc(i)<11.25) THEN
WRITE(61,*) z_cor(i),logR0_r(i)
END IF
END IF
END IF
END DO
CLOSE(61)








OPEN(61,file='output/cand_lum_vs_M_dyn.txt')
DO i=1,n
IF (act_dV(i)) THEN
WRITE(61,*) log_M_dyn_r(i),log_lum_r(i)
END IF
END DO
 CLOSE(61)
 
 
OPEN(61,file='output/scand_lum_vs_M_dyn.txt')
DO i=1,n
IF (act_S(i)) THEN
WRITE(61,*) log_M_dyn_r(i),log_lum_r(i)
END IF
END DO
 CLOSE(61)
 
 
 
OPEN(61,file='output/cand_lum_sersic_vs_M_dyn_sersic.txt')
DO i=1,n
IF (act_dV(i)) THEN
WRITE(61,*) log_M_dyn_r_sersic(i),log_lum_r_sersic(i)
END IF
END DO
 CLOSE(61)
 
 
OPEN(61,file='output/scand_lum_sersic_vs_M_dyn_sersic.txt')
DO i=1,n
IF (act_S(i)) THEN
WRITE(61,*) log_M_dyn_r_sersic(i),log_lum_r_sersic(i)
END IF
END DO
 CLOSE(61)
 
 
 
 

 
 OPEN(61,file='output/cand_mstar_mdyn_dV.txt')
DO i=1,n
IF (act_dV(i)) THEN
WRITE(61,*) log_M_dyn_r(i),new_logmstarc(i)
END IF
END DO
 CLOSE(61)
 
  OPEN(61,file='output/scand_mstar_mdyn_dV.txt')
DO i=1,n
IF (act_S(i)) THEN
WRITE(61,*) log_M_dyn_r(i),new_logmstarc(i)
END IF
END DO
 CLOSE(61)

  OPEN(61,file='output/cand_mstar_mdyn_S.txt')
DO i=1,n
IF (act_dV(i)) THEN
WRITE(61,*) log_M_dyn_r_sersic(i),new_logmstars(i)
END IF
END DO
 CLOSE(61)

   OPEN(61,file='output/scand_mstar_mdyn_S.txt')
DO i=1,n
IF (act_S(i)) THEN
WRITE(61,*) log_M_dyn_r_sersic(i),new_logmstars(i)
END IF
END DO
 CLOSE(61)
 
 
 
 OPEN(61,file='output/taylor_z_vs_size.txt')
DO i=1,n
IF (act_taylor(i)) THEN
WRITE(61,*) z_cor(i),logR0_r(i)
END IF
END DO
CLOSE(61)

 OPEN(61,file='output/taylor_z_vs_size_range.txt')
DO i=1,n
IF (act_taylor(i)) THEN
IF (new_logmstarc(i)>10.75) THEN
IF (new_logmstarc(i)<11.25) THEN
WRITE(61,*) z_cor(i),logR0_r(i)
END IF
END IF
END IF
END DO
CLOSE(61)

 
   OPEN(61,file='output/taylor_mstar_mdyn_dV.txt')
DO i=1,n
IF (act_taylor(i)) THEN
WRITE(61,*) log_M_dyn_r(i),new_logmstarc(i)
END IF
END DO
 CLOSE(61)

  OPEN(61,file='output/taylor_mstar_mdyn_S.txt')
DO i=1,n
IF (act_taylor(i)) THEN
WRITE(61,*) log_M_dyn_r_sersic(i),new_logmstars(i)
END IF
END DO
 CLOSE(61)
 
 

OPEN(61,file='output/taylor_logR0_vs_logsimga.txt')
DO i=1,n
IF (act_taylor(i)) THEN
WRITE(61,*) logR0_r(i),logsigma_r(i),i
END IF
END DO
CLOSE(61)


OPEN(61,file='output/taylor_fp.txt')
DO i=1,n
IF (act_taylor(i)) THEN
WRITE(61,*) logR0_r(i),otherside_r(i),i
END IF
END DO
CLOSE(61)


OPEN(61,file='output/taylor_logR0_sersic_vs_logsimga_sersic.txt')
DO i=1,n
IF (act_taylor(i)) THEN
WRITE(61,*) logR0_r_sersic(i),logsigma_r_sersic(i),i
END IF
END DO
CLOSE(61)


OPEN(61,file='output/taylor_fp_sersic.txt')
DO i=1,n
IF (act_taylor(i)) THEN
WRITE(61,*) logR0_r_sersic(i),sotherside_r(i),i
END IF
END DO
CLOSE(61)


OPEN(61,file='output/taylor_CMD.txt')
DO i=1,n
IF (act_taylor(i)) THEN
WRITE(61,*) magabs_z(i),(Mag_app_g(i)-Mag_app_r(i))
END IF
END DO
CLOSE(61)


 OPEN(61,file='output/taylor_sigma_mstar_mdyn_dV.txt')
DO i=1,n
IF (act_taylor(i)) THEN
WRITE(61,*) logsigma_r(i),(log_M_dyn_r(i)-new_logmstarc(i))
END IF
END DO
 CLOSE(61)

 
   OPEN(61,file='output/taylor_sigma_mstar_mdyn_S.txt')
DO i=1,n
IF (act_taylor(i)) THEN
WRITE(61,*) logsigma_r_sersic(i),(log_M_dyn_r_sersic(i)-new_logmstars(i))
END IF
END DO
 CLOSE(61)
 
  
 OPEN(61,file='output/taylor_mstar_R0_dV.txt')
DO i=1,n
IF (act_taylor(i)) THEN
WRITE(61,*) new_logmstarc(i),logR0_r(i)
END IF
END DO
 CLOSE(61)

 
  OPEN(61,file='output/taylor_mstar_R0_S.txt')
DO i=1,n
IF (act_taylor(i)) THEN
WRITE(61,*) new_logmstars(i),logR0_r_sersic(i)
END IF
END DO
 CLOSE(61)


OPEN(61,file='output/taylor_mag_R0.txt')
DO i=1,n
IF (act_taylor(i)) THEN
WRITE(61,*) magabs_r(i),logR0_r(i)
END IF
END DO
 CLOSE(61)


 OPEN(61,file='output/taylor_mag_sersic_R0_sersic.txt')
DO i=1,n
IF (act_taylor(i)) THEN
WRITE(61,*) magabs_r_sersic(i),logR0_r_sersic(i)
END IF
END DO
 CLOSE(61)


 OPEN(61,file='output/taylor_absmag_vs_lumdist.txt')
DO i=1,n
IF (act_taylor(i)) THEN
WRITE(61,*) logdistlum(i),magabs_r(i)
END IF
END DO
 CLOSE(61)

 
 OPEN(61,file='output/taylor_absmag_sersic_vs_lumdist.txt')
DO i=1,n
IF (act_taylor(i)) THEN
WRITE(61,*) logdistlum(i),magabs_r_sersic(i)
END IF
END DO
 CLOSE(61)
 
 
 
 
 OPEN(61,file='output/taylor_colour_MLstar_dV.txt')
DO i=1,n
IF (act_taylor(i)) THEN
WRITE(61,*) (Mag_app_g(i)-Mag_app_r(i)),ml_ratio_star(i)
END IF
END DO
 CLOSE(61)
 
 
  OPEN(61,file='output/taylor_colour_MLstar_S.txt')
DO i=1,n
IF (act_taylor(i)) THEN
WRITE(61,*) (Mag_app_g_sersic(i)-Mag_app_r_sersic(i)),ml_ratio_star_sersic(i)
END IF
END DO
 CLOSE(61)

 
 OPEN(61,file='output/trujillo_z_vs_size.txt')
DO i=1,n
IF (act_trujillo(i)) THEN
WRITE(61,*) z_cor(i),logR0_r(i)
END IF
END DO
CLOSE(61)
 
 
  OPEN(61,file='output/trujillo_z_vs_size_range.txt')
DO i=1,n
IF (act_trujillo(i)) THEN
IF (new_logmstarc(i)>10.75) THEN
IF (new_logmstarc(i)<11.25) THEN
WRITE(61,*) z_cor(i),logR0_r(i)
END IF
END IF
END IF
END DO
CLOSE(61)
 
   OPEN(61,file='output/trujillo_mstar_mdyn_dV.txt')
DO i=1,n
IF (act_trujillo(i)) THEN
WRITE(61,*) log_M_dyn_r(i),new_logmstarc(i)
END IF
END DO
 CLOSE(61)

  OPEN(61,file='output/trujillo_mstar_mdyn_S.txt')
DO i=1,n
IF (act_trujillo(i)) THEN
WRITE(61,*) log_M_dyn_r_sersic(i),new_logmstars(i)
END IF
END DO
 CLOSE(61)
 
 

OPEN(61,file='output/trujillo_logR0_vs_logsimga.txt')
DO i=1,n
IF (act_trujillo(i)) THEN
WRITE(61,*) logR0_r(i),logsigma_r(i),i
END IF
END DO
CLOSE(61)


OPEN(61,file='output/trujillo_fp.txt')
DO i=1,n
IF (act_trujillo(i)) THEN
WRITE(61,*) logR0_r(i),otherside_r(i),i
END IF
END DO
CLOSE(61)


OPEN(61,file='output/trujillo_logR0_sersic_vs_logsimga_sersic.txt')
DO i=1,n
IF (act_trujillo(i)) THEN
WRITE(61,*) logR0_r_sersic(i),logsigma_r_sersic(i),i
END IF
END DO
CLOSE(61)


OPEN(61,file='output/trujillo_fp_sersic.txt')
DO i=1,n
IF (act_trujillo(i)) THEN
WRITE(61,*) logR0_r_sersic(i),sotherside_r(i),i
END IF
END DO
CLOSE(61)


OPEN(61,file='output/trujillo_CMD.txt')
DO i=1,n
IF (act_trujillo(i)) THEN
WRITE(61,*) magabs_z(i),(Mag_app_g(i)-Mag_app_r(i))
END IF
END DO
CLOSE(61)


 OPEN(61,file='output/trujillo_sigma_mstar_mdyn_dV.txt')
DO i=1,n
IF (act_trujillo(i)) THEN
WRITE(61,*) logsigma_r(i),(log_M_dyn_r(i)-new_logmstarc(i))
END IF
END DO
 CLOSE(61)

 
   OPEN(61,file='output/trujillo_sigma_mstar_mdyn_S.txt')
DO i=1,n
IF (act_trujillo(i)) THEN
WRITE(61,*) logsigma_r_sersic(i),(log_M_dyn_r_sersic(i)-new_logmstars(i))
END IF
END DO
 CLOSE(61)
 
  
 OPEN(61,file='output/trujillo_mstar_R0_dV.txt')
DO i=1,n
IF (act_trujillo(i)) THEN
WRITE(61,*) new_logmstarc(i),logR0_r(i)
END IF
END DO
 CLOSE(61)

 
  OPEN(61,file='output/trujillo_mstar_R0_S.txt')
DO i=1,n
IF (act_trujillo(i)) THEN
WRITE(61,*) new_logmstars(i),logR0_r_sersic(i)
END IF
END DO
 CLOSE(61)


OPEN(61,file='output/trujillo_mag_R0.txt')
DO i=1,n
IF (act_trujillo(i)) THEN
WRITE(61,*) magabs_r(i),logR0_r(i)
END IF
END DO
 CLOSE(61)


 OPEN(61,file='output/trujillo_mag_sersic_R0_sersic.txt')
DO i=1,n
IF (act_trujillo(i)) THEN
WRITE(61,*) magabs_r_sersic(i),logR0_r_sersic(i)
END IF
END DO
 CLOSE(61)


 OPEN(61,file='output/trujillo_absmag_vs_lumdist.txt')
DO i=1,n
IF (act_trujillo(i)) THEN
WRITE(61,*) logdistlum(i),magabs_r(i)
END IF
END DO
 CLOSE(61)

 
 OPEN(61,file='output/trujillo_absmag_sersic_vs_lumdist.txt')
DO i=1,n
IF (act_trujillo(i)) THEN
WRITE(61,*) logdistlum(i),magabs_r_sersic(i)
END IF
END DO
 CLOSE(61)
 
 
 
 
 OPEN(61,file='output/trujillo_colour_MLstar_dV.txt')
DO i=1,n
IF (act_trujillo(i)) THEN
WRITE(61,*) (Mag_app_g(i)-Mag_app_r(i)),ml_ratio_star(i)
END IF
END DO
 CLOSE(61)
 
 
  OPEN(61,file='output/trujillo_colour_MLstar_S.txt')
DO i=1,n
IF (act_trujillo(i)) THEN
WRITE(61,*) (Mag_app_g_sersic(i)-Mag_app_r_sersic(i)),ml_ratio_star_sersic(i)
END IF
END DO
 CLOSE(61)


 
 
 
 hhcount_g=0
 

 DO i=0,16
sersic_index_bin(i)=0.D0
END DO

DO i=1,n


IF (act_taylor(i)) THEN
hhcount_g=hhcount_g+1
DO ii=0,8
binhelp=DBLE(ii)
IF ((new_sersic_index(i)>(binhelp-0.5)).AND.(new_sersic_index(i)<(binhelp+0.5))) THEN
sersic_index_bin(ii)=sersic_index_bin(ii)+1.D0
END IF
END DO
END IF


END DO


DO i=0,8


sersic_index_bin(i)=sersic_index_bin(i)/DBLE(hhcount_g)

END DO


OPEN(70,file='output/sersic_taylor_bin.txt')
DO i=0,8
binhelp=DBLE(i)

WRITE(70,*) binhelp,sersic_index_bin(i)



END DO
 CLOSE (70)

 
 

 hhcount_g=0
 hhcount_r=0

 

 DO i=0,20
 cmagabs_bin_g(i)=0.D0
 cmagabs_bin_r(i)=0.D0
END DO

DO i=1,n



IF (act_taylor(i)) THEN
hhcount_r=hhcount_r+1
DO ii=0,20
binhelp=-DBLE(ii)/2.D0-15.D0
IF ((magabs_r(i)>(binhelp-0.25)).AND.(magabs_r(i)<(binhelp+0.25))) THEN
 cmagabs_bin_r(ii)= cmagabs_bin_r(ii)+1.D0
END IF
END DO
END IF


END DO



DO i=0,20

 cmagabs_bin_r(i)=cmagabs_bin_r(i)/DBLE(hhcount_r)

END DO


OPEN(70,file='output/taylor_magabs_binned.txt')
DO i=0,20
binhelp=-DBLE(i)/2.D0-15.D0

WRITE(70,*) binhelp,cmagabs_bin_r(i)

END DO
 CLOSE (70)

 


 
 hhcount_g=0
 

 DO i=0,16
sersic_index_bin(i)=0.D0
END DO

DO i=1,n


IF (act_trujillo(i)) THEN
hhcount_g=hhcount_g+1
DO ii=0,8
binhelp=DBLE(ii)
IF ((new_sersic_index(i)>(binhelp-0.5)).AND.(new_sersic_index(i)<(binhelp+0.5))) THEN
sersic_index_bin(ii)=sersic_index_bin(ii)+1.D0
END IF
END DO
END IF


END DO


DO i=0,8


sersic_index_bin(i)=sersic_index_bin(i)/DBLE(hhcount_g)

END DO


OPEN(70,file='output/sersic_trujillo_bin.txt')
DO i=0,8
binhelp=DBLE(i)

WRITE(70,*) binhelp,sersic_index_bin(i)



END DO
 CLOSE (70)

 
 

 hhcount_g=0
 hhcount_r=0

 

 DO i=0,20
 cmagabs_bin_g(i)=0.D0
 cmagabs_bin_r(i)=0.D0
END DO

DO i=1,n



IF (act_trujillo(i)) THEN
hhcount_r=hhcount_r+1
DO ii=0,20
binhelp=-DBLE(ii)/2.D0-15.D0
IF ((magabs_r(i)>(binhelp-0.25)).AND.(magabs_r(i)<(binhelp+0.25))) THEN
 cmagabs_bin_r(ii)= cmagabs_bin_r(ii)+1.D0
END IF
END DO
END IF


END DO



DO i=0,20

 cmagabs_bin_r(i)=cmagabs_bin_r(i)/DBLE(hhcount_r)

END DO


OPEN(70,file='output/trujillo_magabs_binned.txt')
DO i=0,20
binhelp=-DBLE(i)/2.D0-15.D0

WRITE(70,*) binhelp,cmagabs_bin_r(i)

END DO
 CLOSE (70)

 




OPEN(61,file='output/taylor_R0_vs_M_dyn.txt')
DO i=1,n
IF (act_taylor(i)) THEN
WRITE(61,*) log_M_dyn_r(i),logR0_r(i)
END IF
END DO
CLOSE(61)


OPEN(61,file='output/taylor_R0_sersic_vs_M_dyn_sersic.txt')
DO i=1,n
IF (act_taylor(i)) THEN
WRITE(61,*) log_M_dyn_r_sersic(i),logR0_r_sersic(i)
END IF
END DO
CLOSE(61)


OPEN(61,file='output/taylor_lum_vs_M_dyn.txt')
DO i=1,n
IF (act_taylor(i)) THEN
WRITE(61,*) log_M_dyn_r(i),log_lum_r(i)
END IF
END DO
 CLOSE(61)
 
 
OPEN(61,file='output/taylor_lum_sersic_vs_M_dyn_sersic.txt')
DO i=1,n
IF (act_taylor(i)) THEN
WRITE(61,*) log_M_dyn_r_sersic(i),log_lum_r_sersic(i)
END IF
END DO
 CLOSE(61)
 
  
 OPEN(61,file='output/taylor_mstar_mdyn.txt')
DO i=1,n
IF (act_taylor(i)) THEN
WRITE(61,*) log_M_dyn_r(i),new_logmstarc(i)
END IF
END DO
 CLOSE(61)

 
 
 

DO i=0,10
ba_ratio_T(i)=0.D0
END DO

DO i=1,n 
IF (act_taylor(i)) THEN
DO ii=1,10
IF ((ba_r(i).GE.(DBLE(ii-1)/10.D0)).AND.(ba_r(i).LE.(DBLE(ii)/10.D0))) THEN
ba_ratio_T(ii)=ba_ratio_T(ii)+1.D0
END IF
END DO
END IF
END DO

iii=0
DO i=1,n 
IF (act_taylor(i)) THEN
iii=iii+1
END IF
END DO

DO i=1,10
ba_ratio_T(i)=ba_ratio_T(i)/DBLE(iii)
END DO


OPEN(80,file='output/bin_ba_ratios_T.txt')
DO i=1,10
WRITE(80,*) ((DBLE(i)/10.D0)-0.05D0),ba_ratio_T(i)
END DO
CLOSE(80)

 

DO i=0,10
ba_ratio_Trujillo(i)=0.D0
END DO

DO i=1,n 
IF (act_trujillo(i)) THEN
DO ii=1,10
IF ((ba_r(i).GE.(DBLE(ii-1)/10.D0)).AND.(ba_r(i).LE.(DBLE(ii)/10.D0))) THEN
ba_ratio_Trujillo(ii)=ba_ratio_Trujillo(ii)+1.D0
END IF
END DO
END IF
END DO

iii=0
DO i=1,n 
IF (act_trujillo(i)) THEN
iii=iii+1
END IF
END DO

DO i=1,10
ba_ratio_Trujillo(i)=ba_ratio_Trujillo(i)/DBLE(iii)
END DO


OPEN(80,file='output/bin_ba_ratios_Trujillo.txt')
DO i=1,10
WRITE(80,*) ((DBLE(i)/10.D0)-0.05D0),ba_ratio_Trujillo(i)
END DO
CLOSE(80)



 
 
   OPEN(61,file='output/taylor_mstar_mdyn_sersic.txt')
DO i=1,n
IF (act_taylor(i)) THEN
WRITE(61,*) log_M_dyn_r_sersic(i),new_logmstars(i)
END IF
END DO
 CLOSE(61)
 
 

av_t_ml_dyns=0.D0
av_t_ml_stars=0.D0
av_t_ml_dyndv=0.D0
av_t_ml_stardv=0.D0
hcount_z=0
DO i=1,n
IF (act_trujillo(i)) THEN
hcount_z=hcount_z+1
av_t_ml_dyns=av_t_ml_dyns+ml_ratio_r_sersic(i)
av_t_ml_stars=av_t_ml_stars+ml_ratio_star_sersic(i)
av_t_ml_dyndv=av_t_ml_dyndv+ml_ratio_r(i)
av_t_ml_stardv=av_t_ml_stardv+ml_ratio_star(i)
END IF
END DO
av_t_ml_dyns=av_t_ml_dyns/DBLE(hcount_z)
av_t_ml_stars=av_t_ml_stars/DBLE(hcount_z)
av_t_ml_dyndv=av_t_ml_dyndv/DBLE(hcount_z)
av_t_ml_stardv=av_t_ml_stardv/DBLE(hcount_z)

sigma_ml_dyn=0.D0
DO i=1,n
IF (act_trujillo(i)) THEN
sigma_ml_dyn=sigma_ml_dyn+(av_t_ml_dyndv-ml_ratio_r(i))**2
END IF
END DO
sigma_ml_dyn=SQRT(sigma_ml_dyn/DBLE(hcount_z))

sigma_ml_star=0.D0
DO i=1,n
IF (act_trujillo(i)) THEN
sigma_ml_star=sigma_ml_star+(av_t_ml_stardv-ml_ratio_star(i))**2
END IF
END DO
sigma_ml_star=SQRT(sigma_ml_star/DBLE(hcount_z))


 OPEN(61,file='output/trujillo_av_ml.txt')
 WRITE(61,*) 'av ml_dyn dv:',av_t_ml_dyndv
  WRITE(61,*) 'av ml_dyn s:',av_t_ml_dyns
   WRITE(61,*) 'av ml_star dv:',av_t_ml_stardv
    WRITE(61,*) 'av ml_star s:',av_t_ml_stars
   WRITE(61,*) 'sigma_ml_dyn dv:',sigma_ml_dyn
    WRITE(61,*) 'sigma_ml_star dv:',sigma_ml_star    
 CLOSE(61)
 
 

av_t_ml_dyns=0.D0
av_t_ml_stars=0.D0
av_t_ml_dyndv=0.D0
av_t_ml_stardv=0.D0
hcount_z=0
DO i=1,n
IF (act_taylor(i)) THEN
hcount_z=hcount_z+1
av_t_ml_dyns=av_t_ml_dyns+ml_ratio_r_sersic(i)
av_t_ml_stars=av_t_ml_stars+ml_ratio_star_sersic(i)
av_t_ml_dyndv=av_t_ml_dyndv+ml_ratio_r(i)
av_t_ml_stardv=av_t_ml_stardv+ml_ratio_star(i)
END IF
END DO
av_t_ml_dyns=av_t_ml_dyns/DBLE(hcount_z)
av_t_ml_stars=av_t_ml_stars/DBLE(hcount_z)
av_t_ml_dyndv=av_t_ml_dyndv/DBLE(hcount_z)
av_t_ml_stardv=av_t_ml_stardv/DBLE(hcount_z)


sigma_ml_dyn=0.D0
DO i=1,n
IF (act_taylor(i)) THEN
sigma_ml_dyn=sigma_ml_dyn+(av_t_ml_dyndv-ml_ratio_r(i))**2
END IF
END DO
sigma_ml_dyn=SQRT(sigma_ml_dyn/DBLE(hcount_z))

sigma_ml_star=0.D0
DO i=1,n
IF (act_taylor(i)) THEN
sigma_ml_star=sigma_ml_star+(av_t_ml_stardv-ml_ratio_star(i))**2
END IF
END DO
sigma_ml_star=SQRT(sigma_ml_star/DBLE(hcount_z))


 OPEN(61,file='output/taylor_av_ml.txt')
 WRITE(61,*) 'av ml_dyn dv:',av_t_ml_dyndv
  WRITE(61,*) 'av ml_dyn s:',av_t_ml_dyns
   WRITE(61,*) 'av ml_star dv:',av_t_ml_stardv
    WRITE(61,*) 'av ml_star s:',av_t_ml_stars
   WRITE(61,*) 'sigma_ml_dyn dv:',sigma_ml_dyn
    WRITE(61,*) 'sigma_ml_star dv:',sigma_ml_star    
 CLOSE(61)
 
 
 
 


OPEN(61,file='output/trujillo_R0_vs_M_dyn.txt')
DO i=1,n
IF (act_trujillo(i)) THEN
WRITE(61,*) log_M_dyn_r(i),logR0_r(i)
END IF
END DO
CLOSE(61)


OPEN(61,file='output/trujillo_R0_sersic_vs_M_dyn_sersic.txt')
DO i=1,n
IF (act_trujillo(i)) THEN
WRITE(61,*) log_M_dyn_r_sersic(i),logR0_r_sersic(i)
END IF
END DO
CLOSE(61)


OPEN(61,file='output/trujillo_lum_vs_M_dyn.txt')
DO i=1,n
IF (act_trujillo(i)) THEN
WRITE(61,*) log_M_dyn_r(i),log_lum_r(i)
END IF
END DO
 CLOSE(61)
 
 
OPEN(61,file='output/trujillo_lum_sersic_vs_M_dyn_sersic.txt')
DO i=1,n
IF (act_trujillo(i)) THEN
WRITE(61,*) log_M_dyn_r_sersic(i),log_lum_r_sersic(i)
END IF
END DO
 CLOSE(61)
 
  
 OPEN(61,file='output/trujillo_mstar_mdyn.txt')
DO i=1,n
IF (act_trujillo(i)) THEN
WRITE(61,*) log_M_dyn_r(i),new_logmstarc(i)
END IF
END DO
 CLOSE(61)

 
   OPEN(61,file='output/trujillo_mstar_mdyn_sersic.txt')
DO i=1,n
IF (act_trujillo(i)) THEN
WRITE(61,*) log_M_dyn_r_sersic(i),new_logmstars(i)
END IF
END DO
 CLOSE(61)
 
 
! 
! av_t_ml_dyns=0.D0
! av_t_ml_stars=0.D0
! av_t_ml_dyndv=0.D0
! av_t_ml_stardv=0.D0
! hcount_z=0
! DO i=1,n
! IF (act_trujillo(i)) THEN
! hcount_z=hcount_z+1
! av_t_ml_dyns=av_t_ml_dyns+ml_ratio_r_sersic(i)
! av_t_ml_stars=av_t_ml_stars+ml_ratio_star_sersic(i)
! av_t_ml_dyndv=av_t_ml_dyndv+ml_ratio_r(i)
! av_t_ml_stardv=av_t_ml_stardv+ml_ratio_star(i)
! END IF
! END DO
! av_t_ml_dyns=av_t_ml_dyns/DBLE(hcount_z)
! av_t_ml_stars=av_t_ml_stars/DBLE(hcount_z)
! av_t_ml_dyndv=av_t_ml_dyndv/DBLE(hcount_z)
! av_t_ml_stardv=av_t_ml_stardv/DBLE(hcount_z)
! 
! 
!  OPEN(61,file='output/trujillo_av_ml.txt')
!  WRITE(61,*) 'av ml_dyn dv:',av_t_ml_dyndv
!   WRITE(61,*) 'av ml_dyn s:',av_t_ml_dyns
!    WRITE(61,*) 'av ml_star dv:',av_t_ml_stardv
!     WRITE(61,*) 'av ml_star s:',av_t_ml_stars
!  CLOSE(61)
!  
!  
!  
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
av_t_ml_dyns=0.D0
av_t_ml_stars=0.D0
av_t_ml_dyndv=0.D0
av_t_ml_stardv=0.D0
hcount_z=0
DO i=1,n
IF (act_dV(i)) THEN
hcount_z=hcount_z+1
av_t_ml_dyns=av_t_ml_dyns+ml_ratio_r_sersic(i)
av_t_ml_stars=av_t_ml_stars+ml_ratio_star_sersic(i)
av_t_ml_dyndv=av_t_ml_dyndv+ml_ratio_r(i)
av_t_ml_stardv=av_t_ml_stardv+ml_ratio_star(i)
END IF
END DO
av_t_ml_dyns=av_t_ml_dyns/DBLE(hcount_z)
av_t_ml_stars=av_t_ml_stars/DBLE(hcount_z)
av_t_ml_dyndv=av_t_ml_dyndv/DBLE(hcount_z)
av_t_ml_stardv=av_t_ml_stardv/DBLE(hcount_z)


sigma_ml_dyn=0.D0
DO i=1,n
IF (act_dV(i)) THEN
sigma_ml_dyn=sigma_ml_dyn+(av_t_ml_dyndv-ml_ratio_r(i))**2
END IF
END DO
sigma_ml_dyn=SQRT(sigma_ml_dyn/DBLE(hcount_z))

sigma_ml_star=0.D0
DO i=1,n
IF (act_dV(i)) THEN
sigma_ml_star=sigma_ml_star+(av_t_ml_stardv-ml_ratio_star(i))**2
END IF
END DO
sigma_ml_star=SQRT(sigma_ml_star/DBLE(hcount_z))


 OPEN(61,file='output/cand_av_ml.txt')
 WRITE(61,*) 'av ml_dyn dv:',av_t_ml_dyndv
  WRITE(61,*) 'av ml_dyn s:',av_t_ml_dyns
   WRITE(61,*) 'av ml_star dv:',av_t_ml_stardv
    WRITE(61,*) 'av ml_star s:',av_t_ml_stars
   WRITE(61,*) 'sigma_ml_dyn dv:',sigma_ml_dyn
    WRITE(61,*) 'sigma_ml_star dv:',sigma_ml_star    
 CLOSE(61)
 
 

 
 av_t_ml_dyns=0.D0
av_t_ml_stars=0.D0
av_t_ml_dyndv=0.D0
av_t_ml_stardv=0.D0
hcount_z=0
DO i=1,n
IF (act_S(i)) THEN
hcount_z=hcount_z+1
av_t_ml_dyns=av_t_ml_dyns+ml_ratio_r_sersic(i)
av_t_ml_stars=av_t_ml_stars+ml_ratio_star_sersic(i)
av_t_ml_dyndv=av_t_ml_dyndv+ml_ratio_r(i)
av_t_ml_stardv=av_t_ml_stardv+ml_ratio_star(i)
END IF
END DO
av_t_ml_dyns=av_t_ml_dyns/DBLE(hcount_z)
av_t_ml_stars=av_t_ml_stars/DBLE(hcount_z)
av_t_ml_dyndv=av_t_ml_dyndv/DBLE(hcount_z)
av_t_ml_stardv=av_t_ml_stardv/DBLE(hcount_z)


sigma_ml_dyn=0.D0
DO i=1,n
IF (act_S(i)) THEN
sigma_ml_dyn=sigma_ml_dyn+(av_t_ml_dyndv-ml_ratio_r(i))**2
END IF
END DO
sigma_ml_dyn=SQRT(sigma_ml_dyn/DBLE(hcount_z))

sigma_ml_star=0.D0
DO i=1,n
IF (act_S(i)) THEN
sigma_ml_star=sigma_ml_star+(av_t_ml_stardv-ml_ratio_star(i))**2
END IF
END DO
sigma_ml_star=SQRT(sigma_ml_star/DBLE(hcount_z))


 OPEN(61,file='output/cand_av_ml_S.txt')
 WRITE(61,*) 'av ml_dyn dv:',av_t_ml_dyndv
  WRITE(61,*) 'av ml_dyn s:',av_t_ml_dyns
   WRITE(61,*) 'av ml_star dv:',av_t_ml_stardv
    WRITE(61,*) 'av ml_star s:',av_t_ml_stars
   WRITE(61,*) 'sigma_ml_dyn dv:',sigma_ml_dyn
    WRITE(61,*) 'sigma_ml_star dv:',sigma_ml_star    
 CLOSE(61)
 
 

DO i=1,n 
act_crossmatchtaylor(i)=.FALSE.
END DO
  
DO i=1,n 
IF (act_taylor(i)) THEN
IF (act(i)) THEN
act_crossmatchtaylor(i)=.TRUE.
END IF
END IF
END DO
 

  
DO i=1,n 
act_crossmatchtrujillo(i)=.FALSE.
END DO
  
DO i=1,n 
IF (act_trujillo(i)) THEN
IF (act(i)) THEN
act_crossmatchtrujillo(i)=.TRUE.
END IF
END IF
END DO
 

 

n_hetngs=0
  ! get length of file
OPEN(51,file='input/vdbosch2015.txt')
io_err=0
n_hetngs=0
DO WHILE (io_err==0) 
READ(51,*,iostat=io_err) 
n_hetngs=n_hetngs+1
END DO
 CLOSE(51)
n_hetngs=n_hetngs-2 !header


allocate(hetngs_ra(1:n_hetngs))
allocate(hetngs_dec(1:n_hetngs))

OPEN(50,file='input/vdbosch2015.txt')
READ(50,*) 
DO i=1,n_hetngs
READ(50,*) hetngs_ra(i),hetngs_dec(i),dummy_var,dummy_var,dummy_var
END DO
 CLOSE(50)

 DO i=1,n
act_vdbosch15(i)=.FALSE.
act_vdbosch15_basic(i)=.FALSE.
END DO


hcount=0

DO i=1,n
IF (act_dV(i)) THEN
DO ii=1,n_hetngs

angular_sep=COS(dec(i)*PI/180.D0)*COS(hetngs_dec(ii)*PI/180.D0)*COS((hetngs_ra(ii)-RA(i))*PI/180.D0)
angular_sep=angular_sep+SIN(dec(i)*PI/180.D0)*SIN(hetngs_dec(ii)*PI/180.D0)
angular_sep=ACOS(angular_sep)*180.D0/PI

IF (angular_sep<0.D0) THEN
angular_sep=-angular_sep
END IF
 
 
 IF (angular_sep<(2.D0*arcsec)) THEN
hcount=hcount+1
act_vdbosch15(i)=.TRUE.
 END IF

END DO
END IF
END DO

 WRITE(*,*) hcount

 
 hcount=0

DO i=1,n
IF (act_old(i)) THEN
DO ii=1,n_hetngs

angular_sep=COS(dec(i)*PI/180.D0)*COS(hetngs_dec(ii)*PI/180.D0)*COS((hetngs_ra(ii)-RA(i))*PI/180.D0)
angular_sep=angular_sep+SIN(dec(i)*PI/180.D0)*SIN(hetngs_dec(ii)*PI/180.D0)
angular_sep=ACOS(angular_sep)*180.D0/PI

IF (angular_sep<0.D0) THEN
angular_sep=-angular_sep
END IF
 
 
 IF (angular_sep<(2.D0*arcsec)) THEN
hcount=hcount+1
act_vdbosch15_basic(i)=.TRUE.
 END IF

END DO
END IF
END DO

 WRITE(*,*) hcount
 

! read file
OPEN(50,file='input/ell.txt')
OPEN(51,file='output/cand_id.txt')
READ(50,*) 
WRITE(51,*)  'SDSS ra dec logR0 logsigma logI0 magabs sersic_index'

DO i=1,n 




IF (act(i)) THEN
READ(50,*) read_string,useless_string,useless_string,useless_string,useless_string,&
useless_string,useless_string,useless_string,useless_string,&
useless_string,useless_string,useless_string,useless_string,&
useless_string,useless_string,useless_string,useless_string,&
useless_string,useless_string,useless_string,useless_string,&
useless_string,useless_string,useless_string,useless_string,&
useless_string,useless_string,useless_string,useless_string,&
useless_string,useless_string,useless_string,useless_string






SDSS_id_string=read_string(1:19)
IF (SDSS_id_string=='1237648703523520846') THEN
special_index=i
WRITE(*,*) special_index
END IF 

act_S(special_index)=.TRUE.

WRITE(51,*) SDSS_id_string,RA(i),dec(i),logR0_r(i),logsigma_r(i),logI0_r(i),magabs_r(i),new_sersic_index(i)

ELSE
READ(50,*) read_string,useless_string,useless_string,useless_string,useless_string,&
useless_string,useless_string,useless_string,useless_string,&
useless_string,useless_string,useless_string,useless_string,&
useless_string,useless_string,useless_string,useless_string,&
useless_string,useless_string,useless_string,useless_string,&
useless_string,useless_string,useless_string,useless_string,&
useless_string,useless_string,useless_string,useless_string,&
useless_string,useless_string,useless_string,useless_string






SDSS_id_string=read_string(1:19)
IF (SDSS_id_string=='1237648703523520846') THEN
special_index=i
WRITE(*,*) special_index
END IF 

666 FORMAT(F10.4)
667 FORMAT(F8.2)


END IF
END DO
 CLOSE(51)
 CLOSE(50)
 uuu=0
 OPEN(51,file='output/download_images.sh')
WRITE(51,*)  '#!/bin/bash'
DO i=1,n 
IF (act_dv(i)) THEN
uuu=uuu+1
dummy_var=12.D0*deVRad_r(i)/500.D0
IF (dummy_var<0.01D0) THEN
dummy_var=0.01D0
END IF
WRITE(hs1,666) RA(i)
WRITE(hs2,666) dec(i)
WRITE(hs3,666) dummy_var
WRITE(hs4,*) uuu
hs4=TRIM(adjustl(hs4))
WRITE(51,*)  'wget -O '//TRIM(hs4)//'.jpeg "http://skyservice.pha.jhu.edu/DR12/ImgCutout/getjpeg.aspx?ra=',&
hs1,'&dec=',hs2,'&scale=',hs3,'&width=500&height=500&opt=G"'
END IF
END DO

uuu=0
DO i=1,n 
IF (act_dv(i)) THEN
uuu=uuu+1
WRITE(hs4,*) uuu
hs4=TRIM(adjustl(hs4))
WRITE(51,*) 'convert '//TRIM(hs4)//'.jpeg  eps2:g'//TRIM(hs4)//'.eps'
END IF 
END DO

 CLOSE(51)

 
 
OPEN(51,file='output/cand_radec.txt')
DO i=1,n 
IF (act(i)) THEN
WRITE(51,*) RA(i),dec(i)
END IF
END DO
 CLOSE(51)

!  

 
 
 
 OPEN(56,file='output/vdbosch2015_crossmatch.txt')
 
 uuu=0
! read file
OPEN(50,file='input/ell.txt')
OPEN(51,file='output/latex_list_basics_dV.txt')
READ(50,*) 


WRITE(51,*)  ' \afterpage{\onecolumn'
WRITE(51,*)  '\begin{landscape}'
WRITE(51,*)  '\centering'
WRITE(51,*)  '  \bottomcaption{}'
WRITE(51,*) '\tablehead{internal ID & SDSS DR10 ID & ra & dec & $z$ & $m_{\textrm{sdss},r}$ &',&
'$a_{\textrm{sdss}}$ & $\sigma_{\textrm{sdss}}$ & $q_{b/a}$ & $\mathcal{L}_{\textrm{ETG}}$\\ '
WRITE(51,*) ' &  & [$^{\circ}$]&  [$^{\circ}$]&   & [mag] & [arcsec] & [km/s] & & \\ \hline }'
WRITE(51,*) '\begin{supertabular}{cccccccccc}'


DO i=1,n 
IF (act_dV(i)) THEN
READ(50,*) read_string,useless_string,useless_string,useless_string,useless_string,&
useless_string,useless_string,useless_string,useless_string,&
useless_string,useless_string,useless_string,useless_string,&
useless_string,useless_string,useless_string,useless_string,&
useless_string,useless_string,useless_string,useless_string,&
useless_string,useless_string,useless_string,useless_string,&
useless_string,useless_string,useless_string,useless_string,&
useless_string,useless_string,useless_string,useless_string

SDSS_id_string=read_string(1:19)
uuu=uuu+1

 

  WRITE(hs1,666) RA(i)
  WRITE(hs2,666) dec(i)
  WRITE(hs3,666) z_cor(i)
  WRITE(hs4,667) deVMag_r(i)
  WRITE(hs5,667) deVMagErr_r(i)
  WRITE(hs6,667) deVRad_r(i)
  WRITE(hs7,667) deVRadErr_r(i)  
  WRITE(hs8,*) NINT(veldisp(i)) 
  WRITE(hs9,*) NINT(veldisperr(i))   
  WRITE(hs10,667) ba_r(i) 
  WRITE(hs11,667) zoo_el(i)   


!   hs14=''
!   hs14='B'
!   IF (act_S(i)) THEN
!  hs14=TRIM(adjustl(hs14))//' S$_{\textrm{S}}$' 
!   END IF
!    IF (act_dV(i)) THEN
!  hs14=TRIM(adjustl(hs14))//' S$_{\textrm{dV}}$' 
!   END IF
!   IF ((act_dV(i)).AND.(act_S(i))) THEN
!  hs14=TRIM(adjustl(hs14))//' G' 
!   END IF  
!   IF (act_crossmatchtaylor(i)) THEN
!  hs14=TRIM(adjustl(hs14))//' T' 
!   END IF

!   hs14,hs15,hs16,hs17,hs18'&',TRIM(adjustl(hs14))
  
WRITE(51,*) uuu,'&',SDSS_id_string,'&',hs1,'&',hs2,'&',hs3,'&',hs4,'$\pm$',hs5,&
'&',hs6,'$\pm$',hs7,'&',hs8,'$\pm$',hs9,'&',hs10,'&',hs11,'\\'

IF (act_vdbosch15(i)) THEN
WRITE(56,*) uuu,SDSS_id_string
END IF

ELSE
READ(50,*) 
END IF
END DO

WRITE(51,*) '\end{supertabular}'
WRITE(51,*) '\label{list_candiates_basics_dV}'
WRITE(51,*) ' \twocolumn'
WRITE(51,*) '\end{landscape}}'




 CLOSE(51)
 CLOSE(50)
 CLOSE(56)
 
 
 
 

 
 uuu=0
! read file
OPEN(50,file='input/ell.txt')
OPEN(51,file='output/latex_list_basics_S.txt')
READ(50,*) 


WRITE(51,*)  ' \afterpage{\onecolumn'
WRITE(51,*)  '\begin{landscape}'
WRITE(51,*)  '\centering'
WRITE(51,*)  '  \bottomcaption{}'
WRITE(51,*) '\tablehead{Sersic ID & SDSS DR10 ID & ra & dec & $z$ & $m_{\textrm{S},r}$ &',&
'$a_{\textrm{S}}$ & $\sigma_{\textrm{sdss}}$ & $n_{S}$ & $\mathcal{L}_{\textrm{ETG}}$ \\ '
WRITE(51,*) ' &  & [$^{\circ}$]&  [$^{\circ}$]&   & [mag] & [arcsec] & [km/s] & & \\ \hline}'
WRITE(51,*) '\begin{supertabular}{cccccccccc}'


DO i=1,n 
IF (act_S(i)) THEN
READ(50,*) read_string,useless_string,useless_string,useless_string,useless_string,&
useless_string,useless_string,useless_string,useless_string,&
useless_string,useless_string,useless_string,useless_string,&
useless_string,useless_string,useless_string,useless_string,&
useless_string,useless_string,useless_string,useless_string,&
useless_string,useless_string,useless_string,useless_string,&
useless_string,useless_string,useless_string,useless_string,&
useless_string,useless_string,useless_string,useless_string

SDSS_id_string=read_string(1:19)
uuu=uuu+1

 

  WRITE(hs1,666) RA(i)
  WRITE(hs2,666) dec(i)
  WRITE(hs3,666) z_cor(i)
  WRITE(hs4,667) new_mag_r_sersic(i)
  WRITE(hs5,667) new_mag_r_err_sersic(i)
  WRITE(hs6,667) rac_r_sersic(i)
  WRITE(hs7,667) deVRadErr_r(i)  
  WRITE(hs8,*) NINT(veldisp(i)) 
  WRITE(hs9,*) NINT(veldisperr(i))   
  WRITE(hs10,667) new_sersic_index(i) 
  WRITE(hs11,667) new_sersic_err_index(i) 
  WRITE(hs12,667) zoo_el(i)  

!   hs14=''
!   hs14='B'
!   IF (act_S(i)) THEN
!  hs14=TRIM(adjustl(hs14))//' S$_{\textrm{S}}$' 
!   END IF
!    IF (act_dV(i)) THEN
!  hs14=TRIM(adjustl(hs14))//' S$_{\textrm{dV}}$' 
!   END IF
!   IF ((act_dV(i)).AND.(act_S(i))) THEN
!  hs14=TRIM(adjustl(hs14))//' G' 
!   END IF  
!   IF (act_crossmatchtaylor(i)) THEN
!  hs14=TRIM(adjustl(hs14))//' T' 
!   END IF

!   hs14,hs15,hs16,hs17,hs18'&',TRIM(adjustl(hs14))
  
WRITE(51,*) uuu,'&',SDSS_id_string,'&',hs1,'&',hs2,'&',hs3,'&',hs4,'$\pm$',hs5,&
'&',hs6,'$\pm$',hs7,'&',hs8,'$\pm$',hs9,'&',hs10,'$\pm$',hs11,'&',hs12,'\\'


ELSE
READ(50,*) 
END IF
END DO

WRITE(51,*) '\end{supertabular}'
WRITE(51,*) '\label{list_candiates_basics_S}'
WRITE(51,*) ' \twocolumn'
WRITE(51,*) '\end{landscape}}'




 CLOSE(51)
 CLOSE(50)
 
 
 
 
 
 
 

 
 uuu=0
! read file
OPEN(50,file='input/ell.txt')
OPEN(51,file='output/latex_list_basics_T.txt')
READ(50,*) 


WRITE(51,*)  ' \afterpage{\onecolumn'
WRITE(51,*)  '\begin{landscape}'
WRITE(51,*)  '\centering'
WRITE(51,*)  '  \bottomcaption{}'
WRITE(51,*) '\tablehead{Taylor ID & SDSS DR10 ID & ra & dec & $z$ & $m_{\textrm{sdss},r}$ &',&
'$a_{\textrm{sdss}}$ & $\sigma_{\textrm{sdss}}$ & $q_{b/a}$ & $\mathcal{L}_{\textrm{ETG}}$\\ '
WRITE(51,*) ' &  & [$^{\circ}$]&  [$^{\circ}$]&   & [mag] & [arcsec] & [km/s] & & \\ \hline }'
WRITE(51,*) '\begin{supertabular}{cccccccccc}'


DO i=1,n 
IF (act_taylor(i)) THEN
READ(50,*) read_string,useless_string,useless_string,useless_string,useless_string,&
useless_string,useless_string,useless_string,useless_string,&
useless_string,useless_string,useless_string,useless_string,&
useless_string,useless_string,useless_string,useless_string,&
useless_string,useless_string,useless_string,useless_string,&
useless_string,useless_string,useless_string,useless_string,&
useless_string,useless_string,useless_string,useless_string,&
useless_string,useless_string,useless_string,useless_string

SDSS_id_string=read_string(1:19)
uuu=uuu+1

 

  WRITE(hs1,666) RA(i)
  WRITE(hs2,666) dec(i)
  WRITE(hs3,666) z_cor(i)
  WRITE(hs4,667) deVMag_r(i)
  WRITE(hs5,667) deVMagErr_r(i)
  WRITE(hs6,667) deVRad_r(i)
  WRITE(hs7,667) deVRadErr_r(i)  
  WRITE(hs8,*) NINT(veldisp(i)) 
  WRITE(hs9,*) NINT(veldisperr(i))   
  WRITE(hs10,667) ba_r(i) 
  WRITE(hs11,667) zoo_el(i)   
  WRITE(hs25,*) taylor_id_sample(i)


  
  
WRITE(51,*) hs25,'&',SDSS_id_string,'&',hs1,'&',hs2,'&',hs3,'&',hs4,'$\pm$',hs5,&
'&',hs6,'$\pm$',hs7,'&',hs8,'$\pm$',hs9,'&',hs10,'&',hs11,'\\'


ELSE
READ(50,*) 
END IF
END DO

WRITE(51,*) '\end{supertabular}'
WRITE(51,*) '\label{list_candiates_basics_T}'
WRITE(51,*) ' \twocolumn'
WRITE(51,*) '\end{landscape}}'




 CLOSE(51)
 CLOSE(50)
 
 
  
 
 
 uuu=0
! read file
OPEN(50,file='input/ell.txt')
OPEN(51,file='output/latex_list_basics_Trujillo.txt')
READ(50,*) 


WRITE(51,*)  ' \afterpage{\onecolumn'
WRITE(51,*)  '\begin{landscape}'
WRITE(51,*)  '\centering'
WRITE(51,*)  '  \bottomcaption{}'
WRITE(51,*) '\tablehead{Trujillo IDNY & SDSS DR10 ID & ra & dec & $z$ & $m_{\textrm{sdss},r}$ &',&
'$a_{\textrm{sdss}}$ & $\sigma_{\textrm{sdss}}$ & $q_{b/a}$ & $\mathcal{L}_{\textrm{ETG}}$\\ '
WRITE(51,*) ' &  & [$^{\circ}$]&  [$^{\circ}$]&   & [mag] & [arcsec] & [km/s] & & \\ \hline }'
WRITE(51,*) '\begin{supertabular}{cccccccccc}'



DO i=1,n 
IF (act_trujillo(i)) THEN
READ(50,*) read_string,useless_string,useless_string,useless_string,useless_string,&
useless_string,useless_string,useless_string,useless_string,&
useless_string,useless_string,useless_string,useless_string,&
useless_string,useless_string,useless_string,useless_string,&
useless_string,useless_string,useless_string,useless_string,&
useless_string,useless_string,useless_string,useless_string,&
useless_string,useless_string,useless_string,useless_string,&
useless_string,useless_string,useless_string,useless_string

SDSS_id_string=read_string(1:19)
uuu=uuu+1

 

  WRITE(hs1,666) RA(i)
  WRITE(hs2,666) dec(i)
  WRITE(hs3,666) z_cor(i)
  WRITE(hs4,667) deVMag_r(i)
  WRITE(hs5,667) deVMagErr_r(i)
  WRITE(hs6,667) deVRad_r(i)
  WRITE(hs7,667) deVRadErr_r(i)  
  WRITE(hs8,*) NINT(veldisp(i)) 
  WRITE(hs9,*) NINT(veldisperr(i))   
  WRITE(hs10,667) ba_r(i) 
  WRITE(hs11,667) zoo_el(i)   
 
  WRITE(hs25,*) trujillo_id_sample(i)

WRITE(51,*) hs25,'&',SDSS_id_string,'&',hs1,'&',hs2,'&',hs3,'&',hs4,'$\pm$',hs5,&
'&',hs6,'$\pm$',hs7,'&',hs8,'$\pm$',hs9,'&',hs10,'&',hs11,'\\'


ELSE
READ(50,*) 
END IF
END DO

WRITE(51,*) '\end{supertabular}'
WRITE(51,*) '\label{list_candiates_basics_trujillo}'
WRITE(51,*) ' \twocolumn'
WRITE(51,*) '\end{landscape}}'




 CLOSE(51)
 CLOSE(50)
 
 
  
 
 
 uuu=0
! read file

OPEN(51,file='output/latex_list_dV.txt')



WRITE(51,*)  ' \afterpage{\onecolumn'
WRITE(51,*)  '\begin{landscape}'
WRITE(51,*)  '\centering'
WRITE(51,*)  '  \bottomcaption{}'
WRITE(51,*) '\tablehead{internal ID & $R_{\textrm{r}}$ & $\sigma_{0}$ & $\mu_{r}$ & $M_{\textrm{r}}$ & ',&
'$(M_{\textrm{g}}-M_{\textrm{r}})$ & $M_{\textrm{z}}$ & log$_{10}$($M_{\textrm{dyn}}$) &  ',&
'log$_{10}$($M_{*}$) & $\vernal_{\textrm{dyn}}$ & $\vernal_{*}$ \\'
WRITE(51,*) ' & [kpc] & [km s$^{-1}$] & [$\frac{\textrm{mag}}{\textrm{arcsec}^{2}}$]  & [mag] & [mag] & [mag] ',&
'& [log$_{10}(M_{\astrosun})$] & [log$_{10}(M_{\astrosun})$] & [$M_{\astrosun}/L_{\astrosun,\textrm{r}}$]',&
'& [$M_{\astrosun}/L_{\astrosun,\textrm{r}}$] \\ \hline }'
WRITE(51,*) '\begin{supertabular}{ccccccccccc}'



DO i=1,n 
IF (act_dV(i)) THEN

uuu=uuu+1

 
  WRITE(hs4,667) R0_r(i)
  WRITE(hs14,667) R_Err_r(i)
  WRITE(hs5,*) NINT(sigma_cor_r(i)) 
  WRITE(hs15,*) NINT(err_sigma_cor_r(i))
  WRITE(hs6,667) (-2.5D0*logI0_r(i)) 
  WRITE(hs16,667) sbm_err_r(i)   
  WRITE(hs7,667) magabs_r(i)  
  WRITE(hs17,667)  magabs_r_err(i)
  WRITE(hs8,667) (magabs_g(i)-magabs_r(i))
  WRITE(hs18,667)  SQRT((magabs_g_err(i)**2)+(magabs_r_err(i)**2))
  WRITE(hs9,667) magabs_z(i)
  WRITE(hs19,667)  magabs_z_err(i)
  WRITE(hs10,667) log_M_dyn_r(i)
!   WRITE(hs20,667) log_M_dyn_r_errp(i)
  WRITE(hs21,667) log_M_dyn_r_errm(i)
  WRITE(hs11,667) new_logmstarc(i)
  WRITE(hs22,667) 0.15D0
  WRITE(hs12,667) ml_ratio_r(i)
  WRITE(hs23,667) ml_ratio_r_err(i)
  WRITE(hs13,667) ml_ratio_star(i)
  WRITE(hs24,667) ml_ratio_star_err(i)

!   hs14,hs15,hs16,hs17,hs18
  
WRITE(51,*) uuu,'&',hs4,'$\pm$',hs14,'&',hs5,'$\pm$',hs15,'&',hs6,'$\pm$',hs16,'&',hs7,'$\pm$',hs17,'&',&
hs8,'$\pm$',hs18,'&',hs9,'$\pm$',hs19,'&',hs10,'$\pm$',hs21,'&',hs11,'$\pm$',hs22,'&',&
hs12,'$\pm$',hs23,'&',hs13,'$\pm$',hs24,'\\'


END IF
END DO

WRITE(51,*) '\end{supertabular}'
WRITE(51,*) '\label{list_candiates_dV}'
WRITE(51,*) ' \twocolumn'
WRITE(51,*) '\end{landscape}}'




 CLOSE(51)

 
 
 
 
 
uuu=0
! read file

OPEN(51,file='output/latex_list_S.txt')


WRITE(51,*)  ' \afterpage{\onecolumn'
WRITE(51,*)  '\begin{landscape}'
WRITE(51,*)  '\centering'
WRITE(51,*)  '  \bottomcaption{}'
WRITE(51,*) '\tablehead{Sersic ID & $R_{\textrm{r}}$ & $\sigma_{0}$ & $\mu_{r}$ & $M_{\textrm{r}}$ & ',&
'$(M_{\textrm{g}}-M_{\textrm{r}})$ &  log$_{10}$($M_{\textrm{dyn}}$) &  log$_{10}$($M_{*}$) &',&
'$\vernal_{\textrm{dyn}}$ & $\vernal_{*}$  \\'
WRITE(51,*) ' & [kpc] &[km s$^{-1}$] & [$\frac{\textrm{mag}}{\textrm{arcsec}^{2}}$] & [mag] & [mag] ',&
'& [log$_{10}(M_{\astrosun})$] & [log$_{10}(M_{\astrosun})$] & [$M_{\astrosun}/L_{\astrosun,\textrm{r}}$]',&
'& [$M_{\astrosun}/L_{\astrosun,\textrm{r}}$] \\ \hline}'
WRITE(51,*) '\begin{supertabular}{cccccccccc}'



DO i=1,n 
IF (act_S(i)) THEN

uuu=uuu+1






  WRITE(hs4,667) R0_r_sersic(i)
  WRITE(hs14,667) R_Err_r(i)
  WRITE(hs5,*) NINT(sigma_r_sersic(i)) 
  WRITE(hs15,*) NINT(err_sigma_r_sersic(i))
  WRITE(hs6,667) (-2.5D0*logI0_r_sersic(i)) 
  WRITE(hs16,667) sb_err_r_sersic(i)   
  WRITE(hs7,667) magabs_r_sersic(i)  
  WRITE(hs17,667)  magabs_sersic_r_err(i)
  WRITE(hs8,667) (magabs_g_sersic(i)-magabs_r_sersic(i))
  WRITE(hs18,667)  SQRT((magabs_sersic_g_err(i)**2)+(magabs_sersic_r_err(i)**2))
  WRITE(hs10,667) log_M_dyn_r_sersic(i)
!   WRITE(hs20,667) log_M_dyn_r_sersic_errp(i)
  WRITE(hs21,667) log_M_dyn_r_sersic_errm(i)
  WRITE(hs11,667) new_logmstars(i)
  WRITE(hs22,667) 0.15D0
  WRITE(hs12,667) ml_ratio_r_sersic(i)
  WRITE(hs23,667) ml_ratio_r_sersic_err(i)
  WRITE(hs13,667) ml_ratio_star_sersic(i)
  WRITE(hs24,667) ml_ratio_star_sersic_err(i)

!   hs14,hs15,hs16,hs17,hs18
  
WRITE(51,*) uuu,'&',hs4,'$\pm$',hs14,'&',hs5,'$\pm$',hs15,'&',hs6,'$\pm$',hs16,'&',hs7,'$\pm$',hs17,'&',&
hs8,'$\pm$',hs18,'&',hs10,'$\pm$',hs21,'&',hs11,'$\pm$',hs22,'&',&
hs12,'$\pm$',hs23,'&',hs13,'$\pm$',hs24,'\\'

 

END IF
END DO

WRITE(51,*) '\end{supertabular}'
WRITE(51,*) '\label{list_candiates_S}'
WRITE(51,*) ' \twocolumn'
WRITE(51,*) '\end{landscape}}'




 CLOSE(51)

 

 uuu=0
! read file

OPEN(51,file='output/latex_list_T.txt')



WRITE(51,*)  ' \afterpage{\onecolumn'
WRITE(51,*)  '\begin{landscape}'
WRITE(51,*)  '\centering'
WRITE(51,*)  '  \bottomcaption{}'
WRITE(51,*) '\tablehead{Taylor ID & $R_{\textrm{r}}$ & $\sigma_{0}$ & $\mu_{r}$ & $M_{\textrm{r}}$ & ',&
'$(M_{\textrm{g}}-M_{\textrm{r}})$ & $M_{\textrm{z}}$ & log$_{10}$($M_{\textrm{dyn}}$) &  ',&
'log$_{10}$($M_{*}$) & $\vernal_{\textrm{dyn}}$ & $\vernal_{*}$ \\'
WRITE(51,*) ' & [kpc] & [km s$^{-1}$] & [$\frac{\textrm{mag}}{\textrm{arcsec}^{2}}$]  & [mag] & [mag] & [mag] ',&
'& [log$_{10}(M_{\astrosun})$] & [log$_{10}(M_{\astrosun})$] & [$M_{\astrosun}/L_{\astrosun,\textrm{r}}$]',&
'& [$M_{\astrosun}/L_{\astrosun,\textrm{r}}$] \\ \hline}'
WRITE(51,*) '\begin{supertabular}{ccccccccccc}'



DO i=1,n 
IF (act_taylor(i)) THEN

uuu=uuu+1

 
  WRITE(hs4,667) R0_r(i)
  WRITE(hs14,667) R_Err_r(i)
  WRITE(hs5,*) NINT(sigma_cor_r(i)) 
  WRITE(hs15,*) NINT(err_sigma_cor_r(i))
  WRITE(hs6,667) (-2.5D0*logI0_r(i)) 
  WRITE(hs16,667) sbm_err_r(i)   
  WRITE(hs7,667) magabs_r(i)  
  WRITE(hs17,667)  magabs_r_err(i)
  WRITE(hs8,667) (magabs_g(i)-magabs_r(i))
  WRITE(hs18,667)  SQRT((magabs_g_err(i)**2)+(magabs_r_err(i)**2))
  WRITE(hs9,667) magabs_z(i)
  WRITE(hs19,667)  magabs_z_err(i)
  WRITE(hs10,667) log_M_dyn_r(i)
!   WRITE(hs20,667) log_M_dyn_r_errp(i)
  WRITE(hs21,667) log_M_dyn_r_errm(i)
  WRITE(hs11,667) new_logmstarc(i)
  WRITE(hs22,667) 0.15D0
  WRITE(hs12,667) ml_ratio_r(i)
  WRITE(hs23,667) ml_ratio_r_err(i)
  WRITE(hs13,667) ml_ratio_star(i)
  WRITE(hs24,667) ml_ratio_star_err(i)
   WRITE(hs25,*) taylor_id_sample(i)

!   hs14,hs15,hs16,hs17,hs18
  
WRITE(51,*) hs25,'&',hs4,'$\pm$',hs14,'&',hs5,'$\pm$',hs15,'&',hs6,'$\pm$',hs16,'&',hs7,'$\pm$',hs17,&
'&',hs8,'$\pm$',hs18,'&',hs9,'$\pm$',hs19,'&',hs10,'$\pm$',hs21,'&',hs11,&
'$\pm$',hs22,'&',hs12,'$\pm$',hs23,'&',hs13,'$\pm$',hs24,'\\'


END IF
END DO

WRITE(51,*) '\end{supertabular}'
WRITE(51,*) '\label{list_candiates_T}'
WRITE(51,*) ' \twocolumn'
WRITE(51,*) '\end{landscape}}'




 CLOSE(51)

 
 

 uuu=0
! read file

OPEN(51,file='output/latex_list_Trujillo.txt')



WRITE(51,*)  ' \afterpage{\onecolumn'
WRITE(51,*)  '\begin{landscape}'
WRITE(51,*)  '\centering'
WRITE(51,*)  '  \bottomcaption{}'
WRITE(51,*) '\tablehead{Trujillo IDNY & $R_{\textrm{r}}$ & $\sigma_{0}$ & $\mu_{r}$ & $M_{\textrm{r}}$ & ',&
'$(M_{\textrm{g}}-M_{\textrm{r}})$ & $M_{\textrm{z}}$ & log$_{10}$($M_{\textrm{dyn}}$) &  ',&
'log$_{10}$($M_{*}$) & $\vernal_{\textrm{dyn}}$ & $\vernal_{*}$ \\'
WRITE(51,*) ' & [kpc] & [km s$^{-1}$] & [$\frac{\textrm{mag}}{\textrm{arcsec}^{2}}$]  & [mag] & [mag] & [mag] ',&
'& [log$_{10}(M_{\astrosun})$] & [log$_{10}(M_{\astrosun})$] & [$M_{\astrosun}/L_{\astrosun,\textrm{r}}$]',&
'& [$M_{\astrosun}/L_{\astrosun,\textrm{r}}$] \\ \hline}'
WRITE(51,*) '\begin{supertabular}{ccccccccccc}'



DO i=1,n 
IF (act_trujillo(i)) THEN

uuu=uuu+1

 
  WRITE(hs4,667) R0_r(i)
  WRITE(hs14,667) R_Err_r(i)
  WRITE(hs5,*) NINT(sigma_cor_r(i)) 
  WRITE(hs15,*) NINT(err_sigma_cor_r(i))
  WRITE(hs6,667) (-2.5D0*logI0_r(i)) 
  WRITE(hs16,667) sbm_err_r(i)   
  WRITE(hs7,667) magabs_r(i)  
  WRITE(hs17,667)  magabs_r_err(i)
  WRITE(hs8,667) (magabs_g(i)-magabs_r(i))
  WRITE(hs18,667)  SQRT((magabs_g_err(i)**2)+(magabs_r_err(i)**2))
  WRITE(hs9,667) magabs_z(i)
  WRITE(hs19,667)  magabs_z_err(i)
  WRITE(hs10,667) log_M_dyn_r(i)
!   WRITE(hs20,667) log_M_dyn_r_errp(i)
  WRITE(hs21,667) log_M_dyn_r_errm(i)
  WRITE(hs11,667) new_logmstarc(i)
  WRITE(hs22,667) 0.15D0
  WRITE(hs12,667) ml_ratio_r(i)
  WRITE(hs23,667) ml_ratio_r_err(i)
  WRITE(hs13,667) ml_ratio_star(i)
  WRITE(hs24,667) ml_ratio_star_err(i)
   WRITE(hs25,*) trujillo_id_sample(i)

!   hs14,hs15,hs16,hs17,hs18
  
WRITE(51,*) hs25,'&',hs4,'$\pm$',hs14,'&',hs5,'$\pm$',hs15,'&',hs6,'$\pm$',hs16,'&',hs7,'$\pm$',hs17,&
'&',hs8,'$\pm$',hs18,'&',hs9,'$\pm$',hs19,'&',hs10,'$\pm$',hs21,'&',hs11,&
'$\pm$',hs22,'&',hs12,'$\pm$',hs23,'&',hs13,'$\pm$',hs24,'\\'


END IF
END DO

WRITE(51,*) '\end{supertabular}'
WRITE(51,*) '\label{list_candiates_trujillo}'
WRITE(51,*) ' \twocolumn'
WRITE(51,*) '\end{landscape}}'




 CLOSE(51)

 
 
uuu=0
u_taylor=0
u_internal=0
u_sersic=0
u_trujillo=0
notlast_round=.true.

! read file
OPEN(50,file='input/ell.txt')
OPEN(51,file='output/latex_ID_crossmatch_side.txt')
READ(50,*) 


WRITE(51,*)  ' \afterpage{\onecolumn'
WRITE(51,*)  '\begin{landscape}'
WRITE(51,*)  '\centering'
WRITE(51,*)  '  \bottomcaption{}'
WRITE(51,*) '\tablehead{SDSS DR10 ID & internal ID & Sersic ID & Taylor ID & Trujillo IDNY & SDSS DR10 ID & internal ID',& 
'& Sersic ID & Taylor ID & Trujillo IDNY \\ \hline}'
WRITE(51,*) '\begin{supertabular}{ccccc|ccccc}'



DO i=1,n 
IF ((act(i)).OR.(act_taylor(i)).OR.(i==n).OR.(act_trujillo(i))) THEN
READ(50,*) read_string,useless_string,useless_string,useless_string,useless_string,&
useless_string,useless_string,useless_string,useless_string,&
useless_string,useless_string,useless_string,useless_string,&
useless_string,useless_string,useless_string,useless_string,&
useless_string,useless_string,useless_string,useless_string,&
useless_string,useless_string,useless_string,useless_string,&
useless_string,useless_string,useless_string,useless_string,&
useless_string,useless_string,useless_string,useless_string

SDSS_id_string=read_string(1:19)
IF ((act(i)).OR.(act_taylor(i)).OR.(act_trujillo(i))) THEN
uuu=uuu+1
else
notlast_round=.false.
END IF

IF (notlast_round) THEN
IF (MOD(uuu,2)==1) THEN
hs1='-'
hs2='-'
hs3='-'
hs4='-'

SDSS_id_string1=SDSS_id_string


IF (act_dV(i)) THEN
u_internal=u_internal+1
   WRITE(hs1,*) u_internal
END IF
   
IF (act_S(i)) THEN
u_sersic=u_sersic+1
   WRITE(hs2,*) u_sersic
END IF

IF (act_taylor(i)) THEN
u_taylor=u_taylor+1
   WRITE(hs3,*) taylor_id_sample(i)
END IF

IF (act_trujillo(i)) THEN
u_trujillo=u_trujillo+1
   WRITE(hs4,*) trujillo_id_sample(i)
END IF
   
END IF



IF (MOD(uuu,2)==0) THEN

hs5='-'
hs6='-'
hs7='-'
hs8='-'

SDSS_id_string2=SDSS_id_string


IF (act_dV(i)) THEN
u_internal=u_internal+1
   WRITE(hs5,*) u_internal
END IF
   
IF (act_S(i)) THEN
u_sersic=u_sersic+1
   WRITE(hs6,*) u_sersic
END IF

IF (act_taylor(i)) THEN
u_taylor=u_taylor+1
   WRITE(hs7,*) taylor_id_sample(i)
END IF

IF (act_trujillo(i)) THEN
u_trujillo=u_trujillo+1
   WRITE(hs8,*) trujillo_id_sample(i)
END IF
   
END IF

! 
! IF (MOD(uuu,3)==0) THEN
! hs7='-'
! hs8='-'
! hs9='-'
! 
! SDSS_id_string3=SDSS_id_string
! 
! 
! IF (act_dV(i)) THEN
! u_internal=u_internal+1
!    WRITE(hs7,*) u_internal
! END IF
!    
! IF (act_S(i)) THEN
! u_sersic=u_sersic+1
!    WRITE(hs8,*) u_sersic
! END IF
! 
! IF (act_taylor(i)) THEN
! u_taylor=u_taylor+1
!    WRITE(hs9,*) taylor_id_sample(i)
! END IF
!    
! END IF
 END IF
!   hs14=''
!   hs14='B'
!   IF (act_S(i)) THEN
!  hs14=TRIM(adjustl(hs14))//' S$_{\textrm{S}}$' 
!   END IF
!    IF (act_dV(i)) THEN
!  hs14=TRIM(adjustl(hs14))//' S$_{\textrm{dV}}$' 
!   END IF
!   IF ((act_dV(i)).AND.(act_S(i))) THEN
!  hs14=TRIM(adjustl(hs14))//' G' 
!   END IF  
!   IF (act_crossmatchtaylor(i)) THEN
!  hs14=TRIM(adjustl(hs14))//' T' 
!   END IF

!   hs14,hs15,hs16,hs17,hs18'&',TRIM(adjustl(hs14))
  IF ((MOD(uuu,2)==0).OR.(i==n)) THEN
WRITE(51,*) SDSS_id_string1,'&',hs1,'&',hs2,'&',hs3,'&',hs4,'&',SDSS_id_string2,'&',hs5,'&',hs6,'&',hs7,'&',hs8,'\\'
SDSS_id_string1=''
SDSS_id_string2=''

hs1=''
hs2=''
hs3=''
hs4=''
hs5=''
hs6=''
hs7=''
hs8=''

END IF

ELSE
READ(50,*) 
END IF
END DO

WRITE(51,*) '\end{supertabular}'
WRITE(51,*) '\label{ID_crossmatches}'
WRITE(51,*) ' \twocolumn'
WRITE(51,*) '\end{landscape}}'


 CLOSE(51)
 CLOSE(50)
 
 
  
!  
!  
!  
! uuu=0
! u_taylor=0
! u_internal=0
! u_sersic=0
! u_trujillo=0
! 
! ! read file
! OPEN(50,file='input/ell.txt')
! OPEN(51,file='output/latex_ID_crossmatch_trujillo.txt')
! READ(50,*) 
! 
! 
! WRITE(51,*)  ' \begin{table*}'
! WRITE(51,*)  '      \centering'
! WRITE(51,*) '\begin{tabular}{ccccc}'
! WRITE(51,*) 'SDSS DR10 ID & internal ID & Sersic ID & Taylor ID & Trujillo ID \\ \hline'
! 
! 
! DO i=1,n 
! IF ((act(i)).OR.(act_taylor(i)).OR.(act_trujillo(i))) THEN
! READ(50,*) read_string,useless_string,useless_string,useless_string,useless_string,&
! useless_string,useless_string,useless_string,useless_string,&
! useless_string,useless_string,useless_string,useless_string,&
! useless_string,useless_string,useless_string,useless_string,&
! useless_string,useless_string,useless_string,useless_string,&
! useless_string,useless_string,useless_string,useless_string,&
! useless_string,useless_string,useless_string,useless_string,&
! useless_string,useless_string,useless_string,useless_string
! 
! SDSS_id_string=read_string(1:19)
! uuu=uuu+1
! 
! hs1='-'
! hs2='-'
! hs3='-'
! hs4='-'
! 
! 
! 
! IF (act_dV(i)) THEN
! u_internal=u_internal+1
!    WRITE(hs1,*) u_internal
! END IF
!    
! IF (act_S(i)) THEN
! u_sersic=u_sersic+1
!    WRITE(hs2,*) u_sersic
! END IF
! 
! IF (act_taylor(i)) THEN
! u_taylor=u_taylor+1
!    WRITE(hs3,*) taylor_id_sample(i)
! END IF
!    
! IF (act_trujillo(i)) THEN
! u_trujillo=u_trujillo+1
!    WRITE(hs4,*) trujillo_id_sample(i)
! END IF
!    
! !   hs14=''
! !   hs14='B'
! !   IF (act_S(i)) THEN
! !  hs14=TRIM(adjustl(hs14))//' S$_{\textrm{S}}$' 
! !   END IF
! !    IF (act_dV(i)) THEN
! !  hs14=TRIM(adjustl(hs14))//' S$_{\textrm{dV}}$' 
! !   END IF
! !   IF ((act_dV(i)).AND.(act_S(i))) THEN
! !  hs14=TRIM(adjustl(hs14))//' G' 
! !   END IF  
! !   IF (act_crossmatchtaylor(i)) THEN
! !  hs14=TRIM(adjustl(hs14))//' T' 
! !   END IF
! 
! !   hs14,hs15,hs16,hs17,hs18'&',TRIM(adjustl(hs14))
!   
! WRITE(51,*) SDSS_id_string,'&',hs1,'&',hs2,'&',hs3,'&',hs4,'\\'
! 
! 
! ELSE
! READ(50,*) 
! END IF
! END DO
! 
! WRITE(51,*) '\end{tabular}'
! WRITE(51,*) '\caption{}'
! WRITE(51,*) '\label{ID_crossmatches}'
! WRITE(51,*) '\end{table*}'
! 
! 
! 
!  CLOSE(51)
!  CLOSE(50)
!  
!  
!   
!   
!  
!  
!  
 
 
 
 
 
 
 

OPEN(61,file='output/special_galaxy_magdist.txt')
WRITE(61,*) logdistlum(special_index),magabs_r(special_index)
CLOSE(61)

OPEN(61,file='output/special_galaxy_magdist_sersic.txt')
WRITE(61,*) logdistlum(special_index),magabs_r_sersic(special_index)
CLOSE(61)

OPEN(61,file='output/special_galaxy_CMD.txt')
WRITE(61,*) magabs_z(special_index),(Mag_app_g(special_index)-Mag_app_r(special_index))
CLOSE(61)



OPEN(61,file='output/special_galaxy_FP.txt')
WRITE(61,*) logR0_r(special_index),otherside_r(special_index)
CLOSE(61)

OPEN(61,file='output/special_galaxy_FP_sersic.txt')
WRITE(61,*) logR0_r_sersic(special_index),sotherside_r(special_index)
CLOSE(61)

OPEN(61,file='output/special_galaxy_Rsigma.txt')
WRITE(61,*) logR0_r(special_index),logsigma_r(special_index)
CLOSE(61)

OPEN(61,file='output/special_galaxy_Rsigma_sersic.txt')
WRITE(61,*) logR0_r_sersic(special_index),logsigma_r_sersic(special_index)
CLOSE(61)





OPEN(61,file='output/special_R0_vs_M_dyn.txt')
WRITE(61,*) log_M_dyn_r(special_index),logR0_r(special_index)
CLOSE(61)

OPEN(61,file='output/special_R0_vs_M_dyn_sersic.txt')
WRITE(61,*) log_M_dyn_r_sersic(special_index),logR0_r_sersic(special_index)
CLOSE(61)


OPEN(61,file='output/special_lum_vs_M_dyn.txt')
WRITE(61,*) log_M_dyn_r(special_index),log_lum_r(special_index)
 CLOSE(61)

OPEN(61,file='output/special_lum_vs_M_dyn_sersic.txt')
WRITE(61,*) log_M_dyn_r_sersic(special_index),log_lum_r_sersic(special_index)
 CLOSE(61)


OPEN(61,file='output/special_mag_R0.txt')
WRITE(61,*) magabs_r(special_index),logR0_r(special_index)
 CLOSE(61)

OPEN(61,file='output/special_mag_R0_sersic.txt')
WRITE(61,*) magabs_r_sersic(special_index),logR0_r_sersic(special_index)
 CLOSE(61)

 
  OPEN(61,file='output/special_mstar_mdyn_dV.txt')
WRITE(61,*) log_M_dyn_r(special_index),new_logmstarc(special_index)
 CLOSE(61)

  OPEN(61,file='output/special_mstar_mdyn_S.txt')
WRITE(61,*) log_M_dyn_r_sersic(special_index),new_logmstars(special_index)
 CLOSE(61)

 
 
  OPEN(61,file='output/special_sigma_mstar_mdyn_dV.txt')
WRITE(61,*) logsigma_r(special_index),(log_M_dyn_r(special_index)-new_logmstarc(special_index))
 CLOSE(61)

  OPEN(61,file='output/special_sigma_mstar_mdyn_S.txt')
WRITE(61,*) logsigma_r_sersic(special_index),(log_M_dyn_r_sersic(special_index)-new_logmstars(special_index))
 CLOSE(61)

 
 
  
 OPEN(61,file='output/special_mstar_R0_dV.txt')
WRITE(61,*) new_logmstarc(special_index),logR0_r(special_index)
 CLOSE(61)

  OPEN(61,file='output/special_mstar_R0_S.txt')
WRITE(61,*) new_logmstars(special_index),logR0_r_sersic(special_index)
 CLOSE(61)

 
 
 
OPEN(61,file='output/special_sigma_ML_dyn_dV.txt')
WRITE(61,*) logsigma_r(special_index),ml_ratio_r(special_index)
 CLOSE(61)



 OPEN(61,file='output/special_sigma_ML_dyn_S.txt')
WRITE(61,*) logsigma_r_sersic(special_index),ml_ratio_r_sersic(special_index)
 CLOSE(61)


 OPEN(61,file='output/special_sigma_ML_star_dV.txt')
WRITE(61,*) logsigma_r(special_index),ml_ratio_star(special_index)
 CLOSE(61)


 OPEN(61,file='output/special_sigma_ML_star_S.txt')
WRITE(61,*) logsigma_r_sersic(special_index),ml_ratio_star_sersic(special_index)
 CLOSE(61)

 
  
 OPEN(61,file='output/special_colour_MLstar_dV.txt')
WRITE(61,*) (Mag_app_g(special_index)-Mag_app_r(special_index)),ml_ratio_star(special_index)
 CLOSE(61)
 
 
  OPEN(61,file='output/special_colour_MLstar_S.txt')
WRITE(61,*) (Mag_app_g_sersic(special_index)-Mag_app_r_sersic(special_index)),ml_ratio_star_sersic(special_index)
 CLOSE(61)

   OPEN(61,file='output/special_z_vs_size.txt')
WRITE(61,*) z_cor(special_index),logR0_r(special_index)
 CLOSE(61)

 
WRITE(*,*) 'final output written'
WRITE(30,*) 'final output written'




!  
   ! get length of file
OPEN(51,file='input/belli2014.txt')
io_err=0
n_belli2014=0
DO WHILE (io_err==0) 
READ(51,*,iostat=io_err) 
n_belli2014=n_belli2014+1
END DO
 CLOSE(51)
n_belli2014=n_belli2014-2 !header


  ! get length of file
OPEN(51,file='input/vdsande2013.txt')
io_err=0
n_vdsande2013=0
DO WHILE (io_err==0) 
READ(51,*,iostat=io_err) 
n_vdsande2013=n_vdsande2013+1
END DO
 CLOSE(51)
n_vdsande2013=n_vdsande2013-2 !header


  ! get length of file
OPEN(51,file='input/taylor2010.txt')
io_err=0
n_taylor2010=0
DO WHILE (io_err==0) 
READ(51,*,iostat=io_err) 
n_taylor2010=n_taylor2010+1
END DO
 CLOSE(51)
n_taylor2010=n_taylor2010-2 !header


 ! get length of file
OPEN(51,file='input/trujillo2009.txt')
io_err=0
n_trujillo2009=0
DO WHILE (io_err==0) 
READ(51,*,iostat=io_err) 
n_trujillo2009=n_trujillo2009+1
END DO
 CLOSE(51)
n_trujillo2009=n_trujillo2009-2 !header


   ! get length of file
OPEN(51,file='input/vanDokkum2008.txt')
io_err=0
n_vdokkum2008=0
DO WHILE (io_err==0) 
READ(51,*,iostat=io_err) 
n_vdokkum2008=n_vdokkum2008+1
END DO
 CLOSE(51)
n_vdokkum2008=n_vdokkum2008-2 

   ! get length of file
OPEN(51,file='input/damjanov2009.txt')
io_err=0
d=0
DO WHILE (io_err==0) 
READ(51,*,iostat=io_err) 
d=d+1
END DO
 CLOSE(51)
d=d-2 

   ! get length of file
OPEN(51,file='input/vdBosch2012.txt')
io_err=0
n_vdBosch2012=0
DO WHILE (io_err==0) 
READ(51,*,iostat=io_err) 
n_vdBosch2012=n_vdBosch2012+1
END DO
 CLOSE(51)
n_vdBosch2012=n_vdBosch2012-2 

    ! get length of file
OPEN(51,file='input/zahid2015.txt')
io_err=0
n_zahid2015=0
DO WHILE (io_err==0) 
READ(51,*,iostat=io_err) 
n_zahid2015=n_zahid2015+1
END DO
 CLOSE(51)
n_zahid2015=n_zahid2015-2 

 
allocate(reff_zahid2015(1:n_zahid2015))
allocate(sigma_zahid2015(1:n_zahid2015))
allocate(z_zahid2015(1:n_zahid2015))
allocate(mstar_zahid2015(1:n_zahid2015))
allocate(mdyn_zahid2015(1:n_zahid2015))
  
allocate(mstar_taylor2010(1:n_taylor2010))
allocate(reff_taylor2010(1:n_taylor2010))

allocate(mstar_trujillo2009(1:n_trujillo2009))
allocate(reff_trujillo2009(1:n_trujillo2009))

allocate(mstar_vdokkum2008(1:n_vdokkum2008))
allocate(reff_vdokkum2008(1:n_vdokkum2008))

allocate(mstar_damjanov2009(1:d))
allocate(reff_damjanov2009(1:d))

allocate(vdisp_taylor2010(1:n_taylor2010))

allocate(mstar_vdbosch2012(1:n_vdBosch2012))
allocate(reff_vdbosch2012(1:n_vdBosch2012))
allocate(veldisp_vdbosch2012(1:n_vdBosch2012))
allocate(ell_vdbosch2012(1:n_vdBosch2012))
allocate(mdyn_vdbosch2012(1:n_vdBosch2012))
allocate(rcor_vdbosch2012(1:n_vdBosch2012))

allocate(z_damjanov2009(1:d))
allocate(z_vdokkum2008(1:n_vdokkum2008))
allocate(z_trujillo2009(1:n_trujillo2009))
allocate(z_taylor2010(1:n_taylor2010))
allocate(z_vdbosch2012(1:n_vdBosch2012))

allocate(z_sande13(1:n_vdsande2013))
allocate(Re_sande13(1:n_vdsande2013))
allocate(sigma_sande13(1:n_vdsande2013))
allocate(ns_sande13(1:n_vdsande2013))
allocate(ba_sande13(1:n_vdsande2013))
allocate(logmdyn_sande13(1:n_vdsande2013))
allocate(logmstar_sande13(1:n_vdsande2013))

allocate(z_belli14(1:n_belli2014))
allocate(Re_belli14(1:n_belli2014))
allocate(sigma_belli14(1:n_belli2014))
allocate(ns_belli14(1:n_belli2014))
allocate(ba_belli14(1:n_belli2014))
allocate(logmdyn_belli14(1:n_belli2014))
allocate(logmstar_belli14(1:n_belli2014))



!  
   ! get length of file
OPEN(50,file='input/belli2014.txt')
READ(50,*) 
DO i=1,n_belli2014
READ(50,*) dummy_var,dummy_var,z_belli14(i),sigma_belli14(i),dummy_var,Re_belli14(i),&
ns_belli14(i),ba_belli14(i),logmstar_belli14(i),dummy_var,logmdyn_belli14(i),dummy_var
END DO
 CLOSE(50)

  ! get length of file
OPEN(50,file='input/vdsande2013.txt')
READ(50,*) 
DO i=1,n_vdsande2013
READ(50,*) dummy_var,z_sande13(i),Re_sande13(i),dummy_var,ns_sande13(i),dummy_var,ba_sande13(i),dummy_var,&
sigma_sande13(i),dummy_var,dummy_var,dummy_var,dummy_var,logmdyn_sande13(i),dummy_var,dummy_var,logmstar_sande13(i)
END DO
 CLOSE(50)



OPEN(50,file='input/zahid2015.txt')
READ(50,*) 
! WRITE(*,*) 
DO i=1,n_zahid2015
READ(50,*) z_zahid2015(i),sigma_zahid2015(i),reff_zahid2015(i),dummy_var,mstar_zahid2015(i),dummy_var,dummy_var
END DO

 CLOSE(50)



OPEN(50,file='input/taylor2010.txt')
READ(50,*) 
! WRITE(*,*) 
DO i=1,n_taylor2010
READ(50,*) dummy_var,dummy_var,z_taylor2010(i),dummy_var,dummy_var,mstar_taylor2010(i),&
dummy_var,dummy_var,dummy_var,reff_taylor2010(i),vdisp_taylor2010(i),dummy_var,dummy_var
! WRITE(*,*) mstar_taylor2010(i),reff_taylor2010(i)
END DO

 CLOSE(50)


OPEN(50,file='input/trujillo2009.txt')
READ(50,*) 
! WRITE(*,*) 
DO i=1,n_trujillo2009
READ(50,*) dummy_var,dummy_var,dummy_var,mstar_trujillo2009(i),reff_trujillo2009(i),z_trujillo2009(i)
! WRITE(*,*) mstar_trujillo2009(i),reff_trujillo2009(i)
END DO

 CLOSE(50)


OPEN(50,file='input/vanDokkum2008.txt')
READ(50,*) 
! WRITE(*,*) 
DO i=1,n_vdokkum2008
READ(50,*) z_vdokkum2008(i),reff_vdokkum2008(i),dummy_var,dummy_var,dummy_var,dummy_var,dummy_var,mstar_vdokkum2008(i)
! WRITE(*,*) mstar_vdokkum2008(i),reff_vdokkum2008(i)
END DO

 CLOSE(50)
 

OPEN(50,file='input/damjanov2009.txt')
READ(50,*) 
! WRITE(*,*) 
DO i=1,d
READ(50,*) z_damjanov2009(i),mstar_damjanov2009(i),dummy_var,reff_damjanov2009(i)
! WRITE(*,*) mstar_damjanov2009(i),reff_damjanov2009(i)
END DO

 CLOSE(50)

 
 OPEN(50,file='input/vdBosch2012.txt')
READ(50,*) 
! WRITE(*,*) 
DO i=1,n_vdBosch2012
READ(50,*) z_vdbosch2012(i),veldisp_vdbosch2012(i),dummy_var,reff_vdbosch2012(i),&
dummy_var,ell_vdbosch2012(i),mstar_vdbosch2012(i)

END DO

 CLOSE(50)
! 


 DO i=1,n_zahid2015
 mdyn_zahid2015(i)=(sigma_zahid2015(i)**2)*reff_zahid2015(i)*5.D0/G
 mdyn_zahid2015(i)=LOG10(mdyn_zahid2015(i)) 
 reff_zahid2015(i)=LOG10(reff_zahid2015(i))
 sigma_zahid2015(i)=LOG10(sigma_zahid2015(i))
 END DO

 DO i=1,n_vdBosch2012
mstar_vdbosch2012(i)=LOG10(mstar_vdbosch2012(i)*1.D11)
rcor_vdbosch2012(i)=reff_vdbosch2012(i)!*SQRT(1.D0-ell_vdbosch2012(i))
reff_vdbosch2012(i)=LOG10(rcor_vdbosch2012(i))
z_vdbosch2012(i)=z_vdbosch2012(i)*H0/light
END DO

DO i=1,n_taylor2010
mstar_taylor2010(i)=mstar_taylor2010(i)
reff_taylor2010(i)=LOG10(reff_taylor2010(i))
END DO
 
DO i=1,n_trujillo2009
mstar_trujillo2009(i)=LOG10(mstar_trujillo2009(i)*1.D10)
reff_trujillo2009(i)=LOG10(reff_trujillo2009(i))
END DO
 
DO i=1,n_vdokkum2008
mstar_vdokkum2008(i)=LOG10(mstar_vdokkum2008(i)*1.D11)
reff_vdokkum2008(i)=LOG10(reff_vdokkum2008(i))
END DO
 
DO i=1,d
mstar_damjanov2009(i)=LOG10(mstar_damjanov2009(i)*1.D11)
reff_damjanov2009(i)=LOG10(reff_damjanov2009(i))
END DO

DO i=1,n_vdsande2013
sigma_sande13(i)=LOG10(sigma_sande13(i))
Re_sande13(i)=LOG10(Re_sande13(i))
END DO

DO i=1,n_belli2014
sigma_belli14(i)=LOG10(sigma_belli14(i))
re_belli14(i)=LOG10(re_belli14(i))
END DO

OPEN(50,file='output/vdsande2013_plot.txt')
DO i=1,n_vdsande2013
WRITE(50,*) logmstar_sande13(i),Re_sande13(i)
END DO
 CLOSE(50)
 
 OPEN(50,file='output/belli2014_plot.txt')
DO i=1,n_belli2014
WRITE(50,*) logmstar_belli14(i),re_belli14(i)
END DO
 CLOSE(50)

 OPEN(50,file='output/vdsande2013_mdyn.txt')
DO i=1,n_vdsande2013
WRITE(50,*) logmdyn_sande13(i),Re_sande13(i)
END DO
 CLOSE(50)
 
 OPEN(50,file='output/belli2014_mdyn.txt')
DO i=1,n_belli2014
WRITE(50,*) logmdyn_belli14(i),re_belli14(i)
END DO
 CLOSE(50)
 
OPEN(50,file='output/vdsande2013_mdyn_mstar.txt')
DO i=1,n_vdsande2013
WRITE(50,*) logmdyn_sande13(i),logmstar_sande13(i)
END DO
 CLOSE(50)
 
 OPEN(50,file='output/belli2014_mdyn_mstar.txt')
DO i=1,n_belli2014
WRITE(50,*) logmdyn_belli14(i),logmstar_belli14(i)
END DO
 CLOSE(50)
 
  OPEN(50,file='output/zahid2015_mdyn_mstar.txt')
DO i=1,n_zahid2015
WRITE(50,*) mdyn_zahid2015(i),mstar_zahid2015(i)
END DO
 CLOSE(50)

 OPEN(50,file='output/vdsande2013_r_sigma.txt')
DO i=1,n_vdsande2013
WRITE(50,*) Re_sande13(i),sigma_sande13(i)
END DO
 CLOSE(50)
 
 OPEN(50,file='output/belli2014_r_sigma.txt')
DO i=1,n_belli2014
WRITE(50,*) re_belli14(i),sigma_belli14(i)
END DO
 CLOSE(50)
 
  OPEN(50,file='output/zahid2015_r_sigma.txt')
DO i=1,n_zahid2015
WRITE(50,*) reff_zahid2015(i),sigma_zahid2015(i)
END DO
 CLOSE(50)
 
 
  OPEN(50,file='output/vdsande2013_sigma_mratio.txt')
DO i=1,n_vdsande2013
WRITE(50,*) sigma_sande13(i),(logmdyn_sande13(i)-logmstar_sande13(i))
END DO
 CLOSE(50)
 
 OPEN(50,file='output/belli2014_sigma_mratio.txt')
DO i=1,n_belli2014
WRITE(50,*)  sigma_belli14(i),(logmdyn_belli14(i)-logmstar_belli14(i))
END DO
 CLOSE(50)
 
  OPEN(50,file='output/zahid2015_sigma_mratio.txt')
DO i=1,n_zahid2015
WRITE(50,*)  sigma_zahid2015(i),(mdyn_zahid2015(i)-mstar_zahid2015(i))
END DO
 CLOSE(50)
 
 
 OPEN(50,file='output/vdsande2013_z_dist.txt')
DO i=1,n_vdsande2013
WRITE(50,*) z_sande13(i),Re_sande13(i)
END DO
 CLOSE(50)
 
 OPEN(50,file='output/belli2014_z_dist.txt')
DO i=1,n_belli2014
WRITE(50,*) z_belli14(i),re_belli14(i)
END DO
 CLOSE(50)

  OPEN(50,file='output/vdsande2013_z_dist_range.txt')
DO i=1,n_vdsande2013
IF (logmstar_sande13(i)>10.75D0) THEN
IF (logmstar_sande13(i)<11.25D0) THEN
WRITE(50,*) z_sande13(i),Re_sande13(i)
END IF
END IF
END DO
 CLOSE(50)
 
 OPEN(50,file='output/belli2014_z_dist_range.txt')
DO i=1,n_belli2014
IF (logmstar_belli14(i)>10.75D0) THEN
IF (logmstar_belli14(i)<11.25D0) THEN
WRITE(50,*) z_belli14(i),re_belli14(i)
END IF
END IF
END DO
 CLOSE(50)
 
 
 DO i=0,8
sersic_index_bin(i)=0.D0
END DO

DO i=1,n_vdsande2013
DO ii=0,8
binhelp=DBLE(ii)
IF ((ns_sande13(i)>(binhelp-0.5)).AND.(ns_sande13(i)<(binhelp+0.5))) THEN
sersic_index_bin(ii)=sersic_index_bin(ii)+1.D0
END IF
END DO
END DO


DO i=0,8
sersic_index_bin(i)=sersic_index_bin(i)/DBLE(n_vdsande2013)
END DO


OPEN(70,file='output/sersic_sande2013.txt')
DO i=0,8
binhelp=DBLE(i)
WRITE(70,*) binhelp,sersic_index_bin(i)
END DO
 CLOSE (70)

  DO i=0,8
sersic_index_bin(i)=0.D0
END DO

DO i=1,n_belli2014
DO ii=0,8
binhelp=DBLE(ii)
IF ((ns_belli14(i)>(binhelp-0.5)).AND.(ns_belli14(i)<(binhelp+0.5))) THEN
sersic_index_bin(ii)=sersic_index_bin(ii)+1.D0
END IF
END DO
END DO


DO i=0,8
sersic_index_bin(i)=sersic_index_bin(i)/DBLE(n_vdsande2013)
END DO


OPEN(70,file='output/sersic_belli2014.txt')
DO i=0,8
binhelp=DBLE(i)
WRITE(70,*) binhelp,sersic_index_bin(i)
END DO
 CLOSE (70)

 

DO i=0,10
ba_ratio_all(i)=0.D0
END DO

DO i=1,n_vdsande2013
DO ii=1,10
IF ((ba_sande13(i).GE.(DBLE(ii-1)/10.D0)).AND.(ba_sande13(i).LE.(DBLE(ii)/10.D0))) THEN
ba_ratio_all(ii)=ba_ratio_all(ii)+1.D0
END IF
END DO
END DO


DO i=1,10
ba_ratio_all(i)=ba_ratio_all(i)/DBLE(n_vdsande2013)
END DO



OPEN(80,file='output/bin_ba_ratios_sande2013.txt')
DO i=1,10
WRITE(80,*) ((DBLE(i)/10.D0)-0.05D0),ba_ratio_all(i)
END DO
CLOSE(80)


DO i=0,10
ba_ratio_all(i)=0.D0
END DO

DO i=1,n_belli2014
DO ii=1,10
IF ((ba_belli14(i).GE.(DBLE(ii-1)/10.D0)).AND.(ba_belli14(i).LE.(DBLE(ii)/10.D0))) THEN
ba_ratio_all(ii)=ba_ratio_all(ii)+1.D0
END IF
END DO
END DO


DO i=1,10
ba_ratio_all(i)=ba_ratio_all(i)/DBLE(n_belli2014)
END DO



OPEN(80,file='output/bin_ba_ratios_belli2014.txt')
DO i=1,10
WRITE(80,*) ((DBLE(i)/10.D0)-0.05D0),ba_ratio_all(i)
END DO
CLOSE(80)





OPEN(50,file='output/vdBosch2012_plot.txt')

DO i=1,n_vdBosch2012
WRITE(50,*) mstar_vdbosch2012(i),reff_vdbosch2012(i)
END DO

 CLOSE(50)

OPEN(50,file='output/zahid2015_plot.txt')

DO i=1,n_zahid2015
WRITE(50,*) mstar_zahid2015(i),reff_zahid2015(i)
END DO

 CLOSE(50)


OPEN(50,file='output/taylor2010_plot.txt')

DO i=1,n_taylor2010
WRITE(50,*) mstar_taylor2010(i),reff_taylor2010(i)
END DO

 CLOSE(50)


OPEN(50,file='output/trujillo2009_plot.txt')

DO i=1,n_trujillo2009
WRITE(50,*) mstar_trujillo2009(i),reff_trujillo2009(i)
END DO

 CLOSE(50)


OPEN(50,file='output/vanDokkum2008_plot.txt')

DO i=1,n_vdokkum2008
WRITE(50,*) mstar_vdokkum2008(i),reff_vdokkum2008(i)
END DO

 CLOSE(50)
 

OPEN(50,file='output/damjanov2009_plot.txt')

DO i=1,d
WRITE(50,*) mstar_damjanov2009(i),reff_damjanov2009(i)
END DO

 CLOSE(50)
 
 
 
 

 
 
OPEN(50,file='output/vdBosch2012_z_vs_size.txt')

DO i=1,n_vdBosch2012
WRITE(50,*) z_vdbosch2012(i),reff_vdbosch2012(i)
END DO

 CLOSE(50)

  OPEN(50,file='output/zahid2015_z_vs_size.txt')

DO i=1,n_zahid2015
WRITE(50,*) z_zahid2015(i),reff_zahid2015(i)
END DO

 CLOSE(50)
 


OPEN(50,file='output/taylor2010_z_vs_size.txt')

DO i=1,n_taylor2010
WRITE(50,*) z_taylor2010(i),reff_taylor2010(i)
END DO

 CLOSE(50)


OPEN(50,file='output/trujillo2009_z_vs_size.txt')

DO i=1,n_trujillo2009
WRITE(50,*) z_trujillo2009(i),reff_trujillo2009(i)
END DO

 CLOSE(50)


OPEN(50,file='output/vanDokkum2008_z_vs_size.txt')

DO i=1,n_vdokkum2008
WRITE(50,*) z_vdokkum2008(i),reff_vdokkum2008(i)
END DO

 CLOSE(50)
 
 
 
 
  OPEN(50,file='output/zahid2015_z_vs_size_range.txt')

DO i=1,n_zahid2015
IF (mstar_zahid2015(i)>10.75D0) THEN
IF (mstar_zahid2015(i)<11.25D0) THEN
WRITE(50,*) z_zahid2015(i),reff_zahid2015(i)
END IF
END IF
END DO

 CLOSE(50)
 


OPEN(50,file='output/taylor2010_z_vs_size_range.txt')

DO i=1,n_taylor2010
IF (mstar_taylor2010(i)>10.75D0) THEN
IF (mstar_taylor2010(i)<11.25D0) THEN
WRITE(50,*) z_taylor2010(i),reff_taylor2010(i)
END IF
END IF
END DO

 CLOSE(50)


OPEN(50,file='output/trujillo2009_z_vs_size_range.txt')

DO i=1,n_trujillo2009
IF (mstar_trujillo2009(i)>10.75D0) THEN
IF (mstar_trujillo2009(i)<11.25D0) THEN
WRITE(50,*) z_trujillo2009(i),reff_trujillo2009(i)
END IF
END IF
END DO

 CLOSE(50)


OPEN(50,file='output/vanDokkum2008_z_vs_size_range.txt')

DO i=1,n_vdokkum2008
IF (mstar_vdokkum2008(i)>10.75D0) THEN
IF (mstar_vdokkum2008(i)<11.25D0) THEN
WRITE(50,*) z_vdokkum2008(i),reff_vdokkum2008(i)
END IF
END IF
END DO

 CLOSE(50)
 
 OPEN(50,file='output/damjanov2009_z_vs_size_range.txt')

DO i=1,d
IF (mstar_damjanov2009(i)>10.75D0) THEN
IF (mstar_damjanov2009(i)<11.25D0) THEN
WRITE(50,*) z_damjanov2009(i),reff_damjanov2009(i)
END IF
END IF
END DO

 CLOSE(50)

OPEN(50,file='output/damjanov2009_z_vs_size.txt')

DO i=1,d
WRITE(50,*) z_damjanov2009(i),reff_damjanov2009(i)
END DO

 CLOSE(50)
 
 
 
 OPEN(50,file='output/zahid2015_Mdyn.txt')

DO i=1,n_zahid2015
WRITE(50,*) mdyn_zahid2015(i),reff_zahid2015(i)
END DO

 CLOSE(50)

 
 
 
 OPEN(50,file='output/candels_m1075_16limits.txt')
DO i=1,6
WRITE(50,*) candels_z(i),candels_m1075(i)
END DO
 CLOSE(50)
 
  OPEN(50,file='output/candels_m1125_16limits.txt')
DO i=2,6
WRITE(50,*) candels_z(i),candels_m1125(i)
END DO
 CLOSE(50)
 
 
 
 
 
WRITE(*,*) 'other samples calibrated'
WRITE(30,*) 'other samples calibrated'


 delta_R0_rz=0.D0
 delta_R0_ri=0.D0
 log_delta_R0_rz=0.D0
 log_delta_R0_ri=0.D0
 av_RO_r=0.D0
 av_logR0_r=0.D0
 iii=0
DO i=1,n
IF (act_dV(i)) THEN
iii=iii+1
av_RO_r=av_RO_r+R0_r(i)
av_logR0_r=av_logR0_r+logR0_r(i)
delta_R0_rz=delta_R0_rz+(R0_z(i)-R0_r(i))
delta_R0_ri=delta_R0_ri+(R0_i(i)-R0_r(i))
log_delta_R0_rz=log_delta_R0_rz+(logR0_z(i)-logR0_r(i))
log_delta_R0_ri=log_delta_R0_ri+(logR0_i(i)-logR0_r(i))
END IF
END DO
delta_R0_rz=delta_R0_rz/DBLE(iii)
delta_R0_ri=delta_R0_ri/DBLE(iii)
log_delta_R0_rz=log_delta_R0_rz/DBLE(iii)
log_delta_R0_ri=log_delta_R0_ri/DBLE(iii)
av_RO_r=av_RO_r/DBLE(iii)
av_logR0_r=av_logR0_r/DBLE(iii)

OPEN(50,file='output/delta_R0_riz.txt')

WRITE(50,*) delta_R0_rz,delta_R0_ri,'av:',av_RO_r
WRITE(50,*) log_delta_R0_rz,log_delta_R0_ri,'av:',av_logR0_r

 CLOSE(50)
 
 DO ii=1,n_allearly
DO iii=1,n_allearly
IF (rad_r_allearly(ii)<rad_r_allearly(iii)) THEN
dummy_var=rad_r_allearly(ii)
rad_r_allearly(ii)=rad_r_allearly(iii)
rad_r_allearly(iii)=dummy_var
END IF
END DO
END DO

n_3sigma=NINT(0.3D0*DBLE(n_allearly)/100.D0/2.D0)
ang_min=rad_r_allearly(n_3sigma)
! WRITE(*,*) rad_r_allearly(n_3sigma)
! 
! n_3sigma=NINT(5.D0*DBLE(n_allearly)/100.D0)
! 
! WRITE(*,*) rad_r_allearly(n_3sigma)
 
n_act=iii
sdss_cover=9274.D0/41253.D0
allocate(visvolume(1:n_act))
! ang_min=0.8D0

 iii=0
DO i=1,n
IF (act_dV(i)) THEN
iii=iii+1

dang_max=d_com(i)*deVRad_r(i)/ang_min

D_limit=dist_k_r*magabs_r(i)+dist_d_r
D_limit=10.D0**D_limit
D_limit=D_limit/1.D6


t1=(light**2)*q0-(light**2)
t2=(light**4)*(q0**2)-2.D0*(light**4)*q0+(light**4)+2.D0*(light**3)*D_limit*H0*(q0**2)
t2=t2-4.D0*(light**3)*D_limit*H0*q0+2.D0*(light**3)*D_limit*H0
t2=SQRT(t2)
t3=light*D_limit*H0*q0

z_limit=1/(light**2)*(t1+t2+t3)

IF (z_limit>zmax) THEN
z_limit=zmax
divisor=(SQRT(1.D0+2.D0*q0*z_limit)+1.D0+q0*z_limit)
D_limit=light/H0*z_limit*(1.D0+((z_limit*(1.D0-q0))/divisor))
END IF


D_limit=D_limit*((1.D0+z_limit)**(-1.D0))!comoving diameter distance

IF (D_limit>dang_max) THEN
! WRITE(*,*) D_limit,dang_max,iii
D_limit=dang_max
END IF


Dmin=dist_k_r*magabs_r(i)+dist_dsat_r
Dmin=10.D0**Dmin
Dmin=Dmin/1.D6

t1=(light**2)*q0-(light**2)
t2=(light**4)*(q0**2)-2.D0*(light**4)*q0+(light**4)+2.D0*(light**3)*Dmin*H0*(q0**2)
t2=t2-4.D0*(light**3)*Dmin*H0*q0+2.D0*(light**3)*Dmin*H0
t2=SQRT(t2)
t3=light*Dmin*H0*q0

z_limit=1/(light**2)*(t1+t2+t3)
Dmin=Dmin*((1.D0+z_limit)**(-1.D0))!comoving diameter distance

Vminsat=(Dmin**3)

IF (Vminsat<Vmin) THEN
Vminsat=Vmin
END IF

V_limit=(D_limit**3)-Vminsat

visvolume(iii)=1.D0/(V_limit*sdss_cover*4.D0*PI/3.D0)





END IF 
END DO





density_trujillo=0.D0
density_taylor=0.D0
density_damjanov=0.D0


i_d=0
i_tr=0
i_ta=0
 iii=0
DO i=1,n
IF (act_dV(i)) THEN
iii=iii+1

IF (M_dyn_r(i)>8.D10) THEN
IF (R0_r(i)<2.D0) THEN
density_damjanov=density_damjanov+visvolume(iii)
i_d=i_d+1
END IF
END IF

IF (M_star(i)>8.D10) THEN
IF (R0_z(i)<1.5D0) THEN
density_trujillo=density_trujillo+visvolume(iii)
i_tr=i_tr+1
END IF
END IF

IF (new_logmstarc(i)>10.7D0) THEN
density_taylor=density_taylor+visvolume(iii)
i_ta=i_ta+1
END IF

END IF
END DO



OPEN(50,file='output/spacedensity_compare.txt')

WRITE(50,*) 'Damjanov:',density_damjanov,'galaxies/Mpc^3',i_d
WRITE(50,*) 'Taylor:',density_taylor,'galaxies/Mpc^3',i_ta
WRITE(50,*) 'Trujillo:',density_trujillo,'galaxies/Mpc^3',i_tr
 CLOSE(50)








spacedensity=0.D0
DO i=1,n_act
spacedensity=spacedensity+visvolume(i)
END DO



OPEN(50,file='output/spacedensity.txt')

WRITE(50,*) spacedensity,'galaxies/Mpc^3'
WRITE(50,*) ang_min,'arcsec'
 CLOSE(50)



OPEN(50,file='output/limits_redshift_size.txt')

ang_min=ang_min*2.D0*PI/(360.D0*60.D0*60.D0)
ang_min=ang_min*av_cirularisation

DO i=1,50
binhelp=DBLE(i)/100.D0
divisor=(SQRT(1.D0+2.D0*q0*binhelp)+1.D0+q0*binhelp)
!luminosity distance
dummy_var=light/H0*binhelp*(1.D0+((binhelp*(1.D0-q0))/divisor))
dummy_var=dummy_var*1.D3
!angular diameter distance
dummy_var=dummy_var*((1.D0+binhelp)**(-2.D0))
! WRITE(*,*) dummy_var


dummy_var=TAN(ang_min)*dummy_var
IF (dummy_var>0.D0) THEN
dummy_var=LOG10(dummy_var)
WRITE(50,*)   binhelp,dummy_var
END IF

END DO

 CLOSE(50)





IF (ttmdyn_on==1) THEN
WRITE(*,*) 'start calculation of additional dynamical masses'
WRITE(30,*)'start calculation of additional dynamical masses'
! get length of file
OPEN(50,file='input/all_spect.txt')
io_err=0
n_spect=0
DO WHILE (io_err==0) 
READ(50,*,iostat=io_err) 
n_spect=n_spect+1
END DO
 CLOSE(50)
n_spect=n_spect-2 !header


allocate(spect_objid(1:n_spect))
allocate(spect_RA(1:n_spect))
allocate(spect_dec(1:n_spect))
allocate(spect_z(1:n_spect))
allocate(spect_veldisp(1:n_spect))
allocate(spect_zErr(1:n_spect))
allocate(spect_veldisperr(1:n_spect))

allocate(taylor_veldisp(1:n_taylor2010))
allocate(taylor_Mdyn(1:n_taylor2010))
allocate(trujillo_veldisp(1:n_trujillo2009))
allocate(trujillo_Mdyn(1:n_trujillo2009))



! read file
OPEN(50,file='input/all_spect.txt')
READ(50,*) 
DO i=1,n_spect 
READ(50,*) spect_objid(i),spect_RA(i),spect_dec(i),&
spect_z(i),spect_veldisp(i),spect_zErr(i),spect_veldisperr(i)
END DO
 CLOSE(50)


WRITE(*,*) n_spect,'galaxies read in'
WRITE(30,*) n_spect,'galaxies read in'



DO ii=1,n_taylor2010
taylor_veldisp(ii)=0.D0
taylor_Mdyn(ii)=0.D0
END DO

DO ii=1,n_trujillo2009
trujillo_veldisp(ii)=0.D0
trujillo_Mdyn(ii)=0.D0
END DO



DO i=1,n_spect 



DO ii=1,n_trujillo2009

angular_sep=COS(spect_dec(i)*PI/180.D0)*COS(trujillo_dec(ii)*PI/180.D0)*COS((trujillo_RA(ii)-spect_RA(i))*PI/180.D0)
angular_sep=angular_sep+SIN(spect_dec(i)*PI/180.D0)*SIN(trujillo_dec(ii)*PI/180.D0)
angular_sep=ACOS(angular_sep)*180.D0/PI
IF (angular_sep<0.D0) THEN
angular_sep=-angular_sep
END IF
 
 
IF (angular_sep<(arcsec)) THEN
trujillo_veldisp(ii)=spect_veldisp(i)
END IF


END DO

END DO





DO ii=1,n_taylor2010
reff_taylor2010(ii)=10.D0**reff_taylor2010(ii)
divisor=(r_fiber/(reff_taylor2010(ii)/8.D0))
taylor_veldisp(ii)=vdisp_taylor2010(ii)*(divisor**0.04D0)

taylor_Mdyn(ii)=(taylor_veldisp(ii)**2)*reff_taylor2010(ii)*5.D0/G

reff_taylor2010(ii)=LOG10(reff_taylor2010(ii))
taylor_Mdyn(ii)=LOG10(taylor_Mdyn(ii))
END DO

DO ii=1,n_trujillo2009
IF (trujillo_veldisp(ii)>0.D0) THEN
reff_trujillo2009(ii)=10.D0**reff_trujillo2009(ii)
divisor=(r_fiber/(reff_trujillo2009(ii)/8.D0))
trujillo_veldisp(ii)=trujillo_veldisp(ii)*(divisor**0.04D0)

trujillo_Mdyn(ii)=(trujillo_veldisp(ii)**2)*reff_trujillo2009(ii)*5.D0/G

reff_trujillo2009(ii)=LOG10(reff_trujillo2009(ii))
trujillo_Mdyn(ii)=LOG10(trujillo_Mdyn(ii))
END IF
END DO

 DO ii=1,n_vdBosch2012
mdyn_vdbosch2012(ii)=(veldisp_vdbosch2012(ii)**2)*rcor_vdbosch2012(ii)*5.D0/G
mdyn_vdbosch2012(ii)=LOG10(mdyn_vdbosch2012(ii))
END DO


OPEN(50,file='output/vdbosch2012_Mdyn.txt')

DO i=1,n_vdbosch2012
WRITE(50,*) mdyn_vdbosch2012(i),reff_vdbosch2012(i)
END DO

 CLOSE(50)

OPEN(50,file='output/taylor2010_Mdyn.txt')

DO i=1,n_taylor2010
WRITE(50,*) taylor_Mdyn(i),reff_taylor2010(i)
END DO

 CLOSE(50)


OPEN(50,file='output/trujillo2009_Mdyn.txt')

DO i=1,n_trujillo2009
IF (trujillo_veldisp(ii)>0.D0) THEN
WRITE(50,*) trujillo_Mdyn(i),reff_trujillo2009(i)
END IF
END DO

 CLOSE(50)
 
 R_lasker=1.9D0

 sigma_lasker=360.3D0
 nser_lasker=6.9
beta=8.87D0-0.831D0*nser_lasker+0.0241D0*(nser_lasker**2) 
  Mdyn_lasker=(sigma_lasker**2)*R_lasker*beta/G
  
  R_lasker=LOG10(R_lasker)
  Mdyn_lasker=LOG10(Mdyn_lasker)
 
 OPEN(50,file='output/lasker2013_Mdyn.txt')

WRITE(50,*) Mdyn_lasker,R_lasker

 CLOSE(50)
 
 
WRITE(*,*) 'dynamical masses for other samples calculated'
WRITE(30,*)'dynamical masses for other samples calculated'

! dummy_var=0.8D0/360.D0/60.D0/60.D0*2.D0*PI
! dummy_var=2.D0/1000.D0/light*H0/dummy_var
! WRITE(*,*) dummy_var
END IF








WRITE(*,*) '-----program finished-----'
WRITE(30,*) '-----program finished-----'
CLOSE(30)

END PROGRAM 
